#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _381
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _730
{
    int _m0;
    int _m1;
};

struct _733
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _403_405
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _405;

layout(set = 0, binding = 0, std140) uniform _416_418
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
} _418;

layout(set = 2, binding = 0, std140) uniform _497_499
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _499;

layout(set = 0, binding = 5, std430) restrict readonly buffer _735_737
{
    _733 _m0[];
} _737;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1350_1352
{
    vec4 _m0[];
} _1352;

layout(push_constant, std430) uniform _1346_1348
{
    int _m0;
    int _m1;
} _1348;

layout(set = 3, binding = 0) uniform texture2D _523[65536];
layout(set = 0, binding = 4) uniform sampler _531;
layout(set = 2, binding = 1) uniform SAMPLER_2D _579;
layout(set = 2, binding = 2) uniform SAMPLER_2D _592;
layout(set = 2, binding = 3) uniform SAMPLER_2D _1066;
layout(set = 2, binding = 4) uniform SAMPLER_2D _1324;
layout(set = 0, binding = 2) uniform sampler3D _1356;
layout(set = 0, binding = 3) uniform sampler3D _1357;

layout(location = 2) in vec4 _395;
layout(location = 6) in vec4 _423;
layout(location = 3) in vec4 _435;
layout(location = 4) in vec4 _438;
layout(location = 5) in vec4 _441;
layout(location = 10) in vec4 _459;
layout(location = 11) in vec4 _463;
layout(location = 12) in vec4 _467;
layout(location = 7) in vec4 _1068;
layout(location = 0) out vec4 _1189;
layout(location = 1) out vec4 _1200;
layout(location = 2) out vec4 _1208;
layout(location = 3) out vec4 _1249;
layout(location = 9) in vec4 _1268;
layout(location = 13) in vec4 _1271;
layout(location = 4) out vec4 _1306;

float _143;

uint _26(float _25)
{
    return floatBitsToUint(_25);
}

float _29(float _28)
{
    if (_28 <= 0.040449999272823333740234375)
    {
        return _28 / 12.9200000762939453125;
    }
    else
    {
        return pow((_28 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _42(float _41)
{
    float _184 = _41;
    return _29(_184);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _35(vec3 _34)
{
    float _145 = _34.x;
    vec3 _144;
    _144.x = _29(_145);
    float _151 = _34.y;
    _144.y = _29(_151);
    float _157 = _34.z;
    _144.z = _29(_157);
    return _144;
}

vec4 _39(vec4 _38)
{
    vec3 _167 = _38.xyz;
    vec4 _166 = vec4(_35(_167), 1.0);
    float _175 = _38.w;
    _166.w = _29(_175);
    return _166;
}

vec4 _45(vec4 _44)
{
    vec4 _189 = _44;
    return _39(_189);
}

vec4 _70(SAMPLER_2D _68, vec2 _69)
{
    vec4 _219 = SAMPLE_TEXTURE(_68, _69);
    vec4 _223 = _219;
    _219 = _45(_223);
    return _219;
}

float _79(float _75, vec4 _76, float _77, bool _78)
{
    float _229 = _76.w / (_75 + _76.z);
    return _229 * _77;
}

vec3 _84(vec3 _82, bool _83)
{
    vec3 _242 = (_82 * 2.0) - vec3(1.0);
    float _260 = (1.0 - (_242.x * _242.x)) - (_242.y * _242.y);
    _242.z = sqrt(_10(_260));
    if (_83 == false)
    {
        _242.z = -_242.z;
    }
    return _242;
}

vec3 _91(vec3 _89, mat3 _90)
{
    return normalize(vec3(dot(_89, _90[0]), dot(_89, _90[1]), dot(_89, _90[2])));
}

float _51(float _50)
{
    return _50 * _50;
}

vec3 _48(vec3 _47)
{
    return _47 * _47;
}

float _57(float _54, float _55, float _56)
{
    float _211 = (_54 - _55) / (_56 - _55);
    return _10(_211);
}

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

void _14(float _13)
{
    if (_13 < 0.0)
    {
        discard;
    }
}

vec2 _95(vec2 _94)
{
    return (vec2(1.0) - abs(_94.yx)) * vec2((_94.x >= 0.0) ? 1.0 : (-1.0), (_94.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _100(inout vec3 _98, bool _99)
{
    _98 /= vec3((abs(_98.x) + abs(_98.y)) + abs(_98.z));
    vec2 _331;
    if (_98.z >= 0.0)
    {
        _331 = _98.xy;
    }
    else
    {
        vec2 _337 = _98.xy;
        _331 = _95(_337);
    }
    _98 = vec3(_331.x, _331.y, _98.z);
    if (_99)
    {
        vec2 _352 = (_98.xy * 0.5) + vec2(0.5);
        _98 = vec3(_352.x, _352.y, _98.z);
    }
    return _98.xy;
}

float _60(float _59)
{
    return sqrt(_59);
}

float _103(float _102)
{
    float _362 = abs(_102);
    float _359 = _60(_362);
    float _366;
    if (_102 > 0.0)
    {
        _366 = _359;
    }
    else
    {
        _366 = -_359;
    }
    return (_366 * 0.5) + 0.5;
}

void main()
{
    float _378 = 0.0;
    _381 _383 = _381(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _383._m15 = _395;
    _383._m16 = gl_FragCoord;
    _383._m40 = (uint(_405._m15.z) & 3u) << uint(4);
    _383._m14 = _418._m4.xyz + _423.xyz;
    _383._m13 = normalize(-_423.xyz);
    _383._m17 = mat3(vec3(_435.xyz), vec3(_438.xyz), vec3(_441.xyz));
    _383._m34 = _459;
    _383._m35 = _463;
    _383._m36 = _467;
    uint _470 = 0u;
    vec4 _471 = vec4(0.0);
    vec4 _472 = vec4(0.0);
    vec4 _473 = vec4(0.0);
    vec4 _474 = vec4(0.0);
    vec4 _475 = vec4(0.0);
    _383._m0 = _473.xyz;
    _383._m2 = _474.xyz;
    _383._m1 = _472.xyz;
    _383._m9 = _471.xyz;
    _383._m3 = _471.w;
    _383._m6 = _475.wyz;
    _383._m2 = _499._m6.xxx;
    _383._m3 = _499._m6.y;
    _383._m6 = vec3(0.5, 0.5, 1.0);
    if (_418._m16.x == 1.0)
    {
        float _516 = _499._m7.x;
        uint _514 = _26(_516);
        uint _525 = _514;
        float _542 = texture(sampler2D(_523[nonuniformEXT(_525)], _531), _395.xy * _499._m8.xy).x;
        float _547 = _42(_542) * 4.0;
        _378 = _10(_547);
        float _550 = _499._m9.x;
        uint _549 = _26(_550);
        uint _555 = _549;
        vec4 _574 = texture(sampler2D(_523[nonuniformEXT(_555)], _531), vec4(_395.xy, 0.0, -2.0).xy, vec4(_395.xy, 0.0, -2.0).w);
        _383._m0 = _45(_574).xyz;
    }
    else
    {
        vec2 _586 = _395.xy * _499._m8.xy;
        float _590 = _70(_579, _586).x * 4.0;
        _378 = _10(_590);
        vec4 _607 = SAMPLE_TEXTURE1(_592, vec4(_395.xy, 0.0, -2.0).xy, vec4(_395.xy, 0.0, -2.0).w);
        _383._m0 = _45(_607).xyz;
    }
    _383._m11 = 1.0;
    uint _613 = uint((_405._m15.x > 0.0) ? 8 : 0);
    float _619 = 16.0;
    float _621 = 8.0;
    float _623 = 24.0;
    vec2 _632 = _383._m16.xy * _418._m17.xy;
    vec3 _625;
    _625 = vec3(_632.x, _632.y, _625.z);
    _625.y = 1.0 - _625.y;
    vec2 _645 = floor(_625.xy * vec2(_619, _621));
    _625 = vec3(_645.x, _645.y, _625.z);
    float _650 = _383._m16.z;
    vec4 _653 = _418._m18;
    float _656 = 1.0;
    bool _657 = false;
    float _648 = _79(_650, _653, _656, _657);
    float _659 = log2(max(1.0, _648 / _418._m19.z)) * _418._m19.w;
    _625.z = min(_623 - 1.0, floor(_659));
    uint _676 = uint((_625.x + (_625.y * _619)) + ((_625.z * _619) * _621));
    _676 = min(_676, uint(((_619 * _621) * _623) - 1.0));
    bool _701 = true;
    _701 = gl_FrontFacing;
    vec3 _706 = _383._m6;
    bool _709 = _701;
    _383._m7 = _84(_706, _709);
    vec3 _713 = _383._m7;
    mat3 _716 = _383._m17;
    _383._m6 = _91(_713, _716);
    uint _721 = 0u;
    uint _722 = 0u;
    uint _723 = 0u;
    uint _724 = 0u;
    uint _725 = 0u;
    uint _726 = 0u;
    int _728 = 256;
    _730 _732;
    _732._m0 = _737._m0[_676]._m0;
    _732._m1 = _737._m0[_676]._m1;
    int _746 = _732._m0 & (~(_732._m0 >> 31));
    int _755 = _732._m1 & (~(_732._m1 >> 31));
    _721 = uint((_746 >> 16) * _728);
    _722 = _721 + uint(_755 & 255);
    _723 = _721;
    _724 = _723 + uint((_755 >> 8) & 255);
    _725 = _721;
    _726 = _725 + uint((_755 >> 16) & 255);
    float _790 = _383._m37;
    float _788 = _51(_790);
    float _797 = _788 - 0.5;
    float _794 = _10(_797) * 2.0;
    float _809 = _788 * 2.0;
    float _800 = (_383._m38 * _383._m38) * _10(_809);
    float _816 = _800 + _794;
    float _812 = _10(_816);
    if (_812 > 0.0039215688593685626983642578125)
    {
        vec3 _825 = _383._m0;
        float _832 = _812 * 1.0;
        float _833 = 0.0;
        float _834 = 0.3499999940395355224609375;
        _383._m0 = mix(_383._m0, _48(_825), vec3(_57(_832, _833, _834) * (1.0 - _383._m3)));
        float _850 = _812 * 1.0;
        float _851 = 0.25;
        float _852 = 0.5;
        _383._m2 = mix(_383._m2, vec3(0.039999999105930328369140625), vec3(_57(_850, _851, _852)));
        vec3 _857 = vec3(_383._m17[0].z, _383._m17[1].z, _383._m17[2].z);
        float _871 = _857.z + 0.0625;
        float _865 = _812 * _10(_871);
        float _880 = _865 * 1.0;
        float _881 = 0.20000000298023223876953125;
        float _882 = 1.0;
        _383._m3 = mix(_383._m3, 0.89999997615814208984375, _57(_880, _881, _882));
        float _891 = _865 * 1.0;
        float _892 = 0.449999988079071044921875;
        float _893 = 0.980000019073486328125;
        float _886 = _57(_891, _892, _893);
        _383._m6 = normalize(mix(_383._m6, vec3(0.0, 0.0, 1.0), vec3(_886)));
        _383._m7 = mix(_383._m6, vec3(0.5, 0.5, 1.0), vec3(_886));
        if (_865 > 0.980000019073486328125)
        {
            float _916 = _865 * _886;
            float _917 = 0.980000019073486328125;
            float _918 = 1.0;
            _857 = normalize(mix(_857, vec3(0.0, 0.0, 1.0), vec3(_57(_916, _917, _918))));
            _383._m17[0].z = _857.x;
            _383._m17[1].z = _857.y;
            _383._m17[2].z = _857.z;
        }
    }
    vec3 _932 = vec3(0.0);
    vec3 _933 = vec3(_383._m34.x, _383._m34.y, _383._m34.z);
    vec3 _941 = vec3(_383._m34.w, _383._m35.x, _383._m35.y);
    vec3 _949 = vec3(_383._m35.z, _383._m35.w, _383._m36.x);
    vec3 _957 = vec3(_383._m36.y, _383._m36.z, _383._m36.w);
    vec3 _965 = ((_933 - (_941 * _383._m6.y)) + (_949 * _383._m6.z)) - (_957 * _383._m6.x);
    float _989 = _405._m16.x * _418._m20.x;
    _932 += max(_965 * _10(_989), vec3(0.0));
    float _1001;
    if (dot(_383._m10, vec3(1.0)) > 0.0)
    {
        _1001 = -_383._m3;
    }
    else
    {
        _1001 = _383._m3;
    }
    _383._m3 = _1001;
    _383._m18 = _932;
    vec2 _1014 = gl_FragCoord.xy * _418._m17.xy;
    _1014.y = 1.0 - _1014.y;
    vec4 _1025 = vec4((_1014.x * 2.0) - 1.0, (_1014.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _1038;
    _1038.x = dot(_1025, _418._m21);
    _1038.y = dot(_1025, _418._m22);
    _1038.z = dot(_1025, _418._m23);
    _1038 /= vec3(dot(_1025, _418._m24));
    float _1065 = SAMPLE_TEXTURE(_1066, _1068.xy * vec2(_405._m17.w)).y;
    vec4 _1085 = vec4(_405._m13.xyz, 1.0);
    vec4 _1086 = _405._m1;
    vec3 _1077;
    _1077.x = _21(_1085, _1086);
    vec4 _1098 = vec4(_405._m13.xyz, 1.0);
    vec4 _1099 = _405._m2;
    _1077.y = _21(_1098, _1099);
    vec4 _1111 = vec4(_405._m13.xyz, 1.0);
    vec4 _1112 = _405._m3;
    _1077.z = _21(_1111, _1112);
    vec3 _1117 = _1077 - _1038;
    float _1121 = (_1065 * _499._m10.x) + (1.0 - _499._m10.x);
    float _1130 = length(_1117) * _1121;
    vec2 _1135 = vec2(6.666666507720947265625, 10.0);
    float _1139 = _1130 - _405._m14.w;
    float _1149 = _1139 * _1135.x;
    float _1144 = _10(_1149);
    float _1156 = _1139 * _1135.y;
    float _1151 = _10(_1156);
    float _1166 = (1.0 - _1151) * _1065;
    vec3 _1158 = _405._m17.xyz * _10(_1166);
    float _1169 = _1144;
    float _1176 = ceil(_1169 - 0.001000000047497451305389404296875);
    float _1171 = _10(_1176);
    float _1181 = _1171 - 9.9999997473787516355514526367188e-05;
    _14(_1181);
    _383._m19 += _1158;
    vec3 _1197 = (_383._m18 * _383._m0) + _383._m10;
    _1189 = vec4(_1197.x, _1197.y, _1197.z, _1189.w);
    vec3 _1201 = _383._m6;
    bool _1204 = false;
    vec2 _1205 = _100(_1201, _1204);
    _1200 = vec4(_1205.x, _1205.y, _1200.z, _1200.w);
    float _1209 = _383._m2.x;
    float _1213 = _383._m2.y;
    float _1217 = _383._m2.z;
    float _1221 = _383._m3;
    _1208 = vec4(_60(_1209), _60(_1213), _60(_1217), _103(_1221));
    uint _1226 = uint((_405._m15.x > 0.0) ? 8 : 0);
    uint _1232 = uint(int(_1226 > 0u));
    _1232 |= 2u;
    _1232 |= 4u;
    _1232 |= ((uint(_405._m15.z) & 3u) << uint(4));
    float _1250 = _383._m0.x;
    float _1254 = _383._m0.y;
    float _1258 = _383._m0.z;
    _1249 = vec4(_60(_1250), _60(_1254), _60(_1258), float(_1232) / 255.0);
    vec4 _1267 = _1268;
    vec4 _1270 = _1271;
    vec2 _1273 = ((_1267.xy / vec2(_1267.w)) * 0.5) + vec2(0.5);
    vec2 _1283 = ((_1270.xy / vec2(_1270.w)) * 0.5) + vec2(0.5);
    _1273.y = 1.0 - _1273.y;
    _1283.y = 1.0 - _1283.y;
    vec2 _1301 = _418._m25.xy;
    _1306 = vec4((_1273 - _1283) * _1301, 0.0, 1.0);
    vec3 _1320 = _1189.xyz + _405._m18.xyz;
    _1189 = vec4(_1320.x, _1320.y, _1320.z, _1189.w);
    float _1329 = SAMPLE_TEXTURE(_1324, _395.xy).x;
    float _1332 = _499._m6.z;
    float _1337 = mix(1.0, _51(_1329), _10(_1332));
    float _1323 = _10(_1337);
    vec3 _1343 = _1189.xyz * vec3(_1323);
    _1189 = vec4(_1343.x, _1343.y, _1343.z, _1189.w);
}

