#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _381
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _729
{
    int _m0;
    int _m1;
};

struct _732
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _403_405
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _405;

layout(set = 0, binding = 0, std140) uniform _417_419
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _419;

layout(set = 2, binding = 0, std140) uniform _498_500
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _500;

layout(set = 0, binding = 5, std430) restrict readonly buffer _734_736
{
    _732 _m0[];
} _736;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1296_1298
{
    vec4 _m0[];
} _1298;

layout(push_constant, std430) uniform _1292_1294
{
    int _m0;
    int _m1;
} _1294;

layout(set = 3, binding = 0) uniform texture2D _524[65536];
layout(set = 0, binding = 4) uniform sampler _532;
layout(set = 2, binding = 1) uniform SAMPLER_2D _580;
layout(set = 2, binding = 2) uniform SAMPLER_2D _593;
layout(set = 2, binding = 3) uniform SAMPLER_2D _1062;
layout(set = 2, binding = 4) uniform SAMPLER_2D _1270;
layout(set = 0, binding = 2) uniform sampler3D _1302;
layout(set = 0, binding = 3) uniform sampler3D _1303;

layout(location = 2) in vec4 _395;
layout(location = 6) in vec4 _424;
layout(location = 3) in vec4 _436;
layout(location = 4) in vec4 _439;
layout(location = 5) in vec4 _442;
layout(location = 10) in vec4 _460;
layout(location = 11) in vec4 _464;
layout(location = 12) in vec4 _468;
layout(location = 7) in vec4 _1064;
layout(location = 0) out vec4 _1186;
layout(location = 1) out vec4 _1197;
layout(location = 2) out vec4 _1205;
layout(location = 3) out vec4 _1243;

float _143;

uint _26(float _25)
{
    return floatBitsToUint(_25);
}

float _29(float _28)
{
    if (_28 <= 0.040449999272823333740234375)
    {
        return _28 / 12.9200000762939453125;
    }
    else
    {
        return pow((_28 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _42(float _41)
{
    float _184 = _41;
    return _29(_184);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _35(vec3 _34)
{
    float _145 = _34.x;
    vec3 _144;
    _144.x = _29(_145);
    float _151 = _34.y;
    _144.y = _29(_151);
    float _157 = _34.z;
    _144.z = _29(_157);
    return _144;
}

vec4 _39(vec4 _38)
{
    vec3 _167 = _38.xyz;
    vec4 _166 = vec4(_35(_167), 1.0);
    float _175 = _38.w;
    _166.w = _29(_175);
    return _166;
}

vec4 _45(vec4 _44)
{
    vec4 _189 = _44;
    return _39(_189);
}

vec4 _70(SAMPLER_2D _68, vec2 _69)
{
    vec4 _219 = SAMPLE_TEXTURE(_68, _69);
    vec4 _223 = _219;
    _219 = _45(_223);
    return _219;
}

float _79(float _75, vec4 _76, float _77, bool _78)
{
    float _229 = _76.w / (_75 + _76.z);
    return _229 * _77;
}

vec3 _84(vec3 _82, bool _83)
{
    vec3 _242 = (_82 * 2.0) - vec3(1.0);
    float _260 = (1.0 - (_242.x * _242.x)) - (_242.y * _242.y);
    _242.z = sqrt(_10(_260));
    if (_83 == false)
    {
        _242.z = -_242.z;
    }
    return _242;
}

vec3 _91(vec3 _89, mat3 _90)
{
    return normalize(vec3(dot(_89, _90[0]), dot(_89, _90[1]), dot(_89, _90[2])));
}

float _51(float _50)
{
    return _50 * _50;
}

vec3 _48(vec3 _47)
{
    return _47 * _47;
}

float _57(float _54, float _55, float _56)
{
    float _211 = (_54 - _55) / (_56 - _55);
    return _10(_211);
}

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

void _14(float _13)
{
    if (_13 < 0.0)
    {
        discard;
    }
}

vec2 _95(vec2 _94)
{
    return (vec2(1.0) - abs(_94.yx)) * vec2((_94.x >= 0.0) ? 1.0 : (-1.0), (_94.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _100(inout vec3 _98, bool _99)
{
    _98 /= vec3((abs(_98.x) + abs(_98.y)) + abs(_98.z));
    vec2 _331;
    if (_98.z >= 0.0)
    {
        _331 = _98.xy;
    }
    else
    {
        vec2 _337 = _98.xy;
        _331 = _95(_337);
    }
    _98 = vec3(_331.x, _331.y, _98.z);
    if (_99)
    {
        vec2 _352 = (_98.xy * 0.5) + vec2(0.5);
        _98 = vec3(_352.x, _352.y, _98.z);
    }
    return _98.xy;
}

float _60(float _59)
{
    return sqrt(_59);
}

float _103(float _102)
{
    float _362 = abs(_102);
    float _359 = _60(_362);
    float _366;
    if (_102 > 0.0)
    {
        _366 = _359;
    }
    else
    {
        _366 = -_359;
    }
    return (_366 * 0.5) + 0.5;
}

void main()
{
    float _378 = 0.0;
    _381 _383 = _381(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _383._m15 = _395;
    _383._m16 = gl_FragCoord;
    _383._m40 = (uint(_405._m8.z) & 3u) << uint(4);
    _383._m14 = _419._m4.xyz + _424.xyz;
    _383._m13 = normalize(-_424.xyz);
    _383._m17 = mat3(vec3(_436.xyz), vec3(_439.xyz), vec3(_442.xyz));
    _383._m34 = _460;
    _383._m35 = _464;
    _383._m36 = _468;
    uint _471 = 0u;
    vec4 _472 = vec4(0.0);
    vec4 _473 = vec4(0.0);
    vec4 _474 = vec4(0.0);
    vec4 _475 = vec4(0.0);
    vec4 _476 = vec4(0.0);
    _383._m0 = _474.xyz;
    _383._m2 = _475.xyz;
    _383._m1 = _473.xyz;
    _383._m9 = _472.xyz;
    _383._m3 = _472.w;
    _383._m6 = _476.wyz;
    _383._m2 = _500._m4.xxx;
    _383._m3 = _500._m4.y;
    _383._m6 = vec3(0.5, 0.5, 1.0);
    if (_419._m6.x == 1.0)
    {
        float _517 = _500._m5.x;
        uint _515 = _26(_517);
        uint _526 = _515;
        float _542 = texture(sampler2D(_524[nonuniformEXT(_526)], _532), _395.xy * _500._m6.xy).x;
        float _547 = _42(_542) * 4.0;
        _378 = _10(_547);
        float _551 = _500._m7.x;
        uint _549 = _26(_551);
        uint _556 = _549;
        vec4 _575 = texture(sampler2D(_524[nonuniformEXT(_556)], _532), vec4(_395.xy, 0.0, -2.0).xy, vec4(_395.xy, 0.0, -2.0).w);
        _383._m0 = _45(_575).xyz;
    }
    else
    {
        vec2 _587 = _395.xy * _500._m6.xy;
        float _591 = _70(_580, _587).x * 4.0;
        _378 = _10(_591);
        vec4 _608 = SAMPLE_TEXTURE1(_593, vec4(_395.xy, 0.0, -2.0).xy, vec4(_395.xy, 0.0, -2.0).w);
        _383._m0 = _45(_608).xyz;
    }
    _383._m11 = 1.0;
    uint _614 = uint((_405._m8.x > 0.0) ? 8 : 0);
    float _620 = 16.0;
    float _622 = 8.0;
    float _624 = 24.0;
    vec2 _633 = _383._m16.xy * _419._m7.xy;
    vec3 _626;
    _626 = vec3(_633.x, _633.y, _626.z);
    _626.y = 1.0 - _626.y;
    vec2 _646 = floor(_626.xy * vec2(_620, _622));
    _626 = vec3(_646.x, _646.y, _626.z);
    float _650 = _383._m16.z;
    vec4 _653 = _419._m8;
    float _656 = 1.0;
    bool _657 = false;
    float _649 = _79(_650, _653, _656, _657);
    float _659 = log2(max(1.0, _649 / _419._m9.z)) * _419._m9.w;
    _626.z = min(_624 - 1.0, floor(_659));
    uint _675 = uint((_626.x + (_626.y * _620)) + ((_626.z * _620) * _622));
    _675 = min(_675, uint(((_620 * _622) * _624) - 1.0));
    bool _700 = true;
    _700 = gl_FrontFacing;
    vec3 _705 = _383._m6;
    bool _708 = _700;
    _383._m7 = _84(_705, _708);
    vec3 _712 = _383._m7;
    mat3 _715 = _383._m17;
    _383._m6 = _91(_712, _715);
    uint _720 = 0u;
    uint _721 = 0u;
    uint _722 = 0u;
    uint _723 = 0u;
    uint _724 = 0u;
    uint _725 = 0u;
    int _727 = 256;
    _729 _731;
    _731._m0 = _736._m0[_675]._m0;
    _731._m1 = _736._m0[_675]._m1;
    int _745 = _731._m0 & (~(_731._m0 >> 31));
    int _754 = _731._m1 & (~(_731._m1 >> 31));
    _720 = uint((_745 >> 16) * _727);
    _721 = _720 + uint(_754 & 255);
    _722 = _720;
    _723 = _722 + uint((_754 >> 8) & 255);
    _724 = _720;
    _725 = _724 + uint((_754 >> 16) & 255);
    float _789 = _383._m37;
    float _787 = _51(_789);
    float _796 = _787 - 0.5;
    float _793 = _10(_796) * 2.0;
    float _808 = _787 * 2.0;
    float _799 = (_383._m38 * _383._m38) * _10(_808);
    float _815 = _799 + _793;
    float _811 = _10(_815);
    if (_811 > 0.0039215688593685626983642578125)
    {
        vec3 _824 = _383._m0;
        float _831 = _811 * 1.0;
        float _832 = 0.0;
        float _833 = 0.3499999940395355224609375;
        _383._m0 = mix(_383._m0, _48(_824), vec3(_57(_831, _832, _833) * (1.0 - _383._m3)));
        float _849 = _811 * 1.0;
        float _850 = 0.25;
        float _851 = 0.5;
        _383._m2 = mix(_383._m2, vec3(0.039999999105930328369140625), vec3(_57(_849, _850, _851)));
        vec3 _856 = vec3(_383._m17[0].z, _383._m17[1].z, _383._m17[2].z);
        float _870 = _856.z + 0.0625;
        float _864 = _811 * _10(_870);
        float _879 = _864 * 1.0;
        float _880 = 0.20000000298023223876953125;
        float _881 = 1.0;
        _383._m3 = mix(_383._m3, 0.89999997615814208984375, _57(_879, _880, _881));
        float _890 = _864 * 1.0;
        float _891 = 0.449999988079071044921875;
        float _892 = 0.980000019073486328125;
        float _885 = _57(_890, _891, _892);
        _383._m6 = normalize(mix(_383._m6, vec3(0.0, 0.0, 1.0), vec3(_885)));
        _383._m7 = mix(_383._m6, vec3(0.5, 0.5, 1.0), vec3(_885));
        if (_864 > 0.980000019073486328125)
        {
            float _915 = _864 * _885;
            float _916 = 0.980000019073486328125;
            float _917 = 1.0;
            _856 = normalize(mix(_856, vec3(0.0, 0.0, 1.0), vec3(_57(_915, _916, _917))));
            _383._m17[0].z = _856.x;
            _383._m17[1].z = _856.y;
            _383._m17[2].z = _856.z;
        }
    }
    vec3 _931 = vec3(0.0);
    vec3 _932 = vec3(_383._m34.x, _383._m34.y, _383._m34.z);
    vec3 _940 = vec3(_383._m34.w, _383._m35.x, _383._m35.y);
    vec3 _948 = vec3(_383._m35.z, _383._m35.w, _383._m36.x);
    vec3 _956 = vec3(_383._m36.y, _383._m36.z, _383._m36.w);
    vec3 _964 = ((_932 - (_940 * _383._m6.y)) + (_948 * _383._m6.z)) - (_956 * _383._m6.x);
    float _988 = _405._m9.x * _419._m10.x;
    _931 += max(_964 * _10(_988), vec3(0.0));
    float _999;
    if (dot(_383._m10, vec3(1.0)) > 0.0)
    {
        _999 = -_383._m3;
    }
    else
    {
        _999 = _383._m3;
    }
    _383._m3 = _999;
    _383._m18 = _931;
    vec2 _1013 = gl_FragCoord.xy * _419._m7.xy;
    _1013.y = 1.0 - _1013.y;
    vec4 _1024 = vec4((_1013.x * 2.0) - 1.0, (_1013.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _1037;
    _1037.x = dot(_1024, _419._m11);
    _1037.y = dot(_1024, _419._m12);
    _1037.z = dot(_1024, _419._m13);
    _1037 /= vec3(dot(_1024, _419._m14));
    float _1061 = SAMPLE_TEXTURE(_1062, _1064.xy * vec2(_405._m10.w)).y;
    vec4 _1081 = vec4(_405._m6.xyz, 1.0);
    vec4 _1082 = _405._m1;
    vec3 _1073;
    _1073.x = _21(_1081, _1082);
    vec4 _1094 = vec4(_405._m6.xyz, 1.0);
    vec4 _1095 = _405._m2;
    _1073.y = _21(_1094, _1095);
    vec4 _1107 = vec4(_405._m6.xyz, 1.0);
    vec4 _1108 = _405._m3;
    _1073.z = _21(_1107, _1108);
    vec3 _1113 = _1073 - _1037;
    float _1117 = (_1061 * _500._m8.x) + (1.0 - _500._m8.x);
    float _1126 = length(_1113) * _1117;
    vec2 _1131 = vec2(6.666666507720947265625, 10.0);
    float _1135 = _1126 - _405._m7.w;
    float _1145 = _1135 * _1131.x;
    float _1140 = _10(_1145);
    float _1152 = _1135 * _1131.y;
    float _1147 = _10(_1152);
    float _1162 = (1.0 - _1147) * _1061;
    vec3 _1154 = _405._m10.xyz * _10(_1162);
    float _1165 = _1140;
    float _1172 = ceil(_1165 - 0.001000000047497451305389404296875);
    float _1167 = _10(_1172);
    float _1177 = _1167 - 9.9999997473787516355514526367188e-05;
    _14(_1177);
    _383._m19 += _1154;
    vec3 _1194 = (_383._m18 * _383._m0) + _383._m10;
    _1186 = vec4(_1194.x, _1194.y, _1194.z, _1186.w);
    vec3 _1198 = _383._m6;
    bool _1201 = false;
    vec2 _1202 = _100(_1198, _1201);
    _1197 = vec4(_1202.x, _1202.y, _1197.z, _1197.w);
    float _1206 = _383._m2.x;
    float _1210 = _383._m2.y;
    float _1214 = _383._m2.z;
    float _1218 = _383._m3;
    _1205 = vec4(_60(_1206), _60(_1210), _60(_1214), _103(_1218));
    uint _1223 = uint((_405._m8.x > 0.0) ? 8 : 0);
    uint _1229 = uint(int(_1223 > 0u));
    _1229 |= 2u;
    _1229 |= ((uint(_405._m8.z) & 3u) << uint(4));
    float _1244 = _383._m0.x;
    float _1248 = _383._m0.y;
    float _1252 = _383._m0.z;
    _1243 = vec4(_60(_1244), _60(_1248), _60(_1252), float(_1229) / 255.0);
    vec3 _1266 = _1186.xyz + _405._m11.xyz;
    _1186 = vec4(_1266.x, _1266.y, _1266.z, _1186.w);
    float _1275 = SAMPLE_TEXTURE(_1270, _395.xy).x;
    float _1278 = _500._m4.z;
    float _1283 = mix(1.0, _51(_1275), _10(_1278));
    float _1269 = _10(_1283);
    vec3 _1289 = _1186.xyz * vec3(_1269);
    _1186 = vec4(_1289.x, _1289.y, _1289.z, _1186.w);
}

