#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _333
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1106
{
    int _m0;
    int _m1;
};

struct _1109
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _355_357
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    vec4 _m37;
} _357;

layout(set = 0, binding = 0, std140) uniform _369_371
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _371;

layout(set = 2, binding = 0, std140) uniform _473_475
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _475;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1111_1113
{
    _1109 _m0[];
} _1113;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1654_1656
{
    vec4 _m0[];
} _1656;

layout(push_constant, std430) uniform _1650_1652
{
    int _m0;
    int _m1;
} _1652;

layout(set = 3, binding = 0) uniform TEXTURE_2D _502[16384];
layout(set = 0, binding = 5) uniform sampler _510;
layout(set = 3, binding = 2) uniform TEXTURE_2D _520[16384];
layout(set = 0, binding = 6) uniform sampler _525;
layout(set = 3, binding = 1) uniform TEXTURE_2D _536[16384];
layout(set = 0, binding = 7) uniform sampler _541;
layout(set = 3, binding = 3) uniform TEXTURE_2D _550[16384];
layout(set = 0, binding = 8) uniform sampler _555;
layout(set = 3, binding = 5) uniform TEXTURE_2D _564[16384];
layout(set = 0, binding = 9) uniform sampler _569;
layout(set = 3, binding = 7) uniform TEXTURE_2D _578[16384];
layout(set = 0, binding = 10) uniform sampler _583;
layout(set = 3, binding = 4) uniform TEXTURE_2D _592[16384];
layout(set = 0, binding = 11) uniform sampler _597;
layout(set = 3, binding = 6) uniform TEXTURE_2D _606[16384];
layout(set = 0, binding = 12) uniform sampler _611;
layout(set = 1, binding = 1) uniform SAMPLER_2D _913;
layout(set = 1, binding = 2) uniform SAMPLER_2D _918;
layout(set = 1, binding = 3) uniform SAMPLER_2D _1467;
layout(set = 0, binding = 3) uniform sampler3D _1660;
layout(set = 0, binding = 4) uniform sampler3D _1661;

layout(location = 2) in vec4 _347;
layout(location = 6) in vec4 _376;
layout(location = 3) in vec4 _388;
layout(location = 4) in vec4 _391;
layout(location = 5) in vec4 _394;
layout(location = 10) in vec4 _412;
layout(location = 11) in vec4 _416;
layout(location = 12) in vec4 _420;
layout(location = 14) flat in uvec3 _433;
layout(location = 15) in vec4 _436;
layout(location = 8) in vec4 _923;
layout(location = 0) out vec4 _1517;
layout(location = 1) out vec4 _1528;
layout(location = 2) out vec4 _1536;
layout(location = 3) out vec4 _1577;
layout(location = 9) in vec4 _1596;
layout(location = 13) in vec4 _1599;
layout(location = 4) out vec4 _1633;

float _116;

uvec4 _18(vec4 _17)
{
    return floatBitsToUint(_17);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _21(float _20)
{
    if (_20 <= 0.040449999272823333740234375)
    {
        return _20 / 12.9200000762939453125;
    }
    else
    {
        return pow((_20 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _27(vec3 _26)
{
    float _118 = _26.x;
    vec3 _117;
    _117.x = _21(_118);
    float _124 = _26.y;
    _117.y = _21(_124);
    float _130 = _26.z;
    _117.z = _21(_130);
    return _117;
}

vec3 _30(vec3 _29)
{
    vec3 _139 = _29;
    return _27(_139);
}

float _54(float _50, vec4 _51, float _52, bool _53)
{
    float _169 = _51.w / (_50 + _51.z);
    return _169 * _52;
}

vec3 _59(vec3 _57, bool _58)
{
    vec3 _183 = (_57 * 2.0) - vec3(1.0);
    float _201 = (1.0 - (_183.x * _183.x)) - (_183.y * _183.y);
    _183.z = sqrt(_10(_201));
    if (_58 == false)
    {
        _183.z = -_183.z;
    }
    return _183;
}

vec3 _66(vec3 _64, mat3 _65)
{
    return normalize(vec3(dot(_64, _65[0]), dot(_64, _65[1]), dot(_64, _65[2])));
}

vec3 _72(vec3 _69, mat3 _70, bool _71)
{
    vec3 _238 = _69;
    bool _240 = _71;
    vec3 _237 = _59(_238, _240);
    vec3 _243 = _237;
    mat3 _245 = _70;
    return _66(_243, _245);
}

float _36(float _35)
{
    return _35 * _35;
}

vec3 _33(vec3 _32)
{
    return _32 * _32;
}

float _42(float _39, float _40, float _41)
{
    float _161 = (_39 - _40) / (_41 - _40);
    return _10(_161);
}

vec2 _78(vec2 _77)
{
    return (vec2(1.0) - abs(_77.yx)) * vec2((_77.x >= 0.0) ? 1.0 : (-1.0), (_77.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _83(inout vec3 _81, bool _82)
{
    _81 /= vec3((abs(_81.x) + abs(_81.y)) + abs(_81.z));
    vec2 _285;
    if (_81.z >= 0.0)
    {
        _285 = _81.xy;
    }
    else
    {
        vec2 _291 = _81.xy;
        _285 = _78(_291);
    }
    _81 = vec3(_285.x, _285.y, _81.z);
    if (_82)
    {
        vec2 _306 = (_81.xy * 0.5) + vec2(0.5);
        _81 = vec3(_306.x, _306.y, _81.z);
    }
    return _81.xy;
}

float _45(float _44)
{
    return sqrt(_44);
}

float _86(float _85)
{
    float _316 = abs(_85);
    float _313 = _45(_316);
    float _320;
    if (_85 > 0.0)
    {
        _320 = _313;
    }
    else
    {
        _320 = -_313;
    }
    return (_320 * 0.5) + 0.5;
}

void main()
{
    _333 _335 = _333(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _335._m15 = _347;
    _335._m16 = gl_FragCoord;
    _335._m40 = (uint(_357._m33.z) & 3u) << uint(4);
    _335._m14 = _371._m0.xyz + _376.xyz;
    _335._m13 = normalize(-_376.xyz);
    _335._m17 = mat3(vec3(_388.xyz), vec3(_391.xyz), vec3(_394.xyz));
    _335._m34 = _412;
    _335._m35 = _416;
    _335._m36 = _420;
    uint _423 = 0u;
    vec4 _424 = vec4(0.0);
    vec4 _425 = vec4(0.0);
    vec4 _426 = vec4(0.0);
    vec4 _427 = vec4(0.0);
    vec4 _428 = vec4(0.0);
    uvec3 _431 = _433;
    vec3 _435 = _436.xyz;
    bool _443 = _431.y == 65535u;
    bool _449;
    if (_443)
    {
        _449 = _431.z == 65535u;
    }
    else
    {
        _449 = _443;
    }
    bool _439 = _449;
    bool _450 = !_439;
    bool _453 = _431.z != 65535u;
    uint _457 = _431.x & 7u;
    uint _468;
    if (_371._m12.x == 0.0)
    {
        _468 = _457;
    }
    else
    {
        vec4 _477 = _475._m6;
        uvec4 _472 = _18(_477);
        uint _481 = _472[_457 / 2u];
        uint _486 = 16u * (_457 & 1u);
        _468 = (_481 >> _486) & 65535u;
    }
    uint _495 = _468;
    uint _504 = _495;
    vec3 _497 = SAMPLE_TEXTURE(SAMPLER_2D(_502[nonuniformEXT(_504)], _510), _335._m15.zw).xyz;
    uint _522 = _495;
    vec2 _519 = SAMPLE_TEXTURE(SAMPLER_2D(_520[nonuniformEXT(_522)], _525), _335._m15.zw).yx;
    vec3 _533 = vec3(0.039999999105930328369140625);
    uint _538 = _495;
    _533 = SAMPLE_TEXTURE(SAMPLER_2D(_536[nonuniformEXT(_538)], _541), _335._m15.zw).xyz;
    uint _552 = _495;
    float _549 = SAMPLE_TEXTURE(SAMPLER_2D(_550[nonuniformEXT(_552)], _555), _335._m15.zw).x;
    float _563 = 1.0;
    uint _566 = _495;
    _563 = SAMPLE_TEXTURE(SAMPLER_2D(_564[nonuniformEXT(_566)], _569), _335._m15.zw).x;
    uint _580 = _495;
    float _577 = SAMPLE_TEXTURE(SAMPLER_2D(_578[nonuniformEXT(_580)], _583), _335._m15.zw).x;
    uint _594 = _495;
    float _591 = SAMPLE_TEXTURE(SAMPLER_2D(_592[nonuniformEXT(_594)], _597), _335._m15.zw).x;
    uint _608 = _495;
    vec3 _605 = SAMPLE_TEXTURE(SAMPLER_2D(_606[nonuniformEXT(_608)], _611), _335._m15.zw).xyz;
    _426 = vec4(_497.x, _497.y, _497.z, _426.w);
    _426.w = _519.y;
    _427 = vec4(_533.x, _533.y, _533.z, _427.w);
    _427.w = _591;
    _428 = vec4(_428.x, _519.x, _428.z, _519.y);
    _424.x = _577;
    _424.y = _563;
    _424.z = _591;
    _424.w = _549;
    _425 = vec4(_605.x, _605.y, _605.z, _425.w);
    uint _644 = 0u;
    vec4 _645 = vec4(0.0);
    vec4 _646 = vec4(0.0);
    vec4 _647 = vec4(0.0);
    vec4 _648 = vec4(0.0);
    vec4 _649 = vec4(0.0);
    uint _650 = _433.x & 7u;
    uint _660;
    if (_371._m12.x == 0.0)
    {
        _660 = _650;
    }
    else
    {
        vec4 _664 = _475._m6;
        uvec4 _663 = _18(_664);
        uint _668 = _663[_650 / 2u];
        uint _673 = 16u * (_650 & 1u);
        _660 = (_668 >> _673) & 65535u;
    }
    uint _681 = _660;
    vec4 _683 = vec4(_335._m15.xy, 0.0, _475._m7.x);
    uint _695 = _681;
    vec3 _693 = SAMPLE_TEXTURE1(SAMPLER_2D(_502[nonuniformEXT(_695)], _510), _683.xy, _683.w).xyz;
    uint _708 = _681;
    vec2 _706 = SAMPLE_TEXTURE1(SAMPLER_2D(_520[nonuniformEXT(_708)], _525), _683.xy, _683.w).yx;
    vec3 _719 = vec3(0.039999999105930328369140625);
    uint _721 = _681;
    _719 = SAMPLE_TEXTURE1(SAMPLER_2D(_536[nonuniformEXT(_721)], _541), _683.xy, _683.w).xyz;
    uint _734 = _681;
    float _732 = SAMPLE_TEXTURE1(SAMPLER_2D(_550[nonuniformEXT(_734)], _555), _683.xy, _683.w).x;
    float _745 = 1.0;
    uint _747 = _681;
    _745 = SAMPLE_TEXTURE1(SAMPLER_2D(_564[nonuniformEXT(_747)], _569), _683.xy, _683.w).x;
    uint _760 = _681;
    float _758 = SAMPLE_TEXTURE1(SAMPLER_2D(_578[nonuniformEXT(_760)], _583), _683.xy, _683.w).x;
    uint _773 = _681;
    float _771 = SAMPLE_TEXTURE1(SAMPLER_2D(_592[nonuniformEXT(_773)], _597), _683.xy, _683.w).x;
    uint _786 = _681;
    vec3 _784 = SAMPLE_TEXTURE1(SAMPLER_2D(_606[nonuniformEXT(_786)], _611), _683.xy, _683.w).xyz;
    _645 = vec4(_693.x, _693.y, _693.z, _645.w);
    _645.w = _706.y;
    _646 = vec4(_719.x, _719.y, _719.z, _646.w);
    _646.w = _771;
    _647 = vec4(_647.x, _706.x, _647.z, _706.y);
    _648.x = _758;
    _648.y = _745;
    _648.z = _771;
    _648.w = _732;
    _649 = vec4(_784.x, _784.y, _784.z, _649.w);
    _335._m8 = _647.wyz;
    float _831 = _424.y * _475._m8.x;
    _335._m4 = _10(_831);
    float _839;
    if (_475._m9.x > 0.0)
    {
        _839 = _427.x;
    }
    else
    {
        _839 = 0.0;
    }
    _335._m5 = _839;
    vec3 _850;
    if (_475._m9.x > 0.0)
    {
        _850 = vec3(_427.y);
    }
    else
    {
        _850 = _427.xyz;
    }
    _427 = vec4(_850.x, _850.y, _850.z, _427.w);
    float _869 = (1.0 - _335._m4) * _475._m10.x;
    _335._m12 = _10(_869);
    _335._m10 = vec3(_424.x) * _435;
    _335._m10 *= vec3(_371._m13.x);
    _335._m0 = _426.xyz;
    _335._m2 = _427.xyz;
    _335._m1 = _425.xyz;
    _335._m9 = _424.xyz;
    _335._m3 = _424.w;
    _335._m6 = _428.wyz;
    vec2 _904 = _347.xy * _357._m34.xy;
    vec4 _911 = SAMPLE_TEXTURE(_913, _904);
    vec4 _917 = SAMPLE_TEXTURE(_918, _904);
    float _928 = _923.x * 0.5;
    float _922 = 1.0 - _10(_928);
    float _934 = _922 * 2.0;
    float _941 = (_10(_934) - (1.0 - _911.w)) * 1.0;
    float _931 = _10(_941);
    float _950 = (_922 - (1.0 - _917.w)) * 1.0;
    float _943 = _10(_950);
    vec3 _954 = _911.xyz;
    _335._m0 = mix(_335._m0, _30(_954), vec3(_931));
    _335._m2 = mix(_335._m2, vec3(0.0199999995529651641845703125), vec3(_931));
    _335._m3 = mix(_335._m3, 0.64999997615814208984375, _931);
    _335._m6 = mix(_335._m6, _917.xyz, vec3(_943));
    uint _984 = uint((_357._m33.x > 0.0) ? 8 : 0);
    float _990 = 16.0;
    float _992 = 8.0;
    float _994 = 24.0;
    vec2 _1003 = _335._m16.xy * _371._m14.xy;
    vec3 _996;
    _996 = vec3(_1003.x, _1003.y, _996.z);
    _996.y = 1.0 - _996.y;
    vec2 _1016 = floor(_996.xy * vec2(_990, _992));
    _996 = vec3(_1016.x, _1016.y, _996.z);
    float _1020 = _335._m16.z;
    vec4 _1023 = _371._m15;
    float _1026 = 1.0;
    bool _1027 = false;
    float _1019 = _54(_1020, _1023, _1026, _1027);
    float _1029 = log2(max(1.0, _1019 / _371._m16.z)) * _371._m16.w;
    _996.z = min(_994 - 1.0, floor(_1029));
    uint _1045 = uint((_996.x + (_996.y * _990)) + ((_996.z * _990) * _992));
    _1045 = min(_1045, uint(((_990 * _992) * _994) - 1.0));
    bool _1070 = true;
    vec3 _1072 = _335._m6;
    bool _1075 = _1070;
    _335._m7 = _59(_1072, _1075);
    vec3 _1079 = _335._m7;
    mat3 _1082 = _335._m17;
    _335._m6 = _66(_1079, _1082);
    vec3 _1087 = _335._m8;
    mat3 _1090 = _335._m17;
    bool _1093 = _1070;
    _335._m8 = _72(_1087, _1090, _1093);
    uint _1097 = 0u;
    uint _1098 = 0u;
    uint _1099 = 0u;
    uint _1100 = 0u;
    uint _1101 = 0u;
    uint _1102 = 0u;
    int _1104 = 256;
    _1106 _1108;
    _1108._m0 = _1113._m0[_1045]._m0;
    _1108._m1 = _1113._m0[_1045]._m1;
    int _1122 = _1108._m0 & (~(_1108._m0 >> 31));
    int _1131 = _1108._m1 & (~(_1108._m1 >> 31));
    _1097 = uint((_1122 >> 16) * _1104);
    _1098 = _1097 + uint(_1131 & 255);
    _1099 = _1097;
    _1100 = _1099 + uint((_1131 >> 8) & 255);
    _1101 = _1097;
    _1102 = _1101 + uint((_1131 >> 16) & 255);
    float _1166 = _335._m37;
    float _1164 = _36(_1166);
    float _1173 = _1164 - 0.5;
    float _1170 = _10(_1173) * 2.0;
    float _1185 = _1164 * 2.0;
    float _1176 = (_335._m38 * _335._m38) * _10(_1185);
    float _1192 = _1176 + _1170;
    float _1188 = _10(_1192);
    if (_1188 > 0.0039215688593685626983642578125)
    {
        vec3 _1201 = _335._m0;
        float _1208 = _1188 * 1.0;
        float _1209 = 0.0;
        float _1210 = 0.3499999940395355224609375;
        _335._m0 = mix(_335._m0, _33(_1201), vec3(_42(_1208, _1209, _1210) * (1.0 - _335._m3)));
        float _1224 = _1188 * 1.0;
        float _1225 = 0.25;
        float _1226 = 0.5;
        _335._m2 = mix(_335._m2, vec3(0.039999999105930328369140625), vec3(_42(_1224, _1225, _1226)));
        vec3 _1231 = vec3(_335._m17[0].z, _335._m17[1].z, _335._m17[2].z);
        float _1245 = _1231.z + 0.0625;
        float _1239 = _1188 * _10(_1245);
        float _1254 = _1239 * 1.0;
        float _1255 = 0.20000000298023223876953125;
        float _1256 = 1.0;
        _335._m3 = mix(_335._m3, 0.89999997615814208984375, _42(_1254, _1255, _1256));
        float _1265 = _1239 * 1.0;
        float _1266 = 0.449999988079071044921875;
        float _1267 = 0.980000019073486328125;
        float _1260 = _42(_1265, _1266, _1267);
        _335._m6 = normalize(mix(_335._m6, vec3(0.0, 0.0, 1.0), vec3(_1260)));
        _335._m7 = mix(_335._m6, vec3(0.5, 0.5, 1.0), vec3(_1260));
        if (_1239 > 0.980000019073486328125)
        {
            float _1291 = _1239 * _1260;
            float _1292 = 0.980000019073486328125;
            float _1293 = 1.0;
            _1231 = normalize(mix(_1231, vec3(0.0, 0.0, 1.0), vec3(_42(_1291, _1292, _1293))));
            _335._m17[0].z = _1231.x;
            _335._m17[1].z = _1231.y;
            _335._m17[2].z = _1231.z;
        }
    }
    vec3 _1307 = vec3(0.0);
    vec3 _1308 = vec3(_335._m34.x, _335._m34.y, _335._m34.z);
    vec3 _1316 = vec3(_335._m34.w, _335._m35.x, _335._m35.y);
    vec3 _1324 = vec3(_335._m35.z, _335._m35.w, _335._m36.x);
    vec3 _1332 = vec3(_335._m36.y, _335._m36.z, _335._m36.w);
    vec3 _1340 = ((_1308 - (_1316 * _335._m6.y)) + (_1324 * _335._m6.z)) - (_1332 * _335._m6.x);
    float _1363 = _357._m35.x * _371._m17.x;
    _1307 += max(_1340 * _10(_1363), vec3(0.0));
    vec3 _1369 = vec3(0.0);
    vec3 _1370 = vec3(_335._m34.x, _335._m34.y, _335._m34.z);
    vec3 _1378 = vec3(_335._m34.w, _335._m35.x, _335._m35.y);
    vec3 _1386 = vec3(_335._m35.z, _335._m35.w, _335._m36.x);
    vec3 _1394 = vec3(_335._m36.y, _335._m36.z, _335._m36.w);
    vec3 _1402 = ((_1370 - (_1378 * _335._m8.y)) + (_1386 * _335._m8.z)) - (_1394 * _335._m8.x);
    float _1425 = _357._m35.x * _371._m17.x;
    _1369 += max(_1402 * _10(_1425), vec3(0.0));
    _1307 = mix(_1307, _1369, vec3(_335._m4));
    float _1442;
    if (dot(_335._m10, vec3(1.0)) > 0.0)
    {
        _1442 = -_335._m3;
    }
    else
    {
        _1442 = _335._m3;
    }
    _335._m3 = _1442;
    _335._m18 = _1307;
    if (_357._m36.x < 1.0)
    {
        vec2 _1461 = gl_FragCoord.xy * 0.00390625;
        float _1466 = TEXTURE_LOD(_1467, vec4(_347.xy * _475._m11.xy, 0.0, 0.0).xy, vec4(_347.xy * _475._m11.xy, 0.0, 0.0).w).x;
        float _1501 = abs(clamp((_357._m36.x - (_1466 * 0.5)) - 0.100000001490116119384765625, -1.0, 0.0));
        _1466 = _10(_1501);
        _1466 *= 600.0;
        _335._m19 += (vec3(_1466) * vec3(1.0, 0.00999999977648258209228515625, 0.0));
    }
    vec3 _1525 = (_335._m18 * _335._m0) + _335._m10;
    _1517 = vec4(_1525.x, _1525.y, _1525.z, _1517.w);
    vec3 _1529 = _335._m6;
    bool _1532 = false;
    vec2 _1533 = _83(_1529, _1532);
    _1528 = vec4(_1533.x, _1533.y, _1528.z, _1528.w);
    float _1537 = _335._m2.x;
    float _1541 = _335._m2.y;
    float _1545 = _335._m2.z;
    float _1549 = _335._m3;
    _1536 = vec4(_45(_1537), _45(_1541), _45(_1545), _86(_1549));
    uint _1554 = uint((_357._m33.x > 0.0) ? 8 : 0);
    uint _1560 = uint(int(_1554 > 0u));
    _1560 |= 2u;
    _1560 |= 4u;
    _1560 |= ((uint(_357._m33.z) & 3u) << uint(4));
    float _1578 = _335._m0.x;
    float _1582 = _335._m0.y;
    float _1586 = _335._m0.z;
    _1577 = vec4(_45(_1578), _45(_1582), _45(_1586), float(_1560) / 255.0);
    vec4 _1595 = _1596;
    vec4 _1598 = _1599;
    vec2 _1601 = ((_1595.xy / vec2(_1595.w)) * 0.5) + vec2(0.5);
    vec2 _1611 = ((_1598.xy / vec2(_1598.w)) * 0.5) + vec2(0.5);
    _1601.y = 1.0 - _1601.y;
    _1611.y = 1.0 - _1611.y;
    vec2 _1629 = _371._m18.xy;
    _1633 = vec4((_1601 - _1611) * _1629, 0.0, 1.0);
    vec3 _1647 = _1517.xyz + _357._m37.xyz;
    _1517 = vec4(_1647.x, _1647.y, _1647.z, _1517.w);
}

