#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

struct _556
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1096
{
    int _m0;
    int _m1;
};

struct _1099
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _579_581
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _581;

layout(set = 0, binding = 0, std140) uniform _593_595
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _595;

layout(set = 2, binding = 0, std140) uniform _746_748
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _748;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1101_1103
{
    _1099 _m0[];
} _1103;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1520_1522
{
    vec4 _m0[];
} _1522;

layout(push_constant, std430) uniform _1516_1518
{
    int _m0;
    int _m1;
} _1518;

layout(set = 2, binding = 1) uniform SAMPLER_2D _726;
layout(set = 2, binding = 2) uniform SAMPLER_2D _862;
layout(set = 1, binding = 1) uniform SAMPLER_2D _915;
layout(set = 1, binding = 2) uniform SAMPLER_2D _920;
layout(set = 3, binding = 0) uniform texture2D _1508[16384];
layout(set = 3, binding = 1) uniform texture2D _1509[16384];
layout(set = 3, binding = 2) uniform texture2D _1510[16384];
layout(set = 3, binding = 3) uniform texture2D _1511[16384];
layout(set = 3, binding = 4) uniform texture2D _1512[16384];
layout(set = 3, binding = 5) uniform texture2D _1513[16384];
layout(set = 3, binding = 6) uniform texture2D _1514[16384];
layout(set = 3, binding = 7) uniform texture2D _1515[16384];
layout(set = 0, binding = 3) uniform sampler3D _1526;
layout(set = 0, binding = 4) uniform sampler3D _1527;

layout(location = 2) in vec4 _571;
layout(location = 6) in vec4 _600;
layout(location = 3) in vec4 _612;
layout(location = 4) in vec4 _615;
layout(location = 5) in vec4 _618;
layout(location = 10) in vec4 _636;
layout(location = 11) in vec4 _640;
layout(location = 12) in vec4 _644;
layout(location = 8) in vec4 _925;
layout(location = 0) out vec4 _1421;
layout(location = 1) out vec4 _1432;
layout(location = 2) out vec4 _1440;
layout(location = 3) out vec4 _1478;

float _155;

float _43(float _42)
{
    return _42 * _42;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _25(float _24)
{
    return _24 * ((_24 * ((_24 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _28(vec3 _27)
{
    float _193 = _27.x;
    vec3 _192;
    _192.x = _25(_193);
    float _198 = _27.y;
    _192.y = _25(_198);
    float _203 = _27.z;
    _192.z = _25(_203);
    return _192;
}

vec4 _34(vec4 _33)
{
    vec3 _212 = _33.xyz;
    vec4 _211 = vec4(_28(_212), 1.0);
    float _220 = _33.w;
    _211.w = _25(_220);
    return _211;
}

vec4 _67(SAMPLER_2D _65, vec2 _66)
{
    vec4 _264 = SAMPLE_TEXTURE(_65, _66);
    vec4 _268 = _264;
    _264 = _34(_268);
    return _264;
}

float _71(vec3 _70)
{
    return dot(_70, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _98(vec3 _96, bool _97)
{
    vec3 _405 = (_96 * 2.0) - vec3(1.0);
    float _423 = (1.0 - (_405.x * _405.x)) - (_405.y * _405.y);
    _405.z = sqrt(_10(_423));
    if (_97 == false)
    {
        _405.z = -_405.z;
    }
    return _405;
}

vec3 _105(vec3 _103, mat3 _104)
{
    return normalize(vec3(dot(_103, _104[0]), dot(_103, _104[1]), dot(_103, _104[2])));
}

vec3 _111(vec3 _108, mat3 _109, bool _110)
{
    vec3 _460 = _108;
    bool _462 = _110;
    vec3 _459 = _98(_460, _462);
    vec3 _465 = _459;
    mat3 _467 = _109;
    return _105(_465, _467);
}

float _19(float _18)
{
    if (_18 <= 0.040449999272823333740234375)
    {
        return _18 / 12.9200000762939453125;
    }
    else
    {
        return pow((_18 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _22(vec3 _21)
{
    float _157 = _21.x;
    vec3 _156;
    _156.x = _19(_157);
    float _164 = _21.y;
    _156.y = _19(_164);
    float _170 = _21.z;
    _156.z = _19(_170);
    return _156;
}

vec3 _37(vec3 _36)
{
    vec3 _229 = _36;
    return _22(_229);
}

float _93(float _89, vec4 _90, float _91, bool _92)
{
    float _392 = _90.w / (_89 + _90.z);
    return _392 * _91;
}

vec3 _40(vec3 _39)
{
    return _39 * _39;
}

float _49(float _46, float _47, float _48)
{
    float _251 = (_46 - _47) / (_48 - _47);
    return _10(_251);
}

float _54(float _52, float _53)
{
    return pow(_52, _53);
}

vec3 _76(vec3 _74, float _75)
{
    float _289 = 50.0 * dot(_74, vec3(0.33329999446868896484375));
    float _282 = _10(_289);
    float _298 = 1.0 - _75;
    float _301 = _10(_298);
    float _302 = 5.0;
    vec3 _306 = _74 + ((vec3(_282) - _74) * _54(_301, _302));
    return _16(_306);
}

vec3 _84(vec3 _79, vec3 _80, vec3 _81, vec3 _82, float _83)
{
    vec3 _310 = normalize(_80 + _81);
    float _315 = 1.0 - (_83 * 0.800000011920928955078125);
    _315 *= _315;
    _315 *= _315;
    float _326 = _315 * _315;
    float _334 = dot(_79, _310);
    float _330 = _10(_334);
    float _336 = ((_330 * _330) * (_326 - 1.0)) + 1.0;
    _336 = _326 / ((_336 * _336) + 9.9999999392252902907785028219223e-09);
    float _355 = dot(_79, _80);
    float _351 = (_10(_355) * (1.0 - _315)) + _315;
    float _366 = dot(_79, _81);
    float _362 = (_10(_366) * (1.0 - _315)) + _315;
    _336 /= (((4.0 * _351) * _362) + 9.9999999392252902907785028219223e-09);
    vec3 _384 = _82;
    float _386 = dot(_81, _310);
    return _76(_384, _386) * _336;
}

vec2 _115(vec2 _114)
{
    return (vec2(1.0) - abs(_114.yx)) * vec2((_114.x >= 0.0) ? 1.0 : (-1.0), (_114.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _120(inout vec3 _118, bool _119)
{
    _118 /= vec3((abs(_118.x) + abs(_118.y)) + abs(_118.z));
    vec2 _507;
    if (_118.z >= 0.0)
    {
        _507 = _118.xy;
    }
    else
    {
        vec2 _513 = _118.xy;
        _507 = _115(_513);
    }
    _118 = vec3(_507.x, _507.y, _118.z);
    if (_119)
    {
        vec2 _528 = (_118.xy * 0.5) + vec2(0.5);
        _118 = vec3(_528.x, _528.y, _118.z);
    }
    return _118.xy;
}

float _57(float _56)
{
    return sqrt(_56);
}

float _123(float _122)
{
    float _538 = abs(_122);
    float _535 = _57(_538);
    float _542;
    if (_122 > 0.0)
    {
        _542 = _535;
    }
    else
    {
        _542 = -_535;
    }
    return (_542 * 0.5) + 0.5;
}

void main()
{
    _556 _558 = _556(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _556 _568 = _556(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _568._m15 = _571;
    _568._m16 = gl_FragCoord;
    _568._m40 = (uint(_581._m25.z) & 3u) << uint(4);
    _568._m14 = _595._m0.xyz + _600.xyz;
    _568._m13 = normalize(-_600.xyz);
    _568._m17 = mat3(vec3(_612.xyz), vec3(_615.xyz), vec3(_618.xyz));
    _568._m34 = _636;
    _568._m35 = _640;
    _568._m36 = _644;
    uint _647 = 0u;
    vec4 _648 = vec4(0.0);
    vec4 _649 = vec4(0.0);
    vec4 _650 = vec4(0.0);
    vec4 _651 = vec4(0.0);
    vec4 _652 = vec4(0.0);
    _568._m0 = _650.xyz;
    _568._m2 = _651.xyz;
    _568._m1 = _649.xyz;
    _568._m9 = _648.xyz;
    _568._m3 = _648.w;
    _568._m6 = _652.wyz;
    _568._m12 = 0.0;
    mat3 _676 = transpose(_568._m17);
    vec3 _680 = normalize(vec3(dot(_568._m13, _676[0]), dot(_568._m13, _676[1]), dot(_568._m13, _676[2])));
    vec2 _698 = _571.xy;
    int _702 = 8;
    vec3 _704 = vec3(-_680.xy, 1.0);
    vec3 _711 = _704 / vec3(float(_702));
    vec3 _717 = vec3(_698, 0.0);
    vec2 _722 = _717.xy;
    float _741 = TEXTURE_LOD(_726, vec4(_717.xy, 0.0, 0.0).xy, vec4(_717.xy, 0.0, 0.0).w).w;
    float _725 = _43(_741);
    float _744 = _725 * _748._m4.x;
    float _752 = _744;
    int _754 = 0;
    for (;;)
    {
        bool _762 = _754 < _702;
        bool _769;
        if (_762)
        {
            _769 = _717.z < _744;
        }
        else
        {
            _769 = _762;
        }
        if (_769)
        {
            _722 = _717.xy;
            _752 = _744;
            _717 += _711;
            float _790 = TEXTURE_LOD(_726, vec4(_717.xy, 0.0, 0.0).xy, vec4(_717.xy, 0.0, 0.0).w).w;
            _744 = _43(_790) * _748._m4.x;
            _754++;
            continue;
        }
        else
        {
            break;
        }
    }
    float _798 = _744 - _717.z;
    float _803 = (_752 - _717.z) + _711.z;
    float _817 = _798 / (_798 - _803);
    float _811 = _10(_817);
    vec2 _819 = mix(_717.xy, _722, vec2(_811));
    vec2 _827 = _819;
    vec4 _826 = _67(_726, _827);
    _558._m0 = _826.xyz;
    vec3 _835 = _826.xyz;
    vec3 _851 = (_826.www * _748._m5.w) * 8.0;
    _568._m0 = mix(_826.xyz, _748._m5.xyz * _71(_835), _16(_851));
    _568._m2 = _748._m6.xxx;
    _568._m3 = _748._m6.y;
    _568._m6 = SAMPLE_TEXTURE(_862, _698).xyz;
    vec3 _871 = _558._m0;
    _558._m2 = _748._m6.zzz * _71(_871);
    _558._m3 = _748._m6.w;
    _558._m6 = vec3(1.0) - SAMPLE_TEXTURE1(_862, vec4(_819, 0.0, 0.0).xy, vec4(_819, 0.0, 0.0).w).xyz;
    vec3 _897 = _558._m6;
    mat3 _900 = _568._m17;
    bool _903 = true;
    _558._m6 = _111(_897, _900, _903);
    vec2 _906 = _571.xy * _581._m26.xy;
    vec4 _914 = SAMPLE_TEXTURE(_915, _906);
    vec4 _919 = SAMPLE_TEXTURE(_920, _906);
    float _930 = _925.x * 0.5;
    float _924 = 1.0 - _10(_930);
    float _936 = _924 * 2.0;
    float _943 = (_10(_936) - (1.0 - _914.w)) * 1.0;
    float _933 = _10(_943);
    float _952 = (_924 - (1.0 - _919.w)) * 1.0;
    float _945 = _10(_952);
    vec3 _956 = _914.xyz;
    _568._m0 = mix(_568._m0, _37(_956), vec3(_933));
    _568._m2 = mix(_568._m2, vec3(0.0199999995529651641845703125), vec3(_933));
    _568._m3 = mix(_568._m3, 0.64999997615814208984375, _933);
    _568._m6 = mix(_568._m6, _919.xyz, vec3(_945));
    uint _986 = uint((_581._m25.x > 0.0) ? 8 : 0);
    float _992 = 16.0;
    float _994 = 8.0;
    float _995 = 24.0;
    vec2 _1004 = _568._m16.xy * _595._m2.xy;
    vec3 _997;
    _997 = vec3(_1004.x, _1004.y, _997.z);
    _997.y = 1.0 - _997.y;
    vec2 _1017 = floor(_997.xy * vec2(_992, _994));
    _997 = vec3(_1017.x, _1017.y, _997.z);
    float _1021 = _568._m16.z;
    vec4 _1024 = _595._m3;
    float _1027 = 1.0;
    bool _1028 = false;
    float _1020 = _93(_1021, _1024, _1027, _1028);
    float _1030 = log2(max(1.0, _1020 / _595._m4.z)) * _595._m4.w;
    _997.z = min(_995 - 1.0, floor(_1030));
    uint _1046 = uint((_997.x + (_997.y * _992)) + ((_997.z * _992) * _994));
    _1046 = min(_1046, uint(((_992 * _994) * _995) - 1.0));
    bool _1071 = true;
    vec3 _1073 = _568._m6;
    bool _1076 = _1071;
    _568._m7 = _98(_1073, _1076);
    vec3 _1080 = _568._m7;
    mat3 _1083 = _568._m17;
    _568._m6 = _105(_1080, _1083);
    uint _1088 = 0u;
    uint _1089 = 0u;
    uint _1090 = 0u;
    uint _1091 = 0u;
    uint _1092 = 0u;
    uint _1093 = 0u;
    int _1094 = 256;
    _1096 _1098;
    _1098._m0 = _1103._m0[_1046]._m0;
    _1098._m1 = _1103._m0[_1046]._m1;
    int _1112 = _1098._m0 & (~(_1098._m0 >> 31));
    int _1121 = _1098._m1 & (~(_1098._m1 >> 31));
    _1088 = uint((_1112 >> 16) * _1094);
    _1089 = _1088 + uint(_1121 & 255);
    _1090 = _1088;
    _1091 = _1090 + uint((_1121 >> 8) & 255);
    _1092 = _1088;
    _1093 = _1092 + uint((_1121 >> 16) & 255);
    float _1156 = _568._m37;
    float _1154 = _43(_1156);
    float _1163 = _1154 - 0.5;
    float _1160 = _10(_1163) * 2.0;
    float _1175 = _1154 * 2.0;
    float _1166 = (_568._m38 * _568._m38) * _10(_1175);
    float _1182 = _1166 + _1160;
    float _1178 = _10(_1182);
    if (_1178 > 0.0039215688593685626983642578125)
    {
        vec3 _1191 = _568._m0;
        float _1198 = _1178 * 1.0;
        float _1199 = 0.0;
        float _1200 = 0.3499999940395355224609375;
        _568._m0 = mix(_568._m0, _40(_1191), vec3(_49(_1198, _1199, _1200) * (1.0 - _568._m3)));
        float _1216 = _1178 * 1.0;
        float _1217 = 0.25;
        float _1218 = 0.5;
        _568._m2 = mix(_568._m2, vec3(0.039999999105930328369140625), vec3(_49(_1216, _1217, _1218)));
        vec3 _1223 = vec3(_568._m17[0].z, _568._m17[1].z, _568._m17[2].z);
        float _1237 = _1223.z + 0.0625;
        float _1231 = _1178 * _10(_1237);
        float _1246 = _1231 * 1.0;
        float _1247 = 0.20000000298023223876953125;
        float _1248 = 1.0;
        _568._m3 = mix(_568._m3, 0.89999997615814208984375, _49(_1246, _1247, _1248));
        float _1257 = _1231 * 1.0;
        float _1258 = 0.449999988079071044921875;
        float _1259 = 0.980000019073486328125;
        float _1252 = _49(_1257, _1258, _1259);
        _568._m6 = normalize(mix(_568._m6, vec3(0.0, 0.0, 1.0), vec3(_1252)));
        _568._m7 = mix(_568._m6, vec3(0.5, 0.5, 1.0), vec3(_1252));
        if (_1231 > 0.980000019073486328125)
        {
            float _1283 = _1231 * _1252;
            float _1284 = 0.980000019073486328125;
            float _1285 = 1.0;
            _1223 = normalize(mix(_1223, vec3(0.0, 0.0, 1.0), vec3(_49(_1283, _1284, _1285))));
            _568._m17[0].z = _1223.x;
            _568._m17[1].z = _1223.y;
            _568._m17[2].z = _1223.z;
        }
    }
    vec3 _1299 = vec3(0.0);
    vec3 _1300 = vec3(_568._m34.x, _568._m34.y, _568._m34.z);
    vec3 _1308 = vec3(_568._m34.w, _568._m35.x, _568._m35.y);
    vec3 _1316 = vec3(_568._m35.z, _568._m35.w, _568._m36.x);
    vec3 _1324 = vec3(_568._m36.y, _568._m36.z, _568._m36.w);
    vec3 _1332 = ((_1300 - (_1308 * _568._m6.y)) + (_1316 * _568._m6.z)) - (_1324 * _568._m6.x);
    float _1356 = _581._m27.x * _595._m5.x;
    _1299 += max(_1332 * _10(_1356), vec3(0.0));
    float _1368;
    if (dot(_568._m10, vec3(1.0)) > 0.0)
    {
        _1368 = -_568._m3;
    }
    else
    {
        _1368 = _568._m3;
    }
    _568._m3 = _1368;
    _568._m18 = _1299;
    float _1388 = dot(_568._m6, _568._m13);
    float _1382 = _10(_1388);
    vec3 _1392 = _568._m19;
    vec3 _1398 = _568._m6;
    vec3 _1401 = _568._m13;
    vec3 _1404 = _568._m13;
    vec3 _1407 = _568._m2;
    float _1410 = _568._m3;
    vec3 _1390 = (_16(_1392) * _1382) * _84(_1398, _1401, _1404, _1407, _1410);
    _568._m18 += _1390;
    vec3 _1429 = (_568._m18 * _568._m0) + _568._m10;
    _1421 = vec4(_1429.x, _1429.y, _1429.z, _1421.w);
    vec3 _1433 = _568._m6;
    bool _1436 = false;
    vec2 _1437 = _120(_1433, _1436);
    _1432 = vec4(_1437.x, _1437.y, _1432.z, _1432.w);
    float _1441 = _568._m2.x;
    float _1445 = _568._m2.y;
    float _1449 = _568._m2.z;
    float _1453 = _568._m3;
    _1440 = vec4(_57(_1441), _57(_1445), _57(_1449), _123(_1453));
    uint _1458 = uint((_581._m25.x > 0.0) ? 8 : 0);
    uint _1464 = uint(int(_1458 > 0u));
    _1464 |= 2u;
    _1464 |= ((uint(_581._m25.z) & 3u) << uint(4));
    float _1479 = _568._m0.x;
    float _1483 = _568._m0.y;
    float _1487 = _568._m0.z;
    _1478 = vec4(_57(_1479), _57(_1483), _57(_1487), float(_1464) / 255.0);
    vec3 _1502 = _1421.xyz + _581._m28.xyz;
    _1421 = vec4(_1502.x, _1502.y, _1502.z, _1421.w);
}

