#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _333
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1107
{
    int _m0;
    int _m1;
};

struct _1110
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _355_357
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
} _357;

layout(set = 0, binding = 0, std140) uniform _369_371
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _371;

layout(set = 2, binding = 0, std140) uniform _472_474
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _474;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1112_1114
{
    _1110 _m0[];
} _1114;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1607_1609
{
    vec4 _m0[];
} _1609;

layout(push_constant, std430) uniform _1603_1605
{
    int _m0;
    int _m1;
} _1605;

layout(set = 3, binding = 0) uniform TEXTURE_2D _500[16384];
layout(set = 0, binding = 5) uniform sampler _508;
layout(set = 3, binding = 2) uniform TEXTURE_2D _518[16384];
layout(set = 0, binding = 6) uniform sampler _523;
layout(set = 3, binding = 1) uniform TEXTURE_2D _534[16384];
layout(set = 0, binding = 7) uniform sampler _539;
layout(set = 3, binding = 3) uniform TEXTURE_2D _548[16384];
layout(set = 0, binding = 8) uniform sampler _553;
layout(set = 3, binding = 5) uniform TEXTURE_2D _562[16384];
layout(set = 0, binding = 9) uniform sampler _567;
layout(set = 3, binding = 7) uniform TEXTURE_2D _576[16384];
layout(set = 0, binding = 10) uniform sampler _581;
layout(set = 3, binding = 4) uniform TEXTURE_2D _590[16384];
layout(set = 0, binding = 11) uniform sampler _595;
layout(set = 3, binding = 6) uniform TEXTURE_2D _604[16384];
layout(set = 0, binding = 12) uniform sampler _609;
layout(set = 1, binding = 1) uniform SAMPLER_2D _914;
layout(set = 1, binding = 2) uniform SAMPLER_2D _919;
layout(set = 1, binding = 3) uniform SAMPLER_2D _1470;
layout(set = 0, binding = 3) uniform sampler3D _1613;
layout(set = 0, binding = 4) uniform sampler3D _1614;

layout(location = 2) in vec4 _347;
layout(location = 6) in vec4 _376;
layout(location = 3) in vec4 _388;
layout(location = 4) in vec4 _391;
layout(location = 5) in vec4 _394;
layout(location = 10) in vec4 _412;
layout(location = 11) in vec4 _416;
layout(location = 12) in vec4 _420;
layout(location = 14) flat in uvec3 _433;
layout(location = 15) in vec4 _436;
layout(location = 8) in vec4 _924;
layout(location = 0) out vec4 _1519;
layout(location = 1) out vec4 _1530;
layout(location = 2) out vec4 _1538;
layout(location = 3) out vec4 _1576;

float _116;

uvec4 _18(vec4 _17)
{
    return floatBitsToUint(_17);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _21(float _20)
{
    if (_20 <= 0.040449999272823333740234375)
    {
        return _20 / 12.9200000762939453125;
    }
    else
    {
        return pow((_20 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _27(vec3 _26)
{
    float _118 = _26.x;
    vec3 _117;
    _117.x = _21(_118);
    float _124 = _26.y;
    _117.y = _21(_124);
    float _130 = _26.z;
    _117.z = _21(_130);
    return _117;
}

vec3 _30(vec3 _29)
{
    vec3 _139 = _29;
    return _27(_139);
}

float _54(float _50, vec4 _51, float _52, bool _53)
{
    float _169 = _51.w / (_50 + _51.z);
    return _169 * _52;
}

vec3 _59(vec3 _57, bool _58)
{
    vec3 _183 = (_57 * 2.0) - vec3(1.0);
    float _201 = (1.0 - (_183.x * _183.x)) - (_183.y * _183.y);
    _183.z = sqrt(_10(_201));
    if (_58 == false)
    {
        _183.z = -_183.z;
    }
    return _183;
}

vec3 _66(vec3 _64, mat3 _65)
{
    return normalize(vec3(dot(_64, _65[0]), dot(_64, _65[1]), dot(_64, _65[2])));
}

vec3 _72(vec3 _69, mat3 _70, bool _71)
{
    vec3 _238 = _69;
    bool _240 = _71;
    vec3 _237 = _59(_238, _240);
    vec3 _243 = _237;
    mat3 _245 = _70;
    return _66(_243, _245);
}

float _36(float _35)
{
    return _35 * _35;
}

vec3 _33(vec3 _32)
{
    return _32 * _32;
}

float _42(float _39, float _40, float _41)
{
    float _161 = (_39 - _40) / (_41 - _40);
    return _10(_161);
}

vec2 _78(vec2 _77)
{
    return (vec2(1.0) - abs(_77.yx)) * vec2((_77.x >= 0.0) ? 1.0 : (-1.0), (_77.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _83(inout vec3 _81, bool _82)
{
    _81 /= vec3((abs(_81.x) + abs(_81.y)) + abs(_81.z));
    vec2 _285;
    if (_81.z >= 0.0)
    {
        _285 = _81.xy;
    }
    else
    {
        vec2 _291 = _81.xy;
        _285 = _78(_291);
    }
    _81 = vec3(_285.x, _285.y, _81.z);
    if (_82)
    {
        vec2 _306 = (_81.xy * 0.5) + vec2(0.5);
        _81 = vec3(_306.x, _306.y, _81.z);
    }
    return _81.xy;
}

float _45(float _44)
{
    return sqrt(_44);
}

float _86(float _85)
{
    float _316 = abs(_85);
    float _313 = _45(_316);
    float _320;
    if (_85 > 0.0)
    {
        _320 = _313;
    }
    else
    {
        _320 = -_313;
    }
    return (_320 * 0.5) + 0.5;
}

void main()
{
    _333 _335 = _333(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _335._m15 = _347;
    _335._m16 = gl_FragCoord;
    _335._m40 = (uint(_357._m25.z) & 3u) << uint(4);
    _335._m14 = _371._m0.xyz + _376.xyz;
    _335._m13 = normalize(-_376.xyz);
    _335._m17 = mat3(vec3(_388.xyz), vec3(_391.xyz), vec3(_394.xyz));
    _335._m34 = _412;
    _335._m35 = _416;
    _335._m36 = _420;
    uint _423 = 0u;
    vec4 _424 = vec4(0.0);
    vec4 _425 = vec4(0.0);
    vec4 _426 = vec4(0.0);
    vec4 _427 = vec4(0.0);
    vec4 _428 = vec4(0.0);
    uvec3 _431 = _433;
    vec3 _435 = _436.xyz;
    bool _443 = _431.y == 65535u;
    bool _449;
    if (_443)
    {
        _449 = _431.z == 65535u;
    }
    else
    {
        _449 = _443;
    }
    bool _439 = _449;
    bool _450 = !_439;
    bool _453 = _431.z != 65535u;
    uint _457 = _431.x & 7u;
    uint _467;
    if (_371._m2.x == 0.0)
    {
        _467 = _457;
    }
    else
    {
        vec4 _475 = _474._m4;
        uvec4 _471 = _18(_475);
        uint _479 = _471[_457 / 2u];
        uint _484 = 16u * (_457 & 1u);
        _467 = (_479 >> _484) & 65535u;
    }
    uint _493 = _467;
    uint _502 = _493;
    vec3 _495 = SAMPLE_TEXTURE(SAMPLER_2D(_500[nonuniformEXT(_502)], _508), _335._m15.zw).xyz;
    uint _520 = _493;
    vec2 _517 = SAMPLE_TEXTURE(SAMPLER_2D(_518[nonuniformEXT(_520)], _523), _335._m15.zw).yx;
    vec3 _531 = vec3(0.039999999105930328369140625);
    uint _536 = _493;
    _531 = SAMPLE_TEXTURE(SAMPLER_2D(_534[nonuniformEXT(_536)], _539), _335._m15.zw).xyz;
    uint _550 = _493;
    float _547 = SAMPLE_TEXTURE(SAMPLER_2D(_548[nonuniformEXT(_550)], _553), _335._m15.zw).x;
    float _561 = 1.0;
    uint _564 = _493;
    _561 = SAMPLE_TEXTURE(SAMPLER_2D(_562[nonuniformEXT(_564)], _567), _335._m15.zw).x;
    uint _578 = _493;
    float _575 = SAMPLE_TEXTURE(SAMPLER_2D(_576[nonuniformEXT(_578)], _581), _335._m15.zw).x;
    uint _592 = _493;
    float _589 = SAMPLE_TEXTURE(SAMPLER_2D(_590[nonuniformEXT(_592)], _595), _335._m15.zw).x;
    uint _606 = _493;
    vec3 _603 = SAMPLE_TEXTURE(SAMPLER_2D(_604[nonuniformEXT(_606)], _609), _335._m15.zw).xyz;
    _426 = vec4(_495.x, _495.y, _495.z, _426.w);
    _426.w = _517.y;
    _427 = vec4(_531.x, _531.y, _531.z, _427.w);
    _427.w = _589;
    _428 = vec4(_428.x, _517.x, _428.z, _517.y);
    _424.x = _575;
    _424.y = _561;
    _424.z = _589;
    _424.w = _547;
    _425 = vec4(_603.x, _603.y, _603.z, _425.w);
    uint _642 = 0u;
    vec4 _643 = vec4(0.0);
    vec4 _644 = vec4(0.0);
    vec4 _645 = vec4(0.0);
    vec4 _646 = vec4(0.0);
    vec4 _647 = vec4(0.0);
    uint _648 = _433.x & 7u;
    uint _658;
    if (_371._m2.x == 0.0)
    {
        _658 = _648;
    }
    else
    {
        vec4 _662 = _474._m4;
        uvec4 _661 = _18(_662);
        uint _666 = _661[_648 / 2u];
        uint _671 = 16u * (_648 & 1u);
        _658 = (_666 >> _671) & 65535u;
    }
    uint _679 = _658;
    vec4 _681 = vec4(_335._m15.xy, 0.0, _474._m5.x);
    uint _693 = _679;
    vec3 _691 = SAMPLE_TEXTURE1(SAMPLER_2D(_500[nonuniformEXT(_693)], _508), _681.xy, _681.w).xyz;
    uint _706 = _679;
    vec2 _704 = SAMPLE_TEXTURE1(SAMPLER_2D(_518[nonuniformEXT(_706)], _523), _681.xy, _681.w).yx;
    vec3 _717 = vec3(0.039999999105930328369140625);
    uint _719 = _679;
    _717 = SAMPLE_TEXTURE1(SAMPLER_2D(_534[nonuniformEXT(_719)], _539), _681.xy, _681.w).xyz;
    uint _732 = _679;
    float _730 = SAMPLE_TEXTURE1(SAMPLER_2D(_548[nonuniformEXT(_732)], _553), _681.xy, _681.w).x;
    float _743 = 1.0;
    uint _745 = _679;
    _743 = SAMPLE_TEXTURE1(SAMPLER_2D(_562[nonuniformEXT(_745)], _567), _681.xy, _681.w).x;
    uint _758 = _679;
    float _756 = SAMPLE_TEXTURE1(SAMPLER_2D(_576[nonuniformEXT(_758)], _581), _681.xy, _681.w).x;
    uint _771 = _679;
    float _769 = SAMPLE_TEXTURE1(SAMPLER_2D(_590[nonuniformEXT(_771)], _595), _681.xy, _681.w).x;
    uint _784 = _679;
    vec3 _782 = SAMPLE_TEXTURE1(SAMPLER_2D(_604[nonuniformEXT(_784)], _609), _681.xy, _681.w).xyz;
    _643 = vec4(_691.x, _691.y, _691.z, _643.w);
    _643.w = _704.y;
    _644 = vec4(_717.x, _717.y, _717.z, _644.w);
    _644.w = _769;
    _645 = vec4(_645.x, _704.x, _645.z, _704.y);
    _646.x = _756;
    _646.y = _743;
    _646.z = _769;
    _646.w = _730;
    _647 = vec4(_782.x, _782.y, _782.z, _647.w);
    _335._m8 = _645.wyz;
    float _830 = _424.y * _474._m6.x;
    _335._m4 = _10(_830);
    float _837;
    if (_474._m7.x > 0.0)
    {
        _837 = _427.x;
    }
    else
    {
        _837 = 0.0;
    }
    _335._m5 = _837;
    vec3 _848;
    if (_474._m7.x > 0.0)
    {
        _848 = vec3(_427.y);
    }
    else
    {
        _848 = _427.xyz;
    }
    _427 = vec4(_848.x, _848.y, _848.z, _427.w);
    float _867 = (1.0 - _335._m4) * _474._m8.x;
    _335._m12 = _10(_867);
    _335._m10 = vec3(_424.x) * _435;
    _335._m10 *= vec3(_371._m3.x);
    _335._m0 = _426.xyz;
    _335._m2 = _427.xyz;
    _335._m1 = _425.xyz;
    _335._m9 = _424.xyz;
    _335._m3 = _424.w;
    _335._m6 = _428.wyz;
    vec2 _904 = _347.xy * _357._m26.xy;
    vec4 _912 = SAMPLE_TEXTURE(_914, _904);
    vec4 _918 = SAMPLE_TEXTURE(_919, _904);
    float _929 = _924.x * 0.5;
    float _923 = 1.0 - _10(_929);
    float _935 = _923 * 2.0;
    float _942 = (_10(_935) - (1.0 - _912.w)) * 1.0;
    float _932 = _10(_942);
    float _951 = (_923 - (1.0 - _918.w)) * 1.0;
    float _944 = _10(_951);
    vec3 _955 = _912.xyz;
    _335._m0 = mix(_335._m0, _30(_955), vec3(_932));
    _335._m2 = mix(_335._m2, vec3(0.0199999995529651641845703125), vec3(_932));
    _335._m3 = mix(_335._m3, 0.64999997615814208984375, _932);
    _335._m6 = mix(_335._m6, _918.xyz, vec3(_944));
    uint _985 = uint((_357._m25.x > 0.0) ? 8 : 0);
    float _991 = 16.0;
    float _993 = 8.0;
    float _995 = 24.0;
    vec2 _1004 = _335._m16.xy * _371._m4.xy;
    vec3 _997;
    _997 = vec3(_1004.x, _1004.y, _997.z);
    _997.y = 1.0 - _997.y;
    vec2 _1017 = floor(_997.xy * vec2(_991, _993));
    _997 = vec3(_1017.x, _1017.y, _997.z);
    float _1021 = _335._m16.z;
    vec4 _1024 = _371._m5;
    float _1027 = 1.0;
    bool _1028 = false;
    float _1020 = _54(_1021, _1024, _1027, _1028);
    float _1030 = log2(max(1.0, _1020 / _371._m6.z)) * _371._m6.w;
    _997.z = min(_995 - 1.0, floor(_1030));
    uint _1046 = uint((_997.x + (_997.y * _991)) + ((_997.z * _991) * _993));
    _1046 = min(_1046, uint(((_991 * _993) * _995) - 1.0));
    bool _1071 = true;
    vec3 _1073 = _335._m6;
    bool _1076 = _1071;
    _335._m7 = _59(_1073, _1076);
    vec3 _1080 = _335._m7;
    mat3 _1083 = _335._m17;
    _335._m6 = _66(_1080, _1083);
    vec3 _1088 = _335._m8;
    mat3 _1091 = _335._m17;
    bool _1094 = _1071;
    _335._m8 = _72(_1088, _1091, _1094);
    uint _1098 = 0u;
    uint _1099 = 0u;
    uint _1100 = 0u;
    uint _1101 = 0u;
    uint _1102 = 0u;
    uint _1103 = 0u;
    int _1105 = 256;
    _1107 _1109;
    _1109._m0 = _1114._m0[_1046]._m0;
    _1109._m1 = _1114._m0[_1046]._m1;
    int _1123 = _1109._m0 & (~(_1109._m0 >> 31));
    int _1132 = _1109._m1 & (~(_1109._m1 >> 31));
    _1098 = uint((_1123 >> 16) * _1105);
    _1099 = _1098 + uint(_1132 & 255);
    _1100 = _1098;
    _1101 = _1100 + uint((_1132 >> 8) & 255);
    _1102 = _1098;
    _1103 = _1102 + uint((_1132 >> 16) & 255);
    float _1167 = _335._m37;
    float _1165 = _36(_1167);
    float _1174 = _1165 - 0.5;
    float _1171 = _10(_1174) * 2.0;
    float _1186 = _1165 * 2.0;
    float _1177 = (_335._m38 * _335._m38) * _10(_1186);
    float _1193 = _1177 + _1171;
    float _1189 = _10(_1193);
    if (_1189 > 0.0039215688593685626983642578125)
    {
        vec3 _1202 = _335._m0;
        float _1209 = _1189 * 1.0;
        float _1210 = 0.0;
        float _1211 = 0.3499999940395355224609375;
        _335._m0 = mix(_335._m0, _33(_1202), vec3(_42(_1209, _1210, _1211) * (1.0 - _335._m3)));
        float _1225 = _1189 * 1.0;
        float _1226 = 0.25;
        float _1227 = 0.5;
        _335._m2 = mix(_335._m2, vec3(0.039999999105930328369140625), vec3(_42(_1225, _1226, _1227)));
        vec3 _1232 = vec3(_335._m17[0].z, _335._m17[1].z, _335._m17[2].z);
        float _1246 = _1232.z + 0.0625;
        float _1240 = _1189 * _10(_1246);
        float _1255 = _1240 * 1.0;
        float _1256 = 0.20000000298023223876953125;
        float _1257 = 1.0;
        _335._m3 = mix(_335._m3, 0.89999997615814208984375, _42(_1255, _1256, _1257));
        float _1266 = _1240 * 1.0;
        float _1267 = 0.449999988079071044921875;
        float _1268 = 0.980000019073486328125;
        float _1261 = _42(_1266, _1267, _1268);
        _335._m6 = normalize(mix(_335._m6, vec3(0.0, 0.0, 1.0), vec3(_1261)));
        _335._m7 = mix(_335._m6, vec3(0.5, 0.5, 1.0), vec3(_1261));
        if (_1240 > 0.980000019073486328125)
        {
            float _1292 = _1240 * _1261;
            float _1293 = 0.980000019073486328125;
            float _1294 = 1.0;
            _1232 = normalize(mix(_1232, vec3(0.0, 0.0, 1.0), vec3(_42(_1292, _1293, _1294))));
            _335._m17[0].z = _1232.x;
            _335._m17[1].z = _1232.y;
            _335._m17[2].z = _1232.z;
        }
    }
    vec3 _1308 = vec3(0.0);
    vec3 _1309 = vec3(_335._m34.x, _335._m34.y, _335._m34.z);
    vec3 _1317 = vec3(_335._m34.w, _335._m35.x, _335._m35.y);
    vec3 _1325 = vec3(_335._m35.z, _335._m35.w, _335._m36.x);
    vec3 _1333 = vec3(_335._m36.y, _335._m36.z, _335._m36.w);
    vec3 _1341 = ((_1309 - (_1317 * _335._m6.y)) + (_1325 * _335._m6.z)) - (_1333 * _335._m6.x);
    float _1365 = _357._m27.x * _371._m7.x;
    _1308 += max(_1341 * _10(_1365), vec3(0.0));
    vec3 _1371 = vec3(0.0);
    vec3 _1372 = vec3(_335._m34.x, _335._m34.y, _335._m34.z);
    vec3 _1380 = vec3(_335._m34.w, _335._m35.x, _335._m35.y);
    vec3 _1388 = vec3(_335._m35.z, _335._m35.w, _335._m36.x);
    vec3 _1396 = vec3(_335._m36.y, _335._m36.z, _335._m36.w);
    vec3 _1404 = ((_1372 - (_1380 * _335._m8.y)) + (_1388 * _335._m8.z)) - (_1396 * _335._m8.x);
    float _1427 = _357._m27.x * _371._m7.x;
    _1371 += max(_1404 * _10(_1427), vec3(0.0));
    _1308 = mix(_1308, _1371, vec3(_335._m4));
    float _1444;
    if (dot(_335._m10, vec3(1.0)) > 0.0)
    {
        _1444 = -_335._m3;
    }
    else
    {
        _1444 = _335._m3;
    }
    _335._m3 = _1444;
    _335._m18 = _1308;
    if (_357._m28.x < 1.0)
    {
        vec2 _1464 = gl_FragCoord.xy * 0.00390625;
        float _1469 = TEXTURE_LOD(_1470, vec4(_347.xy * _474._m9.xy, 0.0, 0.0).xy, vec4(_347.xy * _474._m9.xy, 0.0, 0.0).w).x;
        float _1503 = abs(clamp((_357._m28.x - (_1469 * 0.5)) - 0.100000001490116119384765625, -1.0, 0.0));
        _1469 = _10(_1503);
        _1469 *= 600.0;
        _335._m19 += (vec3(_1469) * vec3(1.0, 0.00999999977648258209228515625, 0.0));
    }
    vec3 _1527 = (_335._m18 * _335._m0) + _335._m10;
    _1519 = vec4(_1527.x, _1527.y, _1527.z, _1519.w);
    vec3 _1531 = _335._m6;
    bool _1534 = false;
    vec2 _1535 = _83(_1531, _1534);
    _1530 = vec4(_1535.x, _1535.y, _1530.z, _1530.w);
    float _1539 = _335._m2.x;
    float _1543 = _335._m2.y;
    float _1547 = _335._m2.z;
    float _1551 = _335._m3;
    _1538 = vec4(_45(_1539), _45(_1543), _45(_1547), _86(_1551));
    uint _1556 = uint((_357._m25.x > 0.0) ? 8 : 0);
    uint _1562 = uint(int(_1556 > 0u));
    _1562 |= 2u;
    _1562 |= ((uint(_357._m25.z) & 3u) << uint(4));
    float _1577 = _335._m0.x;
    float _1581 = _335._m0.y;
    float _1585 = _335._m0.z;
    _1576 = vec4(_45(_1577), _45(_1581), _45(_1585), float(_1562) / 255.0);
    vec3 _1600 = _1519.xyz + _357._m29.xyz;
    _1519 = vec4(_1600.x, _1600.y, _1600.z, _1519.w);
}

