// Decals
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _744
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1206
{
    int _m0;
    int _m1;
};

struct _1209
{
    int _m0;
    int _m1;
};

struct _1320
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2319
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3116
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _3881
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 1, binding = 0, std140) uniform _765_767
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
} _767;

layout(set = 0, binding = 0, std140) uniform _776_778
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _778;

layout(set = 2, binding = 0, std140) uniform _878_880
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _880;

layout(set = 0, binding = 12, std430) restrict readonly buffer _1211_1213
{
    _1209 _m0[];
} _1213;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1295_1297
{
    uint _m0[];
} _1297;

layout(set = 0, binding = 14, std140) uniform _1325_1327
{
    vec4 _m0[4096];
} _1327;

layout(set = 0, binding = 15, std140) uniform _1345_1347
{
    vec4 _m0[4096];
} _1347;

layout(set = 0, binding = 16, std140) uniform _1397_1399
{
    vec4 _m0[4096];
} _1399;

layout(set = 0, binding = 18, std140) uniform _2323_2325
{
    vec4 _m0[4096];
} _2325;

layout(set = 0, binding = 19, std140) uniform _2362_2364
{
    vec4 _m0[4096];
} _2364;

layout(set = 0, binding = 20, std140) uniform _2430_2432
{
    vec4 _m0[4096];
} _2432;

layout(set = 0, binding = 22, std140) uniform _3120_3122
{
    vec4 _m0[4095];
} _3122;

layout(set = 0, binding = 24, std140) uniform _3885_3887
{
    vec4 _m0[4096];
} _3887;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4272_4274
{
    vec4 _m0[];
} _4274;

layout(push_constant, std430) uniform _4268_4270
{
    int _m0;
    int _m1;
} _4270;

layout(set = 3, binding = 0) uniform texture2D _907[16384];
layout(set = 0, binding = 5) uniform sampler _915;
layout(set = 3, binding = 2) uniform texture2D _925[16384];
layout(set = 0, binding = 6) uniform sampler _930;
layout(set = 3, binding = 1) uniform texture2D _941[16384];
layout(set = 0, binding = 7) uniform sampler _946;
layout(set = 3, binding = 3) uniform texture2D _955[16384];
layout(set = 0, binding = 8) uniform sampler _960;
layout(set = 3, binding = 7) uniform texture2D _970[16384];
layout(set = 0, binding = 9) uniform sampler _975;
layout(set = 3, binding = 4) uniform texture2D _984[16384];
layout(set = 0, binding = 10) uniform sampler _989;
layout(set = 3, binding = 6) uniform texture2D _998[16384];
layout(set = 0, binding = 11) uniform sampler _1003;
layout(set = 0, binding = 17) uniform SAMPLER_2D _1621;
layout(set = 0, binding = 21) uniform SAMPLER_2D _2678;
layout(set = 0, binding = 23) uniform sampler2DShadow _3444;
layout(set = 0, binding = 25) uniform SAMPLER_2D _4026;
layout(set = 3, binding = 5) uniform texture2D _4267[16384];
layout(set = 0, binding = 3) uniform sampler3D _4278;
layout(set = 0, binding = 4) uniform sampler3D _4279;

layout(location = 2) in vec4 _758;
layout(location = 6) in vec4 _783;
layout(location = 3) in vec4 _795;
layout(location = 4) in vec4 _798;
layout(location = 5) in vec4 _801;
layout(location = 10) in vec4 _819;
layout(location = 11) in vec4 _823;
layout(location = 12) in vec4 _827;
layout(location = 14) flat in uvec3 _840;
layout(location = 15) in vec4 _843;
layout(location = 0) out vec4 _4185;
layout(location = 1) out vec4 _4193;
layout(location = 2) out vec4 _4201;
layout(location = 3) out vec4 _4219;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _133(float _129, vec4 _130, float _131, bool _132)
{
    float _599 = _130.w / (_129 + _130.z);
    return _599 * _131;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _138(vec3 _136, bool _137)
{
    vec3 _612 = (_136 * 2.0) - vec3(1.0);
    float _629 = (1.0 - (_612.x * _612.x)) - (_612.y * _612.y);
    _612.z = sqrt(_10(_629));
    if (_137 == false)
    {
        _612.z = -_612.z;
    }
    return _612;
}

vec3 _145(vec3 _143, mat3 _144)
{
    return normalize(vec3(dot(_143, _144[0]), dot(_143, _144[1]), dot(_143, _144[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _88(uint _87)
{
    return unpackUnorm4x8(_87).wzyx;
}

vec4 _101(uvec2 _100)
{
    return vec4(float((_100.x >> uint(16)) & 65535u), float(_100.x & 65535u), float((_100.y >> uint(16)) & 65535u), float(_100.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _52(float _51)
{
    return _51 * ((_51 * ((_51 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _91(uint _90)
{
    return vec4(float((_90 >> uint(24)) & 255u), float((_90 >> uint(16)) & 255u), float((_90 >> uint(8)) & 255u), float(_90 & 255u));
}

float _80(float _79)
{
    return (step(0.0, _79) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _55(vec3 _54)
{
    float _260 = _54.x;
    vec3 _259;
    _259.x = _52(_260);
    float _266 = _54.y;
    _259.y = _52(_266);
    float _272 = _54.z;
    _259.z = _52(_272);
    return _259;
}

vec4 _58(vec4 _57)
{
    vec3 _282 = _57.xyz;
    vec4 _281 = vec4(_55(_282), 1.0);
    float _290 = _57.w;
    _281.w = _52(_290);
    return _281;
}

float _64(float _63)
{
    return _63 * _63;
}

vec3 _61(vec3 _60)
{
    return _60 * _60;
}

float _69(float _66, float _67, float _68)
{
    float _316 = (_66 - _67) / (_68 - _67);
    return _10(_316);
}

vec3 _95(uint _94)
{
    return vec3(float((_94 >> uint(21)) & 2047u), float((_94 >> uint(10)) & 2047u), float(_94 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _205 = abs(_48) >= abs(_46);
    bool _213;
    if (_205)
    {
        _213 = abs(_48) >= abs(_47);
    }
    else
    {
        _213 = _205;
    }
    if (_213)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _72(float _71)
{
    return exp2(_71);
}

vec3 _104(uint _103)
{
    uint _414 = _103;
    vec4 _413 = _88(_414);
    float _425 = (_413.w * 255.0) - 128.0;
    return _413.xyz * _72(_425);
}

float _77(float _75, float _76)
{
    return pow(_75, _76);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _109(vec3 _107, float _108)
{
    float _437 = 50.0 * dot(_107, vec3(0.33329999446868896484375));
    float _430 = _10(_437);
    float _446 = 1.0 - _108;
    float _449 = _10(_446);
    float _450 = 5.0;
    vec3 _454 = _107 + ((vec3(_430) - _107) * _77(_449, _450));
    return _16(_454);
}

vec3 _117(vec3 _112, vec3 _113, vec3 _114, vec3 _115, float _116)
{
    vec3 _458 = normalize(_113 + _114);
    float _463 = 1.0 - (_116 * 0.800000011920928955078125);
    _463 *= _463;
    _463 *= _463;
    float _474 = _463 * _463;
    float _482 = dot(_112, _458);
    float _478 = _10(_482);
    float _484 = ((_478 * _478) * (_474 - 1.0)) + 1.0;
    _484 = _474 / ((_484 * _484) + 9.9999999392252902907785028219223e-09);
    float _503 = dot(_112, _113);
    float _499 = (_10(_503) * (1.0 - _463)) + _463;
    float _514 = dot(_112, _114);
    float _510 = (_10(_514) * (1.0 - _463)) + _463;
    _484 /= (((4.0 * _499) * _510) + 9.9999999392252902907785028219223e-09);
    vec3 _532 = _115;
    float _534 = dot(_114, _458);
    return _109(_532, _534) * _484;
}

vec3 _124(vec3 _120, vec3 _121, vec3 _122, float _123)
{
    float _540 = 1.0 - (_123 * 0.800000011920928955078125);
    _540 *= _540;
    _540 *= _540;
    float _550 = _540 * _540;
    float _558 = dot(_120, _121);
    float _554 = _10(_558);
    float _560 = ((_554 * _554) * (_550 - 1.0)) + 1.0;
    _560 = _550 / ((_560 * _560) + 9.9999999392252902907785028219223e-09);
    float _578 = dot(_120, _121);
    float _574 = (_10(_578) * (1.0 - _540)) + _540;
    _560 /= (((4.0 * _574) * _574) + 9.9999999392252902907785028219223e-09);
    vec3 _592 = _122;
    return _16(_592) * _560;
}

vec2 _151(vec2 _150)
{
    return (vec2(1.0) - abs(_150.yx)) * vec2((_150.x >= 0.0) ? 1.0 : (-1.0), (_150.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _156(inout vec3 _154, bool _155)
{
    _154 /= vec3((abs(_154.x) + abs(_154.y)) + abs(_154.z));
    vec2 _696;
    if (_154.z >= 0.0)
    {
        _696 = _154.xy;
    }
    else
    {
        vec2 _702 = _154.xy;
        _696 = _151(_702);
    }
    _154 = vec3(_696.x, _696.y, _154.z);
    if (_155)
    {
        vec2 _717 = (_154.xy * 0.5) + vec2(0.5);
        _154 = vec3(_717.x, _717.y, _154.z);
    }
    return _154.xy;
}

float _83(float _82)
{
    return sqrt(_82);
}

float _159(float _158)
{
    float _727 = abs(_158);
    float _724 = _83(_727);
    float _731;
    if (_158 > 0.0)
    {
        _731 = _724;
    }
    else
    {
        _731 = -_724;
    }
    return (_731 * 0.5) + 0.5;
}

void main()
{
    _744 _746 = _744(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _746._m15 = _758;
    _746._m16 = gl_FragCoord;
    _746._m40 = (uint(_767._m8.z) & 3u) << uint(4);
    _746._m14 = _778._m2.xyz + _783.xyz;
    _746._m13 = normalize(-_783.xyz);
    _746._m17 = mat3(vec3(_795.xyz), vec3(_798.xyz), vec3(_801.xyz));
    _746._m34 = _819;
    _746._m35 = _823;
    _746._m36 = _827;
    uint _830 = 0u;
    vec4 _831 = vec4(0.0);
    vec4 _832 = vec4(0.0);
    vec4 _833 = vec4(0.0);
    vec4 _834 = vec4(0.0);
    vec4 _835 = vec4(0.0);
    uvec3 _838 = _840;
    vec3 _842 = _843.xyz;
    bool _849 = _838.y == 65535u;
    bool _855;
    if (_849)
    {
        _855 = _838.z == 65535u;
    }
    else
    {
        _855 = _849;
    }
    bool _846 = _855;
    bool _856 = !_846;
    bool _859 = _838.z != 65535u;
    uint _863 = _838.x & 7u;
    uint _873;
    if (_778._m4.x == 0.0)
    {
        _873 = _863;
    }
    else
    {
        vec4 _882 = _880._m6;
        uvec4 _877 = _32(_882);
        uint _886 = _877[_863 / 2u];
        uint _891 = 16u * (_863 & 1u);
        _873 = (_886 >> _891) & 65535u;
    }
    uint _900 = _873;
    uint _909 = _900;
    vec3 _902 = texture(sampler2D(_907[nonuniformEXT(_909)], _915), _746._m15.zw).xyz;
    uint _927 = _900;
    vec2 _924 = texture(sampler2D(_925[nonuniformEXT(_927)], _930), _746._m15.zw).yx;
    vec3 _938 = vec3(0.039999999105930328369140625);
    uint _943 = _900;
    _938 = texture(sampler2D(_941[nonuniformEXT(_943)], _946), _746._m15.zw).xyz;
    uint _957 = _900;
    float _954 = texture(sampler2D(_955[nonuniformEXT(_957)], _960), _746._m15.zw).x;
    float _968 = 1.0;
    uint _972 = _900;
    float _969 = texture(sampler2D(_970[nonuniformEXT(_972)], _975), _746._m15.zw).x;
    uint _986 = _900;
    float _983 = texture(sampler2D(_984[nonuniformEXT(_986)], _989), _746._m15.zw).x;
    uint _1000 = _900;
    vec3 _997 = texture(sampler2D(_998[nonuniformEXT(_1000)], _1003), _746._m15.zw).xyz;
    _833 = vec4(_902.x, _902.y, _902.z, _833.w);
    _833.w = _924.y;
    _834 = vec4(_938.x, _938.y, _938.z, _834.w);
    _834.w = _983;
    _835 = vec4(_835.x, _924.x, _835.z, _924.y);
    _831.x = _969;
    _831.y = _968;
    _831.z = _983;
    _831.w = _954;
    _832 = vec4(_997.x, _997.y, _997.z, _832.w);
    vec3 _1036 = (_767._m9.xyz * _880._m7.xyz) * mix(_833.xyz, vec3(1.0), vec3(_767._m9.w));
    _746._m10 = vec3(((_880._m8.x * _831.x) * _831.x) * _767._m10.x) * _1036;
    _746._m10 *= vec3(_778._m5.x);
    _746._m0 = _833.xyz;
    _746._m2 = _834.xyz;
    _746._m1 = _832.xyz;
    _746._m9 = _831.xyz;
    _746._m3 = _831.w;
    _746._m6 = _835.wyz;
    uint _1094 = uint((_767._m8.x > 0.0) ? 8 : 0);
    float _1100 = 16.0;
    float _1102 = 8.0;
    float _1104 = 24.0;
    vec2 _1113 = _746._m16.xy * _778._m6.xy;
    vec3 _1106;
    _1106 = vec3(_1113.x, _1113.y, _1106.z);
    _1106.y = 1.0 - _1106.y;
    
        // FIx for Decals
    _1106.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1126 = floor(_1106.xy * vec2(_1100, _1102));
    _1106 = vec3(_1126.x, _1126.y, _1106.z);
    float _1130 = _746._m16.z;
    vec4 _1133 = _778._m7;
    float _1136 = 1.0;
    bool _1137 = false;
    float _1129 = _133(_1130, _1133, _1136, _1137);
    float _1139 = log2(max(1.0, _1129 / _778._m8.z)) * _778._m8.w;
    _1106.z = min(_1104 - 1.0, floor(_1139));
    uint _1155 = uint((_1106.x + (_1106.y * _1100)) + ((_1106.z * _1100) * _1102));
    _1155 = min(_1155, uint(((_1100 * _1102) * _1104) - 1.0));
    bool _1180 = true;
    vec3 _1182 = _746._m6;
    bool _1185 = _1180;
    _746._m7 = _138(_1182, _1185);
    vec3 _1189 = _746._m7;
    mat3 _1192 = _746._m17;
    _746._m6 = _145(_1189, _1192);
    uint _1197 = 0u;
    uint _1198 = 0u;
    uint _1199 = 0u;
    uint _1200 = 0u;
    uint _1201 = 0u;
    uint _1202 = 0u;
    int _1204 = 256;
    _1206 _1208;
    _1208._m0 = _1213._m0[_1155]._m0;
    _1208._m1 = _1213._m0[_1155]._m1;
    int _1222 = _1208._m0 & (~(_1208._m0 >> 31));
    int _1231 = _1208._m1 & (~(_1208._m1 >> 31));
    _1197 = uint((_1222 >> 16) * _1204);
    _1198 = _1197 + uint(_1231 & 255);
    _1199 = _1197;
    _1200 = _1199 + uint((_1231 >> 8) & 255);
    _1201 = _1197;
    _1202 = _1201 + uint((_1231 >> 16) & 255);
    vec3 _1264 = dFdx(_746._m14);
    vec3 _1268 = dFdy(_746._m14);
    bool _1273 = _1094 == 0u;
    bool _1279;
    if (_1273)
    {
        _1279 = _767._m8.y == 0.0;
    }
    else
    {
        _1279 = _1273;
    }
    _1199 = _1279 ? _1200 : _1199;
    uint _1283 = _1199;
    _1320 _1322;
    vec3 _1675;
    float _1780;
    while (_1283 < _1200)
    {
        uint _1293 = _1297._m0[_1283];
        uint _1302 = (_1293 >> uint(12)) & 4095u;
        uint _1308 = _1302;
        if (_1308 >= _1302)
        {
            _1283++;
        }
        int _1317 = 2;
        int _1318 = 2;
        int _1319 = 2;
        _1322._m0 = _1327._m0[(uint(_1317) * _1308) + 0u];
        _1322._m1 = _1327._m0[(uint(_1317) * _1308) + 1u];
        _1322._m2 = _1347._m0[(uint(_1318) * _1308) + 0u];
        float _1361 = _1347._m0[(uint(_1318) * _1308) + 1u].x;
        _1322._m3.x = _27(_1361);
        float _1371 = _1347._m0[(uint(_1318) * _1308) + 1u].y;
        _1322._m3.y = _27(_1371);
        float _1381 = _1347._m0[(uint(_1318) * _1308) + 1u].z;
        _1322._m4.x = _27(_1381);
        float _1391 = _1347._m0[(uint(_1318) * _1308) + 1u].w;
        _1322._m4.y = _27(_1391);
        float _1405 = _1399._m0[(uint(_1319) * _1308) + 0u].x;
        _1322._m5.x = _27(_1405);
        float _1415 = _1399._m0[(uint(_1319) * _1308) + 0u].y;
        _1322._m5.y = _27(_1415);
        float _1425 = _1399._m0[(uint(_1319) * _1308) + 0u].z;
        _1322._m6 = _27(_1425);
        float _1435 = _1399._m0[(uint(_1319) * _1308) + 0u].w;
        _1322._m7 = _27(_1435);
        float _1445 = _1399._m0[(uint(_1319) * _1308) + 1u].x;
        _1322._m8 = _27(_1445);
        float _1455 = _1399._m0[(uint(_1319) * _1308) + 1u].y;
        _1322._m9 = _27(_1455);
        float _1465 = _1399._m0[(uint(_1319) * _1308) + 1u].z;
        _1322._m10 = _27(_1465);
        float _1476 = _1399._m0[(uint(_1319) * _1308) + 1u].w;
        _1322._m11 = _27(_1476);
        vec4 _1481 = vec4(_746._m14, 1.0);
        vec3 _1488 = vec3(dot(_1481, _1322._m0), dot(_1481, _1322._m1), dot(_1481, _1322._m2));
        float _1502 = 0.0039215688593685626983642578125;
        float _1504 = _1488.x;
        float _1507 = _1488.y;
        float _1510 = _1488.z;
        bool _1515 = _43(_1504, _1507, _1510) <= _1502;
        bool _1532;
        if (!_1515)
        {
            float _1519 = _1488.x;
            float _1522 = _1488.y;
            float _1525 = _1488.z;
            _1532 = _38(_1519, _1522, _1525) >= (1.0 - _1502);
        }
        else
        {
            _1532 = _1515;
        }
        if (_1532)
        {
            continue;
        }
        uint _1536 = _1322._m11;
        bool _1540 = _1094 != 0u;
        bool _1547;
        if (_1540)
        {
            _1547 = (_1536 & 1024u) != 0u;
        }
        else
        {
            _1547 = _1540;
        }
        bool _1560;
        if (!_1547)
        {
            bool _1552 = _1094 == 0u;
            bool _1559;
            if (_1552)
            {
                _1559 = (_1536 & 2048u) != 0u;
            }
            else
            {
                _1559 = _1552;
            }
            _1560 = _1559;
        }
        else
        {
            _1560 = _1547;
        }
        if (_1560)
        {
            continue;
        }
        vec3 _1564 = _1322._m0.xyz;
        vec3 _1568 = _1322._m1.xyz;
        vec3 _1572 = _1322._m2.xyz;
        vec2 _1576 = vec2(dot(_1264, _1564), dot(_1264, _1568));
        vec2 _1584 = vec2(dot(_1268, _1564), dot(_1268, _1568));
        float _1592 = 1.0;
        float _1593 = 1.0;
        vec3 _1594 = vec3(0.5, 0.5, 1.0);
        uint _1596 = _1322._m7;
        uint _1600 = _1322._m9;
        vec4 _1599 = _88(_1600);
        uvec2 _1605 = _1322._m5;
        vec4 _1604 = _101(_1605);
        vec2 _1609 = _1576 * _1604.xy;
        vec2 _1614 = _1584 * _1604.xy;
        vec4 _1619 = TEXTURE_GRAD(_1621, (_1488.xy * _1604.xy) + _1604.zw, _1609, _1614);
        _1592 = _1619.z;
        float _1636 = _1619.w;
        _1593 = _52(_1636);
        bool _1643 = _1593 <= (4.0 * _1502);
        bool _1650;
        if (_1643)
        {
            _1650 = _1599.w <= _1502;
        }
        else
        {
            _1650 = _1643;
        }
        if (_1650)
        {
            continue;
        }
        vec2 _1654 = (_1619.xy * 2.0) - vec2(1.0);
        float _1665 = 1.0 - dot(_1654, _1654);
        _1594 = vec3(_1654, sqrt(_10(_1665)));
        if ((_1536 & 256u) != 0u)
        {
            _1675 = vec3(-_1594.x, -_1594.y, _1594.z);
        }
        else
        {
            _1675 = _1594;
        }
        _1594 = _1675;
        uint _1690 = _1322._m8;
        uint _1694 = _1690;
        float _1693 = 1.0 + (_91(_1694).w * 0.062745101749897003173828125);
        uint _1702 = _1596;
        float _1701 = _88(_1702).z;
        float _1715 = _1693 - (_1693 * abs((_1488.z * 2.0) - 1.0));
        _1593 *= _10(_1715);
        if ((_1596 & 64u) != 0u)
        {
            uint _1726 = _1596;
            float _1725 = _88(_1726).x;
            uint _1731 = _1596;
            float _1730 = _91(_1731).y;
            float _1737 = _1725;
            float _1735 = mix(_1730, 0.0, _10(_1737));
            float _1746 = _1592 - (_1735 / 255.0);
            float _1741 = float(_10(_1746) > 0.0);
            _1593 *= _1741;
        }
        vec3 _1753 = normalize(vec3(_746._m17[0].z, _746._m17[1].z, _746._m17[2].z));
        float _1762 = dot(_1753, normalize(_1572));
        float _1767 = _1762;
        vec2 _1772 = _1594.xy * _80(_1767);
        _1594 = vec3(_1772.x, _1772.y, _1594.z);
        if ((_1536 & 32768u) != 0u)
        {
            float _1785 = abs(_1762);
            _1780 = _10(_1785);
        }
        else
        {
            float _1788 = _1762;
            _1780 = _10(_1788);
        }
        float _1775 = _1780;
        float _1792 = _1593 * _1775;
        uint _1796 = _1322._m6;
        uint _1800 = _1796;
        vec4 _1805 = _88(_1800) * _1792;
        vec4 _1799 = _22(_1805);
        _746._m11 = max(_746._m11, _1799.x);
        _1564 += (_1753 * dot(_1564, _1753));
        _1568 += (_1753 * dot(_1568, _1753));
        _1594 = ((normalize(_1564) * _1594.x) + (normalize(_1568) * _1594.y)) + (_1753 * _1594.z);
        if ((_1536 & 512u) != 0u)
        {
            vec3 _1849 = mix(_1753, _1594, _1799.www);
            float _1855 = dot(_1849, _1753);
            _1594 = (_746._m6 * _1855) + ((_1849 - (_1753 * _1855)) * dot(_746._m6, _1753));
        }
        else
        {
            if ((_1536 & 128u) != 0u)
            {
                _1594 = mix(mix(_746._m6, _1753, vec3(_1792)), _1594, _1799.www);
            }
            else
            {
                _1594 = mix(_746._m6, _1594, _1799.www);
            }
        }
        _746._m6 = normalize(_1594);
        uint _1902 = _1690;
        vec3 _1901 = _88(_1902).xyz;
        float _1906 = _1593;
        if ((_1596 & 1u) != 0u)
        {
            uvec2 _1914 = _1322._m3;
            vec4 _1913 = _101(_1914);
            vec2 _1918 = _1576 * _1913.xy;
            vec2 _1923 = _1584 * _1913.xy;
            vec4 _1928 = TEXTURE_GRAD(_1621, (_1488.xy * _1913.xy) + _1913.zw, _1918, _1923);
            vec4 _1941 = _1928;
            _1928 = _58(_1941);
            float _1951 = (_1928.w - _1502) / (1.0 - _1502);
            _1906 = _10(_1951);
            _1901 *= _1928.xyz;
        }
        _746._m0 = mix(_746._m0, _1901, _1799.xxx);
        float _1964 = ((_1775 * _1906) * _1599.w) * _1701;
        _746._m10 += (_1599.xyz * (_1964 * 64.0));
        uint _1983 = _1322._m10;
        uint _1987 = _1983;
        vec4 _1986 = _88(_1987);
        float _1990 = 0.0;
        if ((_1596 & 10u) != 0u)
        {
            uvec2 _1998 = _1322._m4;
            vec4 _1997 = _101(_1998);
            vec2 _2002 = _1576 * _1997.xy;
            vec2 _2007 = _1584 * _1997.xy;
            vec4 _2012 = TEXTURE_GRAD(_1621, (_1488.xy * _1997.xy) + _1997.zw, _2002, _2007);
            if ((_1596 & 2u) != 0u)
            {
                _1986 = _2012 * _2012;
            }
            else
            {
                _1990 = _2012.w;
            }
        }
        _746._m2 = mix(_746._m2, _1986.xyz, _1799.yyy);
        _746._m3 = mix(_746._m3, _1986.w, _1799.z);
        _746._m37 = max(_746._m37, _1990);
        float _2064 = (_1592 - 0.5) * 2.0;
        _746._m38 = max(_746._m38, _10(_2064));
    }
    float _2069 = _746._m37;
    float _2068 = _64(_2069);
    float _2076 = _2068 - 0.5;
    float _2073 = _10(_2076) * 2.0;
    float _2087 = _2068 * 2.0;
    float _2079 = (_746._m38 * _746._m38) * _10(_2087);
    float _2094 = _2079 + _2073;
    float _2090 = _10(_2094);
    if (_2090 > 0.0039215688593685626983642578125)
    {
        vec3 _2102 = _746._m0;
        float _2109 = _2090 * 1.0;
        float _2110 = 0.0;
        float _2111 = 0.3499999940395355224609375;
        _746._m0 = mix(_746._m0, _61(_2102), vec3(_69(_2109, _2110, _2111) * (1.0 - _746._m3)));
        float _2125 = _2090 * 1.0;
        float _2126 = 0.25;
        float _2127 = 0.5;
        _746._m2 = mix(_746._m2, vec3(0.039999999105930328369140625), vec3(_69(_2125, _2126, _2127)));
        vec3 _2132 = vec3(_746._m17[0].z, _746._m17[1].z, _746._m17[2].z);
        float _2146 = _2132.z + 0.0625;
        float _2140 = _2090 * _10(_2146);
        float _2155 = _2140 * 1.0;
        float _2156 = 0.20000000298023223876953125;
        float _2157 = 1.0;
        _746._m3 = mix(_746._m3, 0.89999997615814208984375, _69(_2155, _2156, _2157));
        float _2166 = _2140 * 1.0;
        float _2167 = 0.449999988079071044921875;
        float _2168 = 0.980000019073486328125;
        float _2161 = _69(_2166, _2167, _2168);
        _746._m6 = normalize(mix(_746._m6, vec3(0.0, 0.0, 1.0), vec3(_2161)));
        _746._m7 = mix(_746._m6, vec3(0.5, 0.5, 1.0), vec3(_2161));
        if (_2140 > 0.980000019073486328125)
        {
            float _2191 = _2140 * _2161;
            float _2192 = 0.980000019073486328125;
            float _2193 = 1.0;
            _2132 = normalize(mix(_2132, vec3(0.0, 0.0, 1.0), vec3(_69(_2191, _2192, _2193))));
            _746._m17[0].z = _2132.x;
            _746._m17[1].z = _2132.y;
            _746._m17[2].z = _2132.z;
        }
    }
    vec3 _2207 = vec3(0.0);
    vec3 _2208 = vec3(_746._m34.x, _746._m34.y, _746._m34.z);
    vec3 _2216 = vec3(_746._m34.w, _746._m35.x, _746._m35.y);
    vec3 _2224 = vec3(_746._m35.z, _746._m35.w, _746._m36.x);
    vec3 _2232 = vec3(_746._m36.y, _746._m36.z, _746._m36.w);
    vec3 _2240 = ((_2208 - (_2216 * _746._m6.y)) + (_2224 * _746._m6.z)) - (_2232 * _746._m6.x);
    float _2263 = _767._m11.x * _778._m9.x;
    _2207 += max(_2240 * _10(_2263), vec3(0.0));
    float _2273;
    if (dot(_746._m10, vec3(1.0)) > 0.0)
    {
        _2273 = -_746._m3;
    }
    else
    {
        _2273 = _746._m3;
    }
    _746._m3 = _2273;
    _746._m18 = _2207;
    _746._m19 = _2207;
    uint _2290 = _1197;
    _2319 _2321;
    vec3 _2639;
    float _2728;
    float _2746;
    uint _3090;
    _3116 _3118;
    uint _3240;
    _3116 _3264;
    while (_2290 < _1198)
    {
        uint _2300 = _1297._m0[_2290];
        uint _2304 = _2300 & 4095u;
        uint _2307 = _2304;
        if (_2307 >= _2304)
        {
            _2290++;
        }
        int _2316 = 4;
        int _2317 = 4;
        int _2318 = 4;
        _2321._m0 = _2325._m0[(uint(_2316) * _2307) + 0u].xyz;
        float _2340 = _2325._m0[(uint(_2316) * _2307) + 0u].w;
        _2321._m1 = _27(_2340);
        _2321._m2 = _2325._m0[(uint(_2316) * _2307) + 1u];
        _2321._m3 = _2325._m0[(uint(_2316) * _2307) + 2u];
        _2321._m4 = _2364._m0[(uint(_2317) * _2307) + 0u];
        _2321._m5 = _2364._m0[(uint(_2317) * _2307) + 1u];
        _2321._m6 = _2364._m0[(uint(_2317) * _2307) + 2u];
        float _2394 = _2325._m0[(uint(_2316) * _2307) + 3u].x;
        _2321._m7.x = _27(_2394);
        float _2404 = _2325._m0[(uint(_2316) * _2307) + 3u].y;
        _2321._m7.y = _27(_2404);
        float _2414 = _2325._m0[(uint(_2316) * _2307) + 3u].z;
        _2321._m7.z = _27(_2414);
        float _2424 = _2325._m0[(uint(_2316) * _2307) + 3u].w;
        _2321._m7.w = _27(_2424);
        _2321._m8 = _2432._m0[(uint(_2318) * _2307) + 0u];
        _2321._m9 = _2432._m0[(uint(_2318) * _2307) + 1u];
        _2321._m10 = _2432._m0[(uint(_2318) * _2307) + 2u];
        _2321._m11 = _2432._m0[(uint(_2318) * _2307) + 3u];
        float _2470 = _2364._m0[(uint(_2317) * _2307) + 3u].x;
        _2321._m12 = _27(_2470);
        float _2480 = _2364._m0[(uint(_2317) * _2307) + 3u].y;
        _2321._m13 = _27(_2480);
        _2321._m14 = _2364._m0[(uint(_2317) * _2307) + 3u].z;
        float _2498 = _2364._m0[(uint(_2317) * _2307) + 3u].w;
        _2321._m15 = _27(_2498);
        uint _2503 = (_2321._m12 >> uint(16)) & 3u;
        if (((_746._m40 >> uint(4)) & 3u) != _2503)
        {
            continue;
        }
        float _2517 = 0.0039215688593685626983642578125;
        vec4 _2518 = vec4(_746._m14, 1.0);
        float _2525 = 1.0 / dot(_2518, _2321._m6);
        vec3 _2531 = vec3(dot(_2518, _2321._m4) * _2525, dot(_2518, _2321._m5) * _2525, dot(_2518, _2321._m3));
        uint _2549 = _2321._m1;
        uint _2552 = _1094;
        _2552 |= 64u;
        float _2556 = _2531.x;
        float _2559 = _2531.y;
        float _2562 = _2531.z;
        bool _2567 = _43(_2556, _2559, _2562) <= _2517;
        bool _2584;
        if (!_2567)
        {
            float _2571 = _2531.x;
            float _2574 = _2531.y;
            float _2577 = _2531.z;
            _2584 = _38(_2571, _2574, _2577) >= (1.0 - _2517);
        }
        else
        {
            _2584 = _2567;
        }
        bool _2592;
        if (!_2584)
        {
            _2592 = (_2549 & _2552) != 0u;
        }
        else
        {
            _2592 = _2584;
        }
        if (_2592)
        {
            continue;
        }
        if ((_2549 & 3u) == 2u)
        {
            vec2 _2611 = fract((_2531.xy * _778._m10.xy) + _778._m10.zw);
            _2531 = vec3(_2611.x, _2611.y, _2531.z);
        }
        vec3 _2614 = _2321._m0;
        float _2617 = 1.0;
        float _2618 = 1.0;
        vec3 _2619 = vec3(0.0, 0.0, 1.0);
        vec3 _2620 = vec3(0.0, 0.0, 1.0);
        uint _2621 = _2321._m1;
        vec3 _2624 = (_2531 * 2.0) - vec3(1.0);
        vec2 _2629 = _2531.xy;
        vec3 _2632 = _2321._m10.xyz;
        if ((_2621 & 3u) == 2u)
        {
            _2639 = _2632;
        }
        else
        {
            _2639 = normalize(_2614 - _746._m14);
        }
        _2619 = _2639;
        _2619 = _2619;
        float _2656 = dot(_746._m6, _2619);
        float _2651 = _10(_2656);
        bool _2660 = _2651 <= _2517;
        bool _2667;
        if (_2660)
        {
            _2667 = (_2621 & 48u) == 0u;
        }
        else
        {
            _2667 = _2660;
        }
        if (_2667)
        {
            continue;
        }
        uvec2 _2672 = _2321._m7.zw;
        vec4 _2671 = _101(_2672);
        float _2677 = TEXTURE_LOD(_2678, vec4((_2629 * _2671.xy) + _2671.zw, 0.0, 0.0).xy, vec4((_2629 * _2671.xy) + _2671.zw, 0.0, 0.0).w).x;
        float _2704 = _2677 * _2677;
        uint _2708 = _2621 & 3u;
        bool _2713 = _2708 == 1u;
        bool _2725;
        if (!_2713)
        {
            bool _2718 = _2708 == 0u;
            bool _2724;
            if (_2718)
            {
                _2724 = _2321._m8.z != 0.0;
            }
            else
            {
                _2724 = _2718;
            }
            _2725 = _2724;
        }
        else
        {
            _2725 = _2713;
        }
        bool _2711 = _2725;
        if (_2711)
        {
            float _2731 = _2321._m8.w;
            _2728 = _10(_2731);
        }
        else
        {
            _2728 = 0.5;
        }
        float _2726 = _2728;
        bool _2739 = _2708 == 0u;
        bool _2745;
        if (_2739)
        {
            _2745 = _2321._m8.z != 0.0;
        }
        else
        {
            _2745 = _2739;
        }
        if (_2745)
        {
            float _2754 = sqrt(dot(_2624, _2624));
            _2746 = min(0.9921875, _10(_2754));
        }
        else
        {
            _2746 = _2531.z;
        }
        float _2737 = _2746;
        uvec2 _2762 = _2321._m7.xy;
        vec4 _2761 = _101(_2762);
        vec2 _2767 = vec2(_2737, _2726);
        float _2771 = TEXTURE_LOD(_2678, vec4((_2767 * _2761.xy) + _2761.zw, 0.0, 0.0).xy, vec4((_2767 * _2761.xy) + _2761.zw, 0.0, 0.0).w).x;
        _2771 *= _2771;
        _2617 = _2771 * _2704;
        if ((_2621 & 48u) != 0u)
        {
            vec4 _2808 = _2321._m10;
            vec4 _2811 = _2321._m8;
            vec4 _2814 = _2321._m9;
            float _2817 = dot(_746._m14, _2808.xyz) + _2808.w;
            if (_2817 < 0.0)
            {
                continue;
            }
            float _2831 = length(_2808.xyz);
            float _2838 = _2817 * 50.0;
            float _2835 = _10(_2838);
            _2617 *= (_2835 * _2835);
            _2817 /= _2831;
            _2808 /= vec4(_2831);
            vec3 _2852 = reflect(-_746._m13, _746._m6);
            if (dot(_2852, _2808.xyz) > 0.0)
            {
                _2852 = reflect(_2852, _2808.xyz);
            }
            float _2870 = dot(_2852, _2808.xyz);
            float _2875 = _2817 / _2870;
            vec3 _2879 = _746._m14 - (_2852 * _2875);
            vec3 _2886 = _2879 - _2614;
            float _2890 = dot(_2886, _2811.xyz) / _2811.w;
            float _2898 = dot(_2886, _2814.xyz) / _2814.w;
            if ((_2621 & 48u) == 32u)
            {
                vec2 _2912 = vec2(_2890, _2898);
                float _2916 = 1.0 / max(1.0, length(vec2(_2890, _2898)));
                _2890 *= (_2916 * _2811.w);
                _2898 *= (_2916 * _2814.w);
            }
            else
            {
                float _2938 = abs(_2890);
                float _2940 = _2890;
                _2890 = (_10(_2938) * _80(_2940)) * _2811.w;
                float _2949 = abs(_2898);
                float _2951 = _2898;
                _2898 = (_10(_2949) * _80(_2951)) * _2814.w;
            }
            vec3 _2958 = (_2811.xyz * _2890) + (_2814.xyz * _2898);
            _2614 += _2958;
            _2619 = normalize(_2614 - _746._m14);
            _2619 = _2619;
        }
        else
        {
            uint _2978 = (_2321._m15 >> uint(16)) & 255u;
            if (_2978 == 0u)
            {
                vec4 _2987 = _2321._m9;
                if (dot(_2987.xyz, _746._m14) < (_2987.w - _2517))
                {
                    continue;
                }
            }
            else
            {
                if (_2978 == 1u)
                {
                    vec3 _3008 = _2321._m9.xyz;
                    float _3013 = _2321._m9.w;
                    uint _3017 = _27(_3013);
                    vec3 _3012 = (((_95(_3017) * 2.0) - vec3(1.0)) * _3008) + _2614;
                    vec3 _3026 = abs((_746._m14 - _3012) / _3008);
                    float _3034 = _3026.x;
                    float _3037 = _3026.y;
                    float _3040 = _3026.z;
                    if (_38(_3034, _3037, _3040) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2617 <= (_2517 / 256.0))
        {
            continue;
        }
        float _3056 = 1.0;
        if ((_2549 & 4u) != 0u)
        {
            float _3063 = float(_2321._m15 & 255u) / 255.0;
            float _3069 = 0.00999999977648258209228515625;
            vec3 _3071 = _746._m14 + (_746._m6 * _3069);
            if ((_2549 & 3u) == 0u)
            {
                vec3 _3084 = _3071 - _2321._m2.xyz;
                float _3091 = _3084.x;
                float _3094 = _3084.y;
                float _3097 = _3084.z;
                _3090 = _49(_3091, _3094, _3097);
            }
            else
            {
                if ((_2549 & 3u) == 2u)
                {
                    float _3107 = 0.0;
                    _3090 = 0u;
                    for (; _3090 < 3u; _3090++)
                    {
                        int _3115 = 5;
                        _3118._m0 = _3122._m0[(uint(_3115) * ((_2549 >> uint(22)) + _3090)) + 0u];
                        _3118._m1 = _3122._m0[(uint(_3115) * ((_2549 >> uint(22)) + _3090)) + 1u];
                        _3118._m2 = _3122._m0[(uint(_3115) * ((_2549 >> uint(22)) + _3090)) + 2u];
                        _3118._m3 = _3122._m0[(uint(_3115) * ((_2549 >> uint(22)) + _3090)) + 3u];
                        _3118._m4 = _3122._m0[(uint(_3115) * ((_2549 >> uint(22)) + _3090)) + 4u];
                        vec2 _3179 = vec2(dot(_3071, _3118._m0.xyz) + _3118._m0.w, dot(_3071, _3118._m1.xyz) + _3118._m1.w);
                        _3179 = abs((_3179 * 2.0) - vec2(1.0));
                        bool _3205 = _3179.x < 0.99500000476837158203125;
                        bool _3211;
                        if (_3205)
                        {
                            _3211 = _3179.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3211 = _3205;
                        }
                        if (_3211)
                        {
                            _3107 = (1.0 - max(_3179.x, _3179.y)) * _778._m11.w;
                            break;
                        }
                    }
                    _3090 = min(2u, _3090);
                    uint _3228 = uint(_746._m16.x) ^ (uint(_746._m16.y) << uint(1));
                    if (_778._m12.w > 0.0)
                    {
                        _3240 = uint(_778._m13.x);
                    }
                    else
                    {
                        _3240 = 0u;
                    }
                    _3228 ^= _3240;
                    _3090 += uint(int(((float(_3228 & 3u) * 0.25) + 0.125) > _3107));
                }
                else
                {
                    _3090 = 0u;
                }
            }
            int _3263 = 5;
            _3264._m0 = _3122._m0[(uint(_3263) * ((_2549 >> uint(22)) + _3090)) + 0u];
            _3264._m1 = _3122._m0[(uint(_3263) * ((_2549 >> uint(22)) + _3090)) + 1u];
            _3264._m2 = _3122._m0[(uint(_3263) * ((_2549 >> uint(22)) + _3090)) + 2u];
            _3264._m3 = _3122._m0[(uint(_3263) * ((_2549 >> uint(22)) + _3090)) + 3u];
            _3264._m4 = _3122._m0[(uint(_3263) * ((_2549 >> uint(22)) + _3090)) + 4u];
            vec4 _3320 = vec4((_3071.x * _3264._m0.x) + ((_3071.y * _3264._m0.y) + ((_3071.z * _3264._m0.z) + _3264._m0.w)), (_3071.x * _3264._m1.x) + ((_3071.y * _3264._m1.y) + ((_3071.z * _3264._m1.z) + _3264._m1.w)), (_3071.x * _3264._m2.x) + ((_3071.y * _3264._m2.y) + ((_3071.z * _3264._m2.z) + _3264._m2.w)), (_3071.x * _3264._m3.x) + ((_3071.y * _3264._m3.y) + ((_3071.z * _3264._m3.z) + _3264._m3.w)));
            vec3 _3407 = _3320.xyz / vec3(_3320.w);
            _3320 = vec4(_3407.x, _3407.y, _3407.z, _3320.w);
            bool _3415 = min(_3320.x, _3320.y) > 0.0;
            bool _3424;
            if (_3415)
            {
                _3424 = max(_3320.x, _3320.y) < 1.0;
            }
            else
            {
                _3424 = _3415;
            }
            if (_3424)
            {
                vec2 _3436 = (_3320.xy * _3264._m4.xy) + _3264._m4.zw;
                _3320 = vec4(_3436.x, _3436.y, _3320.z, _3320.w);
                if (false)
                {
                    _3056 = textureLod(_3444, vec3(_3320.xyz.xy, _3320.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3451 = (_3320.xy * _778._m14.xy) + vec2(0.5);
                    vec2 _3460 = floor(_3451);
                    vec2 _3463 = _3451 - _3460;
                    _3460 -= vec2(0.5);
                    vec2 _3470 = vec2(4.0) - (_3463 * 3.0);
                    vec2 _3476 = vec2(7.0);
                    vec2 _3479 = vec2(1.0) + (_3463 * 3.0);
                    vec2 _3484 = (_3460 + (((vec2(3.0) - (_3463 * 2.0)) / _3470) - vec2(2.0))) * _778._m14.zw;
                    vec2 _3499 = (_3460 + ((vec2(3.0) + _3463) / _3476)) * _778._m14.zw;
                    vec2 _3511 = (_3460 + ((_3463 / _3479) + vec2(2.0))) * _778._m14.zw;
                    vec3 _3535 = vec3(_3484.x, _3484.y, _3320.z);
                    _3056 = (_3470.x * _3470.y) * textureLod(_3444, vec3(_3535.xy, _3535.z), 0.0);
                    vec3 _3551 = vec3(_3499.x, _3484.y, _3320.z);
                    _3056 += ((_3476.x * _3470.y) * textureLod(_3444, vec3(_3551.xy, _3551.z), 0.0));
                    vec3 _3569 = vec3(_3511.x, _3484.y, _3320.z);
                    _3056 += ((_3479.x * _3470.y) * textureLod(_3444, vec3(_3569.xy, _3569.z), 0.0));
                    vec3 _3587 = vec3(_3484.x, _3499.y, _3320.z);
                    _3056 += ((_3470.x * _3476.y) * textureLod(_3444, vec3(_3587.xy, _3587.z), 0.0));
                    vec3 _3605 = vec3(_3499.x, _3499.y, _3320.z);
                    _3056 += ((_3476.x * _3476.y) * textureLod(_3444, vec3(_3605.xy, _3605.z), 0.0));
                    vec3 _3623 = vec3(_3511.x, _3499.y, _3320.z);
                    _3056 += ((_3479.x * _3476.y) * textureLod(_3444, vec3(_3623.xy, _3623.z), 0.0));
                    vec3 _3641 = vec3(_3484.x, _3511.y, _3320.z);
                    _3056 += ((_3470.x * _3479.y) * textureLod(_3444, vec3(_3641.xy, _3641.z), 0.0));
                    vec3 _3659 = vec3(_3499.x, _3511.y, _3320.z);
                    _3056 += ((_3476.x * _3479.y) * textureLod(_3444, vec3(_3659.xy, _3659.z), 0.0));
                    vec3 _3677 = vec3(_3511.x, _3511.y, _3320.z);
                    _3056 += ((_3479.x * _3479.y) * textureLod(_3444, vec3(_3677.xy, _3677.z), 0.0));
                    _3056 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3056 = float((_2549 & 3u) == 2u);
            }
            float _3691 = float((_2549 >> uint(16)) & 63u) / 63.0;
            float _3705 = ((_3056 * _3691) + 1.0) - _3691;
            _3056 = _10(_3705);
        }
        uint _3708 = _2321._m13;
        vec3 _3707 = (_104(_3708) * _3056) * _2617;
        _2618 *= _2321._m14;
        vec3 _3720 = _3707;
        vec3 _3722 = _2619;
        float _3729 = dot(_746._m6, _3722);
        float _3724 = _10(_3729);
        vec3 _3735 = _746._m6;
        vec3 _3738 = _746._m13;
        vec3 _3741 = _2619;
        vec3 _3743 = _746._m2;
        float _3746 = abs(_746._m3);
        vec3 _3731 = _117(_3735, _3738, _3741, _3743, _3746);
        _746._m20 += (((_3731 * _2618) * _3720) * _3724);
        vec3 _3760 = mix(_3720, vec3(0.0), bvec3((_2549 & 256u) > 0u));
        _746._m19 += (_3760 * _3724);
    }
    float _3775 = _778._m15.x;
    if (_3775 > 0.00999999977648258209228515625)
    {
        float _3782 = float(int(_778._m13.x) & 1023) / 1023.0;
        _3775 = max(0.0, _3775 + (((_3782 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _3798 = _746._m13;
        float _3806 = dot(_746._m6, _3798);
        float _3801 = _10(_3806);
        float _3808 = _3801 * _3775;
        vec3 _3816 = _746._m6;
        vec3 _3819 = _746._m13;
        vec3 _3822 = _746._m2;
        float _3825 = abs(_746._m3);
        vec3 _3812 = _124(_3816, _3819, _3822, _3825) * _3775;
        _746._m19 += vec3(_3808);
        _746._m20 += vec3(_3812);
    }
    _746._m19 = _746._m19;
    _746._m20 += _746._m10;
    float _3853 = 0.064999997615814208984375;
    float _3855 = 1.0 + _3853;
    bool _3858 = false;
    uint _3863;
    if (_778._m16.w > 0.00999999977648258209228515625)
    {
        _3863 = uint(_778._m16.x);
    }
    else
    {
        _3863 = 0u;
    }
    uint _3859 = _3863;
    _3881 _3883;
    for (uint _3871 = 0u; _3871 < _3859; _3871++)
    {
        int _3880 = 4;
        _3883._m0 = _3887._m0[(uint(_3880) * _3871) + 0u];
        _3883._m1 = _3887._m0[(uint(_3880) * _3871) + 1u];
        _3883._m2 = _3887._m0[(uint(_3880) * _3871) + 2u];
        float _3917 = _3887._m0[(uint(_3880) * _3871) + 3u].x;
        _3883._m3 = _27(_3917);
        float _3927 = _3887._m0[(uint(_3880) * _3871) + 3u].y;
        _3883._m4 = _27(_3927);
        float _3937 = _3887._m0[(uint(_3880) * _3871) + 3u].z;
        _3883._m5 = _27(_3937);
        vec4 _3942 = vec4(_746._m14, 1.0);
        vec3 _3949 = vec3(dot(_3942, _3883._m1), dot(_3942, _3883._m2), dot(_3942, _3883._m0));
        float _3963 = _3949.x;
        float _3966 = _3949.y;
        float _3969 = _3949.z;
        bool _3973 = _43(_3963, _3966, _3969) >= 0.0;
        bool _3982;
        if (_3973)
        {
            _3982 = max(_3949.x, _3949.y) < 1.0;
        }
        else
        {
            _3982 = _3973;
        }
        bool _3989;
        if (_3982)
        {
            _3989 = _3949.z < _3855;
        }
        else
        {
            _3989 = _3982;
        }
        if (_3989)
        {
            float _3992 = _3949.z;
            vec4 _3995 = vec4(_746._m14, 1.0);
            vec2 _4002 = vec2(0.0);
            _4002 = (((_3995.xy - _778._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4015 = 0.000244140625;
            float _4021 = abs(_746._m6.z) * 2.0;
            _4015 *= _10(_4021);
            vec3 _4025 = vec3(TEXTURE_LOD(_4026, vec4(_4002 + vec2(_4015), 0.0, 0.0).xy, vec4(_4002 + vec2(_4015), 0.0, 0.0).w).x, TEXTURE_LOD(_4026, vec4(_4002, 0.0, 0.0).xy, vec4(_4002, 0.0, 0.0).w).x, TEXTURE_LOD(_4026, vec4(_4002 - vec2(_4015), 0.0, 0.0).xy, vec4(_4002 - vec2(_4015), 0.0, 0.0).w).x);
            float _4089 = 2.0 - (2.0 * (length(_3995.xy - _778._m17.zw) / 16.0));
            _4025 *= _10(_4089);
            float _4096 = 1.0 - _3992;
            float _4093 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4096));
            float _4107 = (_746._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4099 = (_4025 * _4093) * _10(_4107);
            float _4116 = _3855 - _3992;
            float _4110 = (1.0 - _4093) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4116));
            float _4130 = ((-_746._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4120 = (_4025 * _4110) * _10(_4130);
            _4025 = _4099 + _4120;
            float _4141 = 1.02499997615814208984375 - _3992;
            float _4136 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4141));
            float _4144 = _778._m16.w;
            _746._m19 = mix(_746._m19, (_746._m19 * _4025) + (_746._m19 * mix(1.0, 0.5, _4136)), vec3(_4144));
            break;
        }
    }
    _746._m19 *= _746._m0;
    _746._m21 = _746._m19 + _746._m20;
    vec3 _4178 = vec3(0.0);
    _746._m19 += _4178;
    vec3 _4190 = _746._m19 + _746._m20;
    _4185 = vec4(_4190.x, _4190.y, _4190.z, _4185.w);
    vec3 _4194 = _746._m6;
    bool _4197 = false;
    vec2 _4198 = _156(_4194, _4197);
    _4193 = vec4(_4198.x, _4198.y, _4193.z, _4193.w);
    float _4202 = _746._m2.x;
    float _4206 = _746._m2.y;
    float _4210 = _746._m2.z;
    float _4214 = _746._m3;
    _4201 = vec4(_83(_4202), _83(_4206), _83(_4210), _159(_4214));
    _4219 = vec4(0.0, 0.0, 0.0, float((uint(_767._m8.z) & 3u) << uint(4)) / 255.0);
    vec3 _4232 = _746._m19 + _746._m20;
    _4185 = vec4(_4232.x, _4232.y, _4232.z, _4185.w);
    vec3 _4235 = _746._m6;
    bool _4238 = false;
    vec2 _4239 = _156(_4235, _4238);
    _4193 = vec4(_4239.x, _4239.y, _4193.z, _4193.w);
    float _4242 = _746._m2.x;
    float _4246 = _746._m2.y;
    float _4250 = _746._m2.z;
    float _4254 = _746._m3;
    _4201 = vec4(_83(_4242), _83(_4246), _83(_4250), _159(_4254));
    vec3 _4264 = _4185.xyz + _767._m12.xyz;
    _4185 = vec4(_4264.x, _4264.y, _4264.z, _4185.w);
}


