// SKY Flares
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 0, std140) uniform _270_272
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _272;

layout(set = 2, binding = 0, std140) uniform _349_351
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _351;

layout(set = 1, binding = 0, std140) uniform _400_402
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _402;

layout(set = 0, binding = 1, std430) restrict readonly buffer _760_762
{
    vec4 _m0[];
} _762;

layout(push_constant, std430) uniform _756_758
{
    int _m0;
    int _m1;
} _758;

layout(set = 0, binding = 2) uniform SAMPLER_2D _281;
layout(set = 0, binding = 3) uniform SAMPLER_2D _304;
layout(set = 2, binding = 1) uniform SAMPLER_2D _360;
layout(set = 2, binding = 2) uniform SAMPLER_2D _388;
layout(set = 0, binding = 4) uniform sampler3D _511;
layout(set = 0, binding = 5) uniform sampler3D _532;
layout(set = 0, binding = 6) uniform sampler3D _654;

layout(location = 2) in vec4 _361;
layout(location = 0) in vec4 _384;
layout(location = 0) out vec4 _430;
layout(location = 1) out vec4 _702;
layout(location = 2) out vec4 _703;

float _58(vec4 _57)
{
    return _57.z;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _18(float _17)
{
    return _17 * ((_17 * ((_17 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _24(vec3 _23)
{
    float _93 = _23.x;
    vec3 _92;
    _92.x = _18(_93);
    float _99 = _23.y;
    _92.y = _18(_99);
    float _105 = _23.z;
    _92.z = _18(_105);
    return _92;
}

vec4 _30(vec4 _29)
{
    vec3 _115 = _29.xyz;
    vec4 _114 = vec4(_24(_115), 1.0);
    float _123 = _29.w;
    _114.w = _18(_123);
    return _114;
}

vec4 _54(SAMPLER_2D _52, vec2 _53)
{
    vec4 _234 = SAMPLE_TEXTURE(_52, _53);
    vec4 _238 = _234;
    _234 = _30(_238);
    return _234;
}

uint _15(float _14)
{
    return floatBitsToUint(_14);
}

float _67(float _63, vec4 _64, float _65, bool _66)
{
    float _248 = _64.w / (_63 + _64.z);
    return _248 * _65;
}

float _33(float _32)
{
    float _132 = (((-0.15658299624919891357421875) * abs(_32)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_32));
    float _146;
    if (_32 >= 0.0)
    {
        _146 = _132;
    }
    else
    {
        _146 = 3.1415927410125732421875 - _132;
    }
    return _146;
}

float _36(float _35)
{
    float _160;
    if (_35 < 1.0)
    {
        _160 = _35;
    }
    else
    {
        _160 = 1.0 / _35;
    }
    float _157 = _160;
    float _168 = _157 * _157;
    float _172 = 0.087292902171611785888671875;
    _172 = (-0.3018949925899505615234375) + (_172 * _168);
    _172 = 1.0 + (_172 * _168);
    _172 *= _157;
    float _188;
    if (_35 < 1.0)
    {
        _188 = _172;
    }
    else
    {
        _188 = 1.57079637050628662109375 - _172;
    }
    return _188;
}

float _39(float _38)
{
    float _201 = abs(_38);
    float _198 = _36(_201);
    float _205;
    if (_38 < 0.0)
    {
        _205 = -_198;
    }
    else
    {
        _205 = _198;
    }
    return _205;
}

float _44(float _42, float _43)
{
    float _219 = _42 / _43;
    float _215 = _39(_219);
    if (_43 < 0.0)
    {
        _215 += ((_42 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _215;
}

void main()
{
    vec4 _264 = gl_FragCoord;
    float _261 = _58(_264);
    vec2 _267 = gl_FragCoord.xy * _272._m4.zw;
    float _280 = min(TEXTURE_LOD(_281, vec4(_267 * _272._m5.zw, 0.0, 0.0).xy, vec4(_267 * _272._m5.zw, 0.0, 0.0).w).x, TEXTURE_LOD(_304, vec4(_267, 0.0, 0.0).xy, vec4(_267, 0.0, 0.0).w).x);
    float _319 = 1.0 / (1.0 - _280);
    float _323 = 1.0 / (1.0 - _261);
    float _327 = _319 - _323;
    bool _331 = _272._m6.z > 0.0;
    float _339;
    if (_331)
    {
        _339 = abs(_327);
    }
    else
    {
        _339 = _327;
    }
    float _337 = _339;
    float _357 = _337 * (1.0 / _351._m9.x);
    float _347 = _10(_357);
    vec2 _382 = (_361.xy * _351._m10.xy) + vec2(_272._m7.x * _351._m10.z, _272._m7.y * _351._m10.w);
    vec4 _359 = _54(_360, _382) * _384;
    vec2 _389 = _361.xy;
    vec4 _387 = _54(_388, _389);
    _359 *= _351._m7;
    vec3 _415 = _359.xyz + ((vec3(_351._m8.x * _402._m7.x) * _359.xyz) * _387.xyz);
    _359 = vec4(_415.x, _415.y, _415.z, _359.w);
    _359.w *= _347;
    _359.w *= _387.w;
    _430 = _359;
    vec2 _432 = gl_FragCoord.xy * _272._m4.zw;
    
    // Fix for SKY
    _432.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    float _439 = gl_FragCoord.z;
    vec4 _443 = vec4(0.0);
    float _445 = 1.0;
    float _448 = _272._m8.w;
    uint _447 = _15(_448);
    if ((_447 & 6u) != 0u)
    {
        vec2 _458 = _432 + vec2(0.0);
        vec3 _462 = _272._m9.xyz;
        float _466 = 0.100000001490116119384765625;
        float _468 = _272._m10.y;
        float _471 = _272._m9.z;
        float _474 = 0.0;
        float _478 = _439;
        vec4 _480 = _272._m11;
        float _483 = 1.0;
        bool _484 = false;
        float _475 = _67(_478, _480, _483, _484);
        _474 = pow(max(0.0, (_475 - _466) / (_468 - _466)), 0.5);
        _474 = (_474 * (_471 - 1.0)) / _471;
        vec4 _502 = vec4(_458, _474, 0.0);
        vec3 _528 = textureLod(_511, vec4(_502.xyz, 0.0).xyz, vec4(_502.xyz, 0.0).w).xyz;
        _443 = vec4(_528.x, _528.y, _528.z, _443.w);
        vec2 _531 = textureLod(_532, vec4(_502.xyz, 0.0).xyz, vec4(_502.xyz, 0.0).w).xy;
        _443.w = _531.x;
        _445 = _531.y;
    }
    if ((_447 & 2u) != 0u)
    {
        vec4 _560 = vec4(0.0);
        vec3 _561 = _272._m12.xyz;
        float _567 = _439;
        vec4 _569 = _272._m11;
        float _572 = 1.0;
        bool _573 = false;
        float _566 = _67(_567, _569, _572, _573);
        vec3 _575 = mix(_272._m13.xyz, _272._m14.xyz, vec3(_432.x * _272._m5.z));
        vec3 _591 = mix(_272._m15.xyz, _272._m16.xyz, vec3(_432.x * _272._m5.z));
        vec3 _607 = mix(_591, _575, vec3(1.0 - (_432.y * _272._m5.w)));
        vec4 _618 = vec4(0.0);
        vec3 _619 = normalize(_607);
        float _622 = _619.z;
        _618.x = clamp(_33(_622) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _631 = _619.y;
        float _634 = _619.x;
        _618.y = _44(_631, _634) / 6.283185482025146484375;
        _618.z = sqrt(_566 * _272._m17.w);
        _618.z = clamp(_618.z, 0.015625, 0.984375);
        vec3 _661 = textureLod(_654, _618.xyz, _618.w).xyz;
        _560 = vec4(_661.x, _661.y, _661.z, _560.w);
        vec3 _670 = _430.xyz + (_560.xyz * _445);
        _430 = vec4(_670.x, _670.y, _670.z, _430.w);
    }
    if ((_447 & 4u) != 0u)
    {
        vec3 _686 = (_430.xyz * _443.w) + _443.xyz;
        _430 = vec4(_686.x, _686.y, _686.z, _430.w);
    }
    float _689 = _430.w;
    _430.w = _10(_689);
    vec3 _699 = _430.xyz * _430.w;
    _430 = vec4(_699.x, _699.y, _699.z, _430.w);
    _702 = vec4(0.0);
    _703 = vec4(0.0);
    if (_272._m18.w > 0.0)
    {
        vec2 _710 = gl_FragCoord.xy * _272._m4.xy;
        bool _717 = (gl_FragCoord.z < TEXTURE_LOD(_281, vec4(_710, 0.0, 0.0).xy, vec4(_710, 0.0, 0.0).w).x) ? true : false;
        if (_717 == false)
        {
            _702 = _430;
        }
        _430 *= float(_717 == true);
        _703.x = _430.w;
    }
    if (!_331)
    {
        _703.x = _359.w;
    }
}


