#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

layout(set = 1, binding = 0, std140) uniform _54_56
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _56;

layout(set = 0, binding = 0, std140) uniform _70_72
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _72;

layout(set = 2, binding = 0, std140) uniform _99_101
{
    vec4 _m0;
} _101;

layout(push_constant, std430) uniform _165_167
{
    int _m0;
    int _m1;
} _167;

layout(set = 2, binding = 1) uniform SAMPLER_2D _24;
layout(set = 2, binding = 2) uniform SAMPLER_2D _40;

layout(location = 2) in vec4 _27;
layout(location = 0) in vec4 _32;
layout(location = 3) in vec4 _36;
layout(location = 0) out vec4 _53;

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    vec4 _20 = SAMPLE_TEXTURE(_24, _27.xy);
    
    // Filter OUT the damn MARKERS
    vec2 tex_size = TEXTURE_SIZE(_24 , 0);
    if (tex_size.x == 128 && tex_size.y == 128)      _20 = vec4(0);
    
    _20 *= _32;
    _20 += _36;
    _20.w *= SAMPLE_TEXTURE(_40, _27.zw).w;
    float _62 = _20.x;
    _53.x = (_56._m5.w * ((_10(_62) * _20.w) * _72._m4.x)) + (_20.w * 0.25);
    _53.y = 0.0;
    _53.z = 0.0;
    _53.w = (_56._m5.w * _20.w) + (_20.w * 0.25);
    if (_101._m0.x == 0.0)
    {
    }
    else
    {
        if (_101._m0.x == 1.0)
        {
            _53.w = 9.9999997473787516355514526367188e-05;
        }
        else
        {
            if (_101._m0.x == 2.0)
            {
                _53.w = 1.0;
            }
            else
            {
                if (_101._m0.x == 3.0)
                {
                    float _132 = _53.w;
                    _53.w = _10(_132);
                    vec3 _142 = _53.xyz * _53.w;
                    _53 = vec4(_142.x, _142.y, _142.z, _53.w);
                }
                else
                {
                    if (_101._m0.x == 4.0)
                    {
                        float _152 = _53.w;
                        _53.w = _10(_152);
                        vec3 _161 = _53.xyz * _53.w;
                        _53 = vec4(_161.x, _161.y, _161.z, _53.w);
                        _53.w = 9.9999997473787516355514526367188e-05;
                    }
                }
            }
        }
    }
}


