// FIX FOR DECALS CLIPPING
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require
#extension GL_EXT_nonuniform_qualifier : require
layout(early_fragment_tests) in;

struct _792
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1097
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _2327
{
    int _m0;
    int _m1;
};

struct _2330
{
    int _m0;
    int _m1;
};

struct _2430
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _3369
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _4166
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4931
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _813_815
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _815;

layout(set = 0, binding = 0, std140) uniform _835_837
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _837;

layout(set = 2, binding = 0, std140) uniform _944_946
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _946;

layout(set = 0, binding = 14, std430) restrict readonly buffer _2332_2334
{
    _2330 _m0[];
} _2334;

layout(set = 0, binding = 15, std430) restrict readonly buffer _2405_2407
{
    uint _m0[];
} _2407;

layout(set = 0, binding = 16, std140) uniform _2435_2437
{
    vec4 _m0[4096];
} _2437;

layout(set = 0, binding = 17, std140) uniform _2455_2457
{
    vec4 _m0[4096];
} _2457;

layout(set = 0, binding = 18, std140) uniform _2507_2509
{
    vec4 _m0[4096];
} _2509;

layout(set = 0, binding = 20, std140) uniform _3373_3375
{
    vec4 _m0[4096];
} _3375;

layout(set = 0, binding = 21, std140) uniform _3412_3414
{
    vec4 _m0[4096];
} _3414;

layout(set = 0, binding = 22, std140) uniform _3480_3482
{
    vec4 _m0[4096];
} _3482;

layout(set = 0, binding = 24, std140) uniform _4170_4172
{
    vec4 _m0[4095];
} _4172;

layout(set = 0, binding = 26, std140) uniform _4935_4937
{
    vec4 _m0[4096];
} _4937;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5316_5318
{
    uint _m0[];
} _5318;

layout(push_constant, std430) uniform _5312_5314
{
    int _m0;
    int _m1;
} _5314;

layout(set = 3, binding = 0) uniform texture2D _972[16384];
layout(set = 0, binding = 3) uniform sampler _980;
layout(set = 3, binding = 2) uniform texture2D _989[16384];
layout(set = 0, binding = 4) uniform sampler _994;
layout(set = 3, binding = 1) uniform texture2D _1004[16384];
layout(set = 0, binding = 5) uniform sampler _1009;
layout(set = 3, binding = 3) uniform texture2D _1017[16384];
layout(set = 0, binding = 6) uniform sampler _1022;
layout(set = 3, binding = 7) uniform texture2D _1031[16384];
layout(set = 0, binding = 7) uniform sampler _1036;
layout(set = 3, binding = 4) uniform texture2D _1044[16384];
layout(set = 0, binding = 8) uniform sampler _1049;
layout(set = 3, binding = 6) uniform texture2D _1057[16384];
layout(set = 0, binding = 9) uniform sampler _1062;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1899;
layout(set = 0, binding = 11) uniform SAMPLER_2D _1908;
layout(set = 0, binding = 12) uniform SAMPLER_2D _1964;
layout(set = 0, binding = 13, r32f) uniform writeonly image2D _2192;
layout(set = 0, binding = 19) uniform SAMPLER_2D _2730;
layout(set = 0, binding = 23) uniform SAMPLER_2D _3728;
layout(set = 0, binding = 25) uniform sampler2DShadow _4494;
layout(set = 0, binding = 27) uniform SAMPLER_2D _5076;
layout(set = 3, binding = 5) uniform texture2D _5311[16384];

layout(location = 2) in vec4 _806;
layout(location = 5) in vec4 _824;
layout(location = 3) in vec4 _827;
layout(location = 4) in vec4 _850;
layout(location = 14) flat in uvec3 _902;
layout(location = 0) out vec4 _5229;
layout(location = 1) out vec4 _5237;
layout(location = 2) out vec4 _5245;
layout(location = 3) out vec4 _5263;

float _288;

uvec4 _44(vec4 _43)
{
    return floatBitsToUint(_43);
}

float _64(float _63)
{
    if (_63 <= 0.040449999272823333740234375)
    {
        return _63 / 12.9200000762939453125;
    }
    else
    {
        return pow((_63 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _76(float _75)
{
    float _342 = _75;
    return _64(_342);
}

float _67(float _66)
{
    return _66 * ((_66 * ((_66 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _29(vec2 _27, vec2 _28)
{
    return dot(_27, _28);
}

float _35(uint _34)
{
    return uintBitsToFloat(_34);
}

float _150(float _146, vec4 _147, float _148, bool _149)
{
    float _647 = _147.w / (_146 + _147.z);
    return _647 * _148;
}

vec3 _155(vec3 _153, bool _154)
{
    vec3 _660 = (_153 * 2.0) - vec3(1.0);
    float _677 = (1.0 - (_660.x * _660.x)) - (_660.y * _660.y);
    _660.z = sqrt(_10(_677));
    if (_154 == false)
    {
        _660.z = -_660.z;
    }
    return _660;
}

vec3 _162(vec3 _160, mat3 _161)
{
    return normalize(vec3(dot(_160, _161[0]), dot(_160, _161[1]), dot(_160, _161[2])));
}

uint _39(float _38)
{
    return floatBitsToUint(_38);
}

float _55(float _52, float _53, float _54)
{
    return min(_52, min(_53, _54));
}

float _50(float _47, float _48, float _49)
{
    return max(_47, max(_48, _49));
}

vec4 _105(uint _104)
{
    return unpackUnorm4x8(_104).wzyx;
}

vec4 _118(uvec2 _117)
{
    return vec4(float((_117.x >> uint(16)) & 65535u), float(_117.x & 65535u), float((_117.y >> uint(16)) & 65535u), float(_117.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _108(uint _107)
{
    return vec4(float((_107 >> uint(24)) & 255u), float((_107 >> uint(16)) & 255u), float((_107 >> uint(8)) & 255u), float(_107 & 255u));
}

float _98(float _97)
{
    return (step(0.0, _97) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _70(vec3 _69)
{
    float _303 = _69.x;
    vec3 _302;
    _302.x = _67(_303);
    float _309 = _69.y;
    _302.y = _67(_309);
    float _315 = _69.z;
    _302.z = _67(_315);
    return _302;
}

vec4 _73(vec4 _72)
{
    vec3 _325 = _72.xyz;
    vec4 _324 = vec4(_70(_325), 1.0);
    float _333 = _72.w;
    _324.w = _67(_333);
    return _324;
}

float _82(float _81)
{
    return _81 * _81;
}

vec3 _79(vec3 _78)
{
    return _78 * _78;
}

float _87(float _84, float _85, float _86)
{
    float _364 = (_84 - _85) / (_86 - _85);
    return _10(_364);
}

vec3 _112(uint _111)
{
    return vec3(float((_111 >> uint(21)) & 2047u), float((_111 >> uint(10)) & 2047u), float(_111 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _61(float _58, float _59, float _60)
{
    bool _229 = abs(_60) >= abs(_58);
    bool _237;
    if (_229)
    {
        _237 = abs(_60) >= abs(_59);
    }
    else
    {
        _237 = _229;
    }
    if (_237)
    {
        return uint((_60 < 0.0) ? 5 : 4);
    }
    if (abs(_59) >= abs(_58))
    {
        return uint((_59 < 0.0) ? 3 : 2);
    }
    return uint(int(_58 < 0.0));
}

float _90(float _89)
{
    return exp2(_89);
}

vec3 _121(uint _120)
{
    uint _462 = _120;
    vec4 _461 = _105(_462);
    float _473 = (_461.w * 255.0) - 128.0;
    return _461.xyz * _90(_473);
}

float _95(float _93, float _94)
{
    return pow(_93, _94);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _126(vec3 _124, float _125)
{
    float _485 = 50.0 * dot(_124, vec3(0.33329999446868896484375));
    float _478 = _10(_485);
    float _494 = 1.0 - _125;
    float _497 = _10(_494);
    float _498 = 5.0;
    vec3 _502 = _124 + ((vec3(_478) - _124) * _95(_497, _498));
    return _16(_502);
}

vec3 _134(vec3 _129, vec3 _130, vec3 _131, vec3 _132, float _133)
{
    vec3 _506 = normalize(_130 + _131);
    float _511 = 1.0 - (_133 * 0.800000011920928955078125);
    _511 *= _511;
    _511 *= _511;
    float _522 = _511 * _511;
    float _530 = dot(_129, _506);
    float _526 = _10(_530);
    float _532 = ((_526 * _526) * (_522 - 1.0)) + 1.0;
    _532 = _522 / ((_532 * _532) + 9.9999999392252902907785028219223e-09);
    float _551 = dot(_129, _130);
    float _547 = (_10(_551) * (1.0 - _511)) + _511;
    float _562 = dot(_129, _131);
    float _558 = (_10(_562) * (1.0 - _511)) + _511;
    _532 /= (((4.0 * _547) * _558) + 9.9999999392252902907785028219223e-09);
    vec3 _580 = _132;
    float _582 = dot(_131, _506);
    return _126(_580, _582) * _532;
}

vec3 _141(vec3 _137, vec3 _138, vec3 _139, float _140)
{
    float _588 = 1.0 - (_140 * 0.800000011920928955078125);
    _588 *= _588;
    _588 *= _588;
    float _598 = _588 * _588;
    float _606 = dot(_137, _138);
    float _602 = _10(_606);
    float _608 = ((_602 * _602) * (_598 - 1.0)) + 1.0;
    _608 = _598 / ((_608 * _608) + 9.9999999392252902907785028219223e-09);
    float _626 = dot(_137, _138);
    float _622 = (_10(_626) * (1.0 - _588)) + _588;
    _608 /= (((4.0 * _622) * _622) + 9.9999999392252902907785028219223e-09);
    vec3 _640 = _139;
    return _16(_640) * _608;
}

vec2 _166(vec2 _165)
{
    return (vec2(1.0) - abs(_165.yx)) * vec2((_165.x >= 0.0) ? 1.0 : (-1.0), (_165.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _171(inout vec3 _169, bool _170)
{
    _169 /= vec3((abs(_169.x) + abs(_169.y)) + abs(_169.z));
    vec2 _744;
    if (_169.z >= 0.0)
    {
        _744 = _169.xy;
    }
    else
    {
        vec2 _750 = _169.xy;
        _744 = _166(_750);
    }
    _169 = vec3(_744.x, _744.y, _169.z);
    if (_170)
    {
        vec2 _765 = (_169.xy * 0.5) + vec2(0.5);
        _169 = vec3(_765.x, _765.y, _169.z);
    }
    return _169.xy;
}

float _101(float _100)
{
    return sqrt(_100);
}

float _174(float _173)
{
    float _775 = abs(_173);
    float _772 = _101(_775);
    float _779;
    if (_173 > 0.0)
    {
        _779 = _772;
    }
    else
    {
        _779 = -_772;
    }
    return (_779 * 0.5) + 0.5;
}

void main()
{
    _792 _794 = _792(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _794._m15 = _806;
    _794._m16 = gl_FragCoord;
    _794._m40 = (uint(_815._m16.z) & 3u) << uint(4);
    vec3 _823 = vec3(_824.zw, _827.w);
    _794._m14 = _837._m0.xyz + _823;
    vec3 _845 = normalize(_827.xyz);
    vec3 _849 = normalize(_850.xyz);
    vec3 _854 = normalize(cross(_845, _849) * sign(_850.w));
    _794._m17 = mat3(vec3(_849.x, _854.x, _845.x), vec3(_849.y, _854.y, _845.y), vec3(_849.z, _854.z, _845.z));
    _794._m13 = normalize(-_823);
    uint _892 = 0u;
    vec4 _893 = vec4(0.0);
    vec4 _894 = vec4(0.0);
    vec4 _895 = vec4(0.0);
    vec4 _896 = vec4(0.0);
    vec4 _897 = vec4(0.0);
    uvec3 _900 = _902;
    vec3 _904 = vec3(abs(_850.w) - 1.0, 0.0, _824.x);
    bool _915 = _900.y == 65535u;
    bool _921;
    if (_915)
    {
        _921 = _900.z == 65535u;
    }
    else
    {
        _921 = _915;
    }
    bool _912 = _921;
    bool _922 = !_912;
    bool _925 = _900.z != 65535u;
    uint _929 = _900.x & 7u;
    uint _939;
    if (_837._m1.x == 0.0)
    {
        _939 = _929;
    }
    else
    {
        vec4 _947 = _946._m3;
        uvec4 _943 = _44(_947);
        uint _951 = _943[_929 / 2u];
        uint _956 = 16u * (_929 & 1u);
        _939 = (_951 >> _956) & 65535u;
    }
    uint _965 = _939;
    uint _974 = _965;
    vec3 _967 = texture(sampler2D(_972[nonuniformEXT(_974)], _980), _806.zw).xyz;
    uint _991 = _965;
    vec2 _988 = texture(sampler2D(_989[nonuniformEXT(_991)], _994), _806.zw).yx;
    vec3 _1001 = vec3(0.039999999105930328369140625);
    uint _1006 = _965;
    _1001 = texture(sampler2D(_1004[nonuniformEXT(_1006)], _1009), _806.zw).xyz;
    uint _1019 = _965;
    float _1016 = texture(sampler2D(_1017[nonuniformEXT(_1019)], _1022), _806.zw).x;
    float _1029 = 1.0;
    uint _1033 = _965;
    float _1030 = texture(sampler2D(_1031[nonuniformEXT(_1033)], _1036), _806.zw).x;
    uint _1046 = _965;
    float _1043 = texture(sampler2D(_1044[nonuniformEXT(_1046)], _1049), _806.zw).x;
    uint _1059 = _965;
    vec3 _1056 = texture(sampler2D(_1057[nonuniformEXT(_1059)], _1062), _806.zw).xyz;
    _895 = vec4(_967.x, _967.y, _967.z, _895.w);
    _895.w = _988.y;
    _896 = vec4(_1001.x, _1001.y, _1001.z, _896.w);
    _896.w = _1043;
    _897 = vec4(_897.x, _988.x, _897.z, _988.y);
    _893.x = _1030;
    _893.y = _1029;
    _893.z = _1043;
    _893.w = _1016;
    _894 = vec4(_1056.x, _1056.y, _1056.z, _894.w);
    vec2 _1094 = _806.zw;
    _1097 _1099;
    _1099._m0 = _895;
    _1099._m1 = _896;
    float _1104 = _893.x;
    _1099._m2.x = _76(_1104);
    _1099._m2 = vec4(_1099._m2.x, _893.yzw.x, _893.yzw.y, _893.yzw.z);
    _1099._m3 = _897;
    _1099._m4 = _894;
    _1097 _1118 = _1099;
    vec3 _1120 = vec3(0.0);
    bool _1128;
    if (_922)
    {
        _1128 = _904.x < 65534.0;
    }
    else
    {
        _1128 = _922;
    }
    bool _1134;
    if (_1128)
    {
        _1134 = _904.x > 0.0;
    }
    else
    {
        _1134 = _1128;
    }
    if (_1134)
    {
        uint _1137 = 0u;
        _1097 _1138 = _1097(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1140 = _900.y & 7u;
        uint _1149;
        if (_837._m1.x == 0.0)
        {
            _1149 = _1140;
        }
        else
        {
            vec4 _1153 = _946._m3;
            uvec4 _1152 = _44(_1153);
            uint _1157 = _1152[_1140 / 2u];
            uint _1162 = 16u * (_1140 & 1u);
            _1149 = (_1157 >> _1162) & 65535u;
        }
        uint _1170 = _1149;
        uint _1174 = _1170;
        vec3 _1172 = texture(sampler2D(_972[nonuniformEXT(_1174)], _980), _1094).xyz;
        uint _1184 = _1170;
        vec2 _1182 = texture(sampler2D(_989[nonuniformEXT(_1184)], _994), _1094).yx;
        vec3 _1192 = vec3(0.039999999105930328369140625);
        uint _1194 = _1170;
        _1192 = texture(sampler2D(_1004[nonuniformEXT(_1194)], _1009), _1094).xyz;
        uint _1204 = _1170;
        float _1202 = texture(sampler2D(_1017[nonuniformEXT(_1204)], _1022), _1094).x;
        float _1212 = 1.0;
        uint _1215 = _1170;
        float _1213 = texture(sampler2D(_1031[nonuniformEXT(_1215)], _1036), _1094).x;
        uint _1225 = _1170;
        float _1223 = texture(sampler2D(_1044[nonuniformEXT(_1225)], _1049), _1094).x;
        uint _1235 = _1170;
        vec3 _1233 = texture(sampler2D(_1057[nonuniformEXT(_1235)], _1062), _1094).xyz;
        _1138._m0 = vec4(_1172.x, _1172.y, _1172.z, _1138._m0.w);
        _1138._m0.w = _1182.y;
        _1138._m1 = vec4(_1192.x, _1192.y, _1192.z, _1138._m1.w);
        _1138._m1.w = _1223;
        _1138._m3 = vec4(_1138._m3.x, _1182.x, _1138._m3.z, _1182.y);
        _1138._m2.x = _1213;
        _1138._m2.y = _1212;
        _1138._m2.z = _1223;
        _1138._m2.w = _1202;
        _1138._m4 = vec4(_1233.x, _1233.y, _1233.z, _1138._m4.w);
        float _1272 = _1138._m2.x;
        _1138._m2.x = _67(_1272);
        float _1277 = _1138._m1.w;
        float _1280 = _904.x * _1277;
        float _1285 = _1099._m2.x;
        float _1288 = 0.0;
        float _1289 = 0.0;
        float _1290 = (_1280 * 1.5) - 0.5;
        float _1298 = 1.0 - _1285;
        float _1295 = _10(_1298);
        float _1307 = ((_1295 + _1290) - 0.5) * 10.0;
        float _1300 = _10(_1307);
        _1288 = _1300;
        float _1310 = (_904.x * 1.5) - 0.5;
        float _1318 = 1.0 - _1285;
        float _1315 = _10(_1318);
        float _1326 = ((_1315 + _1310) - 0.5) * 10.0;
        float _1320 = _10(_1326);
        _1289 = _1320;
        _1118._m0 = mix(_1118._m0, _1138._m0, vec4(_1288));
        _1118._m1 = mix(_1118._m1, _1138._m1, vec4(_1288));
        _1118._m2 = mix(_1118._m2, _1138._m2, vec4(_1288));
        _1118._m3 = mix(_1118._m3, _1138._m3, vec4(_1288));
        _1118._m4 = mix(_1118._m4, _1138._m4, vec4(_1288));
        _892 = (_1288 > 0.5) ? _1137 : _892;
        _1120.x = _1288;
    }
    bool _1382;
    if (_925)
    {
        _1382 = _904.y < 65534.0;
    }
    else
    {
        _1382 = _925;
    }
    bool _1388;
    if (_1382)
    {
        _1388 = _904.y > 0.0;
    }
    else
    {
        _1388 = _1382;
    }
    if (_1388)
    {
        uint _1391 = 0u;
        _1097 _1392 = _1097(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1393 = _900.z & 7u;
        uint _1402;
        if (_837._m1.x == 0.0)
        {
            _1402 = _1393;
        }
        else
        {
            vec4 _1406 = _946._m3;
            uvec4 _1405 = _44(_1406);
            uint _1410 = _1405[_1393 / 2u];
            uint _1415 = 16u * (_1393 & 1u);
            _1402 = (_1410 >> _1415) & 65535u;
        }
        uint _1423 = _1402;
        uint _1427 = _1423;
        vec3 _1425 = texture(sampler2D(_972[nonuniformEXT(_1427)], _980), _1094).xyz;
        uint _1437 = _1423;
        vec2 _1435 = texture(sampler2D(_989[nonuniformEXT(_1437)], _994), _1094).yx;
        vec3 _1445 = vec3(0.039999999105930328369140625);
        uint _1447 = _1423;
        _1445 = texture(sampler2D(_1004[nonuniformEXT(_1447)], _1009), _1094).xyz;
        uint _1457 = _1423;
        float _1455 = texture(sampler2D(_1017[nonuniformEXT(_1457)], _1022), _1094).x;
        float _1465 = 1.0;
        uint _1468 = _1423;
        float _1466 = texture(sampler2D(_1031[nonuniformEXT(_1468)], _1036), _1094).x;
        uint _1478 = _1423;
        float _1476 = texture(sampler2D(_1044[nonuniformEXT(_1478)], _1049), _1094).x;
        uint _1488 = _1423;
        vec3 _1486 = texture(sampler2D(_1057[nonuniformEXT(_1488)], _1062), _1094).xyz;
        _1392._m0 = vec4(_1425.x, _1425.y, _1425.z, _1392._m0.w);
        _1392._m0.w = _1435.y;
        _1392._m1 = vec4(_1445.x, _1445.y, _1445.z, _1392._m1.w);
        _1392._m1.w = _1476;
        _1392._m3 = vec4(_1392._m3.x, _1435.x, _1392._m3.z, _1435.y);
        _1392._m2.x = _1466;
        _1392._m2.y = _1465;
        _1392._m2.z = _1476;
        _1392._m2.w = _1455;
        _1392._m4 = vec4(_1486.x, _1486.y, _1486.z, _1392._m4.w);
        float _1525 = _1392._m2.x;
        _1392._m2.x = _67(_1525);
        float _1530 = _1392._m1.w;
        float _1533 = _904.y * _1530;
        float _1538 = _1118._m2.x;
        float _1541 = 0.0;
        float _1542 = 0.0;
        float _1543 = (_1533 * 1.5) - 0.5;
        float _1550 = 1.0 - _1538;
        float _1547 = _10(_1550);
        float _1558 = ((_1547 + _1543) - 0.5) * 10.0;
        float _1552 = _10(_1558);
        _1541 = _1552;
        float _1561 = (_904.y * 1.5) - 0.5;
        float _1569 = 1.0 - _1538;
        float _1566 = _10(_1569);
        float _1577 = ((_1566 + _1561) - 0.5) * 10.0;
        float _1571 = _10(_1577);
        _1542 = _1571;
        _1118._m0 = mix(_1118._m0, _1392._m0, vec4(_1541));
        _1118._m1 = mix(_1118._m1, _1392._m1, vec4(_1541));
        _1118._m2 = mix(_1118._m2, _1392._m2, vec4(_1541));
        _1118._m3 = mix(_1118._m3, _1392._m3, vec4(_1541));
        _1118._m4 = mix(_1118._m4, _1392._m4, vec4(_1541));
        _892 = (_1541 > 0.5) ? _1391 : _892;
        _1120.y = _1541;
    }
    bool _1633;
    if (_922)
    {
        _1633 = _904.z > 0.0;
    }
    else
    {
        _1633 = _922;
    }
    if (_1633)
    {
        _794._m37 = _904.z;
        float _1644 = 1.0 - _1118._m2.x;
        _794._m38 = _10(_1644);
    }
    _895 = _1118._m0;
    _896 = _1118._m1;
    vec3 _1652;
    if (_922)
    {
        _1652 = vec3(0.0);
    }
    else
    {
        _1652 = _893.xyz;
    }
    _893 = vec4(_1652.x, _1652.y, _1652.z, _893.w);
    _893.w = _1118._m2.w;
    _897 = _1118._m3;
    _894 = _1118._m4;
    vec3 _1668 = vec3(1.0);
    vec3 _1670 = (_815._m0.xyz * _946._m13.xyz) * mix(_895.xyz, vec3(1.0), vec3(_815._m0.w));
    _794._m10 = vec3(((_946._m14.x * _893.x) * _893.x) * _815._m1.x) * _1670;
    _794._m10 *= _904;
    _794._m10 *= vec3(_837._m2.x);
    uint _1712 = 0u;
    _794._m15.x = (_794._m15.x * _815._m2.x) + _815._m2.z;
    _794._m15.y = (_794._m15.y * _815._m2.y) + _815._m2.w;
    float _1731 = _837._m3.z;
    float _1734 = _837._m4.z;
    vec2 _1737 = _794._m15.xy * _1731;
    vec2 _1743 = dFdx(_1737) / vec2(float(gl_FragmentSizeNV.x));
    vec2 _1755 = dFdy(_1737) / vec2(float(gl_FragmentSizeNV.y));
    vec2 _1764 = _1743;
    vec2 _1766 = _1743;
    float _1763 = _29(_1764, _1766);
    vec2 _1770 = _1755;
    vec2 _1772 = _1755;
    float _1769 = _29(_1770, _1772);
    float _1775 = 0.5 * log2(max(_1763, _1769));
    float _1781 = 0.5 * log2(min(_1763, _1769));
    float _1787 = _1775 - min(_1734, _1775 - _1781);
    float _1795 = _1787;
    float _1797 = _837._m3.y;
    float _1800 = _837._m4.y;
    uvec2 _1803 = uvec2(_794._m15.xy * _1797);
    uint _1810 = uint(min(_837._m4.w, max(0.0, _1787) + _1800));
    uint _1819 = uint(_837._m3.x);
    _1712 = _1803.x & 255u;
    _1712 |= ((_1803.y & 255u) << uint(8));
    _1712 |= ((_1803.x >> uint(8)) << uint(16));
    _1712 |= ((_1803.y >> uint(8)) << uint(24));
    _1712 |= (_1810 << uint(19));
    _1712 |= (_1819 << uint(27));
    vec3 _1912;
    if (_837._m5.y != 0.0)
    {
        float _1859 = fract(_1795);
        float _1862 = 0.375;
        float _1864 = 0.625;
        bool _1871;
        float _1872;
        float _1875;
        if (_1859 <= _1862)
        {
            _1871 = false;
            _1872 = _1795 - 0.5;
            _1875 = 0.0;
        }
        else
        {
            if (_1859 >= _1864)
            {
                _1871 = false;
                _1872 = _1795 + 0.5;
                _1875 = 0.0;
            }
            else
            {
                _1871 = true;
                _1872 = _1795 - 0.5;
                _1875 = _1795 + 0.5;
            }
        }
        vec4 _1890 = vec4(_794._m15.x, _794._m15.y, 0.0, _1872);
        vec2 _1897 = TEXTURE_LOD(_1899, _1890.xy, _1890.w).xy;
        vec4 _1907 = SAMPLE_TEXTURE(_1908, _1897);
        _1912.x = (_794._m15.x * _1907.x) + _1907.z;
        _1912.y = (_794._m15.y * (_1907.x * _837._m6.x)) + _1907.w;
        _1912.z = _1907.y;
        vec2 _1938 = (dFdx(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1912.z;
        vec2 _1951 = (dFdy(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1912.z;
        vec3 _1971 = TEXTURE_GRAD(_1964, _1912.xy, _1938, _1951).xyz;
        _893 = vec4(_1971.x, _1971.y, _1971.z, _893.w);
        if (_1871)
        {
            vec4 _1977 = vec4(_794._m15.x, _794._m15.y, 0.0, _1875);
            vec2 _1984 = TEXTURE_LOD(_1899, _1977.xy, _1977.w).xy;
            vec4 _1992 = SAMPLE_TEXTURE(_1908, _1984);
            _1912.x = (_794._m15.x * _1992.x) + _1992.z;
            _1912.y = (_794._m15.y * (_1992.x * _837._m6.x)) + _1992.w;
            _1912.z = _1992.y;
            vec2 _2020 = (dFdx(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1912.z;
            vec2 _2033 = (dFdy(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1912.z;
            vec3 _2053 = TEXTURE_GRAD(_1964, _1912.xy, _2020, _2033).xyz;
            vec4 _2046;
            _2046 = vec4(_2053.x, _2053.y, _2053.z, _2046.w);
            float _2056 = 0.0;
            float _2057 = 0.375;
            float _2062 = (_1859 - _2057) * 4.0;
            _2056 = _10(_2062);
            vec3 _2070 = mix(_893.xyz, _2046.xyz, vec3(_2056));
            _2046 = vec4(_2070.x, _2070.y, _2070.z, _2046.w);
        }
    }
    else
    {
        vec4 _2074 = vec4(_794._m15.x, _794._m15.y, 0.0, _1795 - 0.5);
        vec2 _2082 = TEXTURE_LOD(_1899, _2074.xy, _2074.w).xy;
        vec4 _2090 = SAMPLE_TEXTURE(_1908, _2082);
        _1912.x = (_794._m15.x * _2090.x) + _2090.z;
        _1912.y = (_794._m15.y * (_2090.x * _837._m6.x)) + _2090.w;
        _1912.z = _2090.y;
        vec2 _2118 = (dFdx(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1912.z;
        vec2 _2131 = (dFdy(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1912.z;
        vec3 _2150 = TEXTURE_GRAD(_1964, _1912.xy, _2118, _2131).xyz;
        _893 = vec4(_2150.x, _2150.y, _2150.z, _893.w);
    }
    vec2 _2153 = vec2(160.0, 90.0);
    vec2 _2157 = _2153 * _837._m7.zw;
    vec2 _2164 = (gl_FragCoord.xy * _837._m7.zw) * _2153;
    bool _2178 = fract(_2164.x) < _2157.x;
    bool _2187;
    if (_2178)
    {
        _2187 = fract(_2164.y) < _2157.y;
    }
    else
    {
        _2187 = _2178;
    }
    if (_2187)
    {
        uint _2196 = _1712;
        imageStore(_2192, ivec2(_2164), vec4(_35(_2196), 0.0, 0.0, 0.0));
    }
    _892 = _1712;
    _794._m0 = _895.xyz;
    _794._m2 = _896.xyz;
    _794._m1 = _894.xyz;
    _794._m9 = _893.xyz;
    _794._m3 = _893.w;
    _794._m6 = _897.wyz;
    uint _2220 = 8u;
    float _2222 = 16.0;
    float _2224 = 8.0;
    float _2226 = 24.0;
    vec2 _2235 = _794._m16.xy * _837._m7.xy;
    vec3 _2228;
    _2228 = vec3(_2235.x, _2235.y, _2228.z);
    _2228.y = 1.0 - _2228.y;
    
    // FIx for Decals
    _2228.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    
    vec2 _2248 = floor(_2228.xy * vec2(_2222, _2224));
    _2228 = vec3(_2248.x, _2248.y, _2228.z);
    float _2252 = _794._m16.z;
    vec4 _2255 = _837._m8;
    float _2258 = 1.0;
    bool _2259 = false;
    float _2251 = _150(_2252, _2255, _2258, _2259);
    float _2261 = log2(max(1.0, _2251 / _837._m9.z)) * _837._m9.w;
    _2228.z = min(_2226 - 1.0, floor(_2261));
    uint _2277 = uint((_2228.x + (_2228.y * _2222)) + ((_2228.z * _2222) * _2224));
    _2277 = min(_2277, uint(((_2222 * _2224) * _2226) - 1.0));
    bool _2302 = true;
    vec3 _2303 = _794._m6;
    bool _2306 = _2302;
    _794._m7 = _155(_2303, _2306);
    vec3 _2310 = _794._m7;
    mat3 _2313 = _794._m17;
    _794._m6 = _162(_2310, _2313);
    uint _2318 = 0u;
    uint _2319 = 0u;
    uint _2320 = 0u;
    uint _2321 = 0u;
    uint _2322 = 0u;
    uint _2323 = 0u;
    int _2325 = 256;
    _2327 _2329;
    _2329._m0 = _2334._m0[_2277]._m0;
    _2329._m1 = _2334._m0[_2277]._m1;
    int _2343 = _2329._m0 & (~(_2329._m0 >> 31));
    int _2352 = _2329._m1 & (~(_2329._m1 >> 31));
    _2318 = uint((_2343 >> 16) * _2325);
    _2319 = _2318 + uint(_2352 & 255);
    _2320 = _2318;
    _2321 = _2320 + uint((_2352 >> 8) & 255);
    _2322 = _2318;
    _2323 = _2322 + uint((_2352 >> 16) & 255);
    vec3 _2385 = dFdx(_794._m14);
    vec3 _2389 = dFdy(_794._m14);
    uint _2393 = _2320;
    _2430 _2432;
    vec3 _2784;
    float _2889;
    while (_2393 < _2321)
    {
        uint _2403 = _2407._m0[_2393];
        uint _2412 = (_2403 >> uint(12)) & 4095u;
        uint _2418 = _2412;
        if (_2418 >= _2412)
        {
            _2393++;
        }
        int _2427 = 2;
        int _2428 = 2;
        int _2429 = 2;
        _2432._m0 = _2437._m0[(uint(_2427) * _2418) + 0u];
        _2432._m1 = _2437._m0[(uint(_2427) * _2418) + 1u];
        _2432._m2 = _2457._m0[(uint(_2428) * _2418) + 0u];
        float _2471 = _2457._m0[(uint(_2428) * _2418) + 1u].x;
        _2432._m3.x = _39(_2471);
        float _2481 = _2457._m0[(uint(_2428) * _2418) + 1u].y;
        _2432._m3.y = _39(_2481);
        float _2491 = _2457._m0[(uint(_2428) * _2418) + 1u].z;
        _2432._m4.x = _39(_2491);
        float _2501 = _2457._m0[(uint(_2428) * _2418) + 1u].w;
        _2432._m4.y = _39(_2501);
        float _2515 = _2509._m0[(uint(_2429) * _2418) + 0u].x;
        _2432._m5.x = _39(_2515);
        float _2525 = _2509._m0[(uint(_2429) * _2418) + 0u].y;
        _2432._m5.y = _39(_2525);
        float _2535 = _2509._m0[(uint(_2429) * _2418) + 0u].z;
        _2432._m6 = _39(_2535);
        float _2545 = _2509._m0[(uint(_2429) * _2418) + 0u].w;
        _2432._m7 = _39(_2545);
        float _2555 = _2509._m0[(uint(_2429) * _2418) + 1u].x;
        _2432._m8 = _39(_2555);
        float _2565 = _2509._m0[(uint(_2429) * _2418) + 1u].y;
        _2432._m9 = _39(_2565);
        float _2575 = _2509._m0[(uint(_2429) * _2418) + 1u].z;
        _2432._m10 = _39(_2575);
        float _2586 = _2509._m0[(uint(_2429) * _2418) + 1u].w;
        _2432._m11 = _39(_2586);
        vec4 _2591 = vec4(_794._m14, 1.0);
        vec3 _2598 = vec3(dot(_2591, _2432._m0), dot(_2591, _2432._m1), dot(_2591, _2432._m2));
        float _2612 = 0.0039215688593685626983642578125;
        float _2614 = _2598.x;
        float _2617 = _2598.y;
        float _2620 = _2598.z;
        bool _2625 = _55(_2614, _2617, _2620) <= _2612;
        bool _2642;
        if (!_2625)
        {
            float _2629 = _2598.x;
            float _2632 = _2598.y;
            float _2635 = _2598.z;
            _2642 = _50(_2629, _2632, _2635) >= (1.0 - _2612);
        }
        else
        {
            _2642 = _2625;
        }
        if (_2642)
        {
            continue;
        }
        uint _2646 = _2432._m11;
        bool _2650 = _2220 != 0u;
        bool _2657;
        if (_2650)
        {
            _2657 = (_2646 & 1024u) != 0u;
        }
        else
        {
            _2657 = _2650;
        }
        bool _2670;
        if (!_2657)
        {
            bool _2662 = _2220 == 0u;
            bool _2669;
            if (_2662)
            {
                _2669 = (_2646 & 2048u) != 0u;
            }
            else
            {
                _2669 = _2662;
            }
            _2670 = _2669;
        }
        else
        {
            _2670 = _2657;
        }
        if (_2670)
        {
            continue;
        }
        vec3 _2674 = _2432._m0.xyz;
        vec3 _2678 = _2432._m1.xyz;
        vec3 _2682 = _2432._m2.xyz;
        vec2 _2686 = vec2(dot(_2385, _2674), dot(_2385, _2678));
        vec2 _2694 = vec2(dot(_2389, _2674), dot(_2389, _2678));
        float _2702 = 1.0;
        float _2703 = 1.0;
        vec3 _2704 = vec3(0.5, 0.5, 1.0);
        uint _2706 = _2432._m7;
        uint _2710 = _2432._m9;
        vec4 _2709 = _105(_2710);
        uvec2 _2715 = _2432._m5;
        vec4 _2714 = _118(_2715);
        vec2 _2719 = _2686 * _2714.xy;
        vec2 _2724 = _2694 * _2714.xy;
        vec4 _2729 = TEXTURE_GRAD(_2730, (_2598.xy * _2714.xy) + _2714.zw, _2719, _2724);
        _2702 = _2729.z;
        float _2745 = _2729.w;
        _2703 = _67(_2745);
        bool _2752 = _2703 <= (4.0 * _2612);
        bool _2759;
        if (_2752)
        {
            _2759 = _2709.w <= _2612;
        }
        else
        {
            _2759 = _2752;
        }
        if (_2759)
        {
            continue;
        }
        vec2 _2763 = (_2729.xy * 2.0) - vec2(1.0);
        float _2774 = 1.0 - dot(_2763, _2763);
        _2704 = vec3(_2763, sqrt(_10(_2774)));
        if ((_2646 & 256u) != 0u)
        {
            _2784 = vec3(-_2704.x, -_2704.y, _2704.z);
        }
        else
        {
            _2784 = _2704;
        }
        _2704 = _2784;
        uint _2799 = _2432._m8;
        uint _2803 = _2799;
        float _2802 = 1.0 + (_108(_2803).w * 0.062745101749897003173828125);
        uint _2811 = _2706;
        float _2810 = _105(_2811).z;
        float _2824 = _2802 - (_2802 * abs((_2598.z * 2.0) - 1.0));
        _2703 *= _10(_2824);
        if ((_2706 & 64u) != 0u)
        {
            uint _2835 = _2706;
            float _2834 = _105(_2835).x;
            uint _2840 = _2706;
            float _2839 = _108(_2840).y;
            float _2846 = _2834;
            float _2844 = mix(_2839, 0.0, _10(_2846));
            float _2855 = _2702 - (_2844 / 255.0);
            float _2850 = float(_10(_2855) > 0.0);
            _2703 *= _2850;
        }
        vec3 _2862 = normalize(vec3(_794._m17[0].z, _794._m17[1].z, _794._m17[2].z));
        float _2871 = dot(_2862, normalize(_2682));
        float _2876 = _2871;
        vec2 _2881 = _2704.xy * _98(_2876);
        _2704 = vec3(_2881.x, _2881.y, _2704.z);
        if ((_2646 & 32768u) != 0u)
        {
            float _2894 = abs(_2871);
            _2889 = _10(_2894);
        }
        else
        {
            float _2897 = _2871;
            _2889 = _10(_2897);
        }
        float _2884 = _2889;
        float _2901 = _2703 * _2884;
        uint _2905 = _2432._m6;
        uint _2909 = _2905;
        vec4 _2914 = _105(_2909) * _2901;
        vec4 _2908 = _22(_2914);
        _794._m11 = max(_794._m11, _2908.x);
        _2674 += (_2862 * dot(_2674, _2862));
        _2678 += (_2862 * dot(_2678, _2862));
        _2704 = ((normalize(_2674) * _2704.x) + (normalize(_2678) * _2704.y)) + (_2862 * _2704.z);
        if ((_2646 & 512u) != 0u)
        {
            vec3 _2958 = mix(_2862, _2704, _2908.www);
            float _2964 = dot(_2958, _2862);
            _2704 = (_794._m6 * _2964) + ((_2958 - (_2862 * _2964)) * dot(_794._m6, _2862));
        }
        else
        {
            if ((_2646 & 128u) != 0u)
            {
                _2704 = mix(mix(_794._m6, _2862, vec3(_2901)), _2704, _2908.www);
            }
            else
            {
                _2704 = mix(_794._m6, _2704, _2908.www);
            }
        }
        _794._m6 = normalize(_2704);
        uint _3011 = _2799;
        vec3 _3010 = _105(_3011).xyz;
        float _3015 = _2703;
        if ((_2706 & 1u) != 0u)
        {
            uvec2 _3023 = _2432._m3;
            vec4 _3022 = _118(_3023);
            vec2 _3027 = _2686 * _3022.xy;
            vec2 _3032 = _2694 * _3022.xy;
            vec4 _3037 = TEXTURE_GRAD(_2730, (_2598.xy * _3022.xy) + _3022.zw, _3027, _3032);
            vec4 _3050 = _3037;
            _3037 = _73(_3050);
            float _3060 = (_3037.w - _2612) / (1.0 - _2612);
            _3015 = _10(_3060);
            _3010 *= _3037.xyz;
        }
        _794._m0 = mix(_794._m0, _3010, _2908.xxx);
        float _3073 = ((_2884 * _3015) * _2709.w) * _2810;
        _794._m10 += (_2709.xyz * (_3073 * 64.0));
        uint _3092 = _2432._m10;
        uint _3096 = _3092;
        vec4 _3095 = _105(_3096);
        float _3099 = 0.0;
        if ((_2706 & 10u) != 0u)
        {
            uvec2 _3107 = _2432._m4;
            vec4 _3106 = _118(_3107);
            vec2 _3111 = _2686 * _3106.xy;
            vec2 _3116 = _2694 * _3106.xy;
            vec4 _3121 = TEXTURE_GRAD(_2730, (_2598.xy * _3106.xy) + _3106.zw, _3111, _3116);
            if ((_2706 & 2u) != 0u)
            {
                _3095 = _3121 * _3121;
            }
            else
            {
                _3099 = _3121.w;
            }
        }
        _794._m2 = mix(_794._m2, _3095.xyz, _2908.yyy);
        _794._m3 = mix(_794._m3, _3095.w, _2908.z);
        _794._m37 = max(_794._m37, _3099);
        float _3171 = (_2702 - 0.5) * 2.0;
        _794._m38 = max(_794._m38, _10(_3171));
    }
    float _3176 = _794._m37;
    float _3175 = _82(_3176);
    float _3183 = _3175 - 0.5;
    float _3180 = _10(_3183) * 2.0;
    float _3194 = _3175 * 2.0;
    float _3186 = (_794._m38 * _794._m38) * _10(_3194);
    float _3201 = _3186 + _3180;
    float _3197 = _10(_3201);
    if (_3197 > 0.0039215688593685626983642578125)
    {
        vec3 _3209 = _794._m0;
        float _3216 = _3197 * 1.0;
        float _3217 = 0.0;
        float _3218 = 0.3499999940395355224609375;
        _794._m0 = mix(_794._m0, _79(_3209), vec3(_87(_3216, _3217, _3218) * (1.0 - _794._m3)));
        float _3232 = _3197 * 1.0;
        float _3233 = 0.25;
        float _3234 = 0.5;
        _794._m2 = mix(_794._m2, vec3(0.039999999105930328369140625), vec3(_87(_3232, _3233, _3234)));
        vec3 _3239 = vec3(_794._m17[0].z, _794._m17[1].z, _794._m17[2].z);
        float _3253 = _3239.z + 0.0625;
        float _3247 = _3197 * _10(_3253);
        float _3262 = _3247 * 1.0;
        float _3263 = 0.20000000298023223876953125;
        float _3264 = 1.0;
        _794._m3 = mix(_794._m3, 0.89999997615814208984375, _87(_3262, _3263, _3264));
        float _3273 = _3247 * 1.0;
        float _3274 = 0.449999988079071044921875;
        float _3275 = 0.980000019073486328125;
        float _3268 = _87(_3273, _3274, _3275);
        _794._m6 = normalize(mix(_794._m6, vec3(0.0, 0.0, 1.0), vec3(_3268)));
        _794._m7 = mix(_794._m6, vec3(0.5, 0.5, 1.0), vec3(_3268));
        if (_3247 > 0.980000019073486328125)
        {
            float _3298 = _3247 * _3268;
            float _3299 = 0.980000019073486328125;
            float _3300 = 1.0;
            _3239 = normalize(mix(_3239, vec3(0.0, 0.0, 1.0), vec3(_87(_3298, _3299, _3300))));
            _794._m17[0].z = _3239.x;
            _794._m17[1].z = _3239.y;
            _794._m17[2].z = _3239.z;
        }
    }
    vec3 _3314 = vec3(0.0);
    _3314 = _794._m9 * _837._m10.x;
    float _3324;
    if (dot(_794._m10, vec3(1.0)) > 0.0)
    {
        _3324 = -_794._m3;
    }
    else
    {
        _3324 = _794._m3;
    }
    _794._m3 = _3324;
    _794._m18 = _3314;
    _794._m19 = _3314;
    uint _3340 = _2318;
    _3369 _3371;
    vec3 _3689;
    float _3778;
    float _3796;
    uint _4140;
    _4166 _4168;
    uint _4290;
    _4166 _4314;
    while (_3340 < _2319)
    {
        uint _3350 = _2407._m0[_3340];
        uint _3354 = _3350 & 4095u;
        uint _3357 = _3354;
        if (_3357 >= _3354)
        {
            _3340++;
        }
        int _3366 = 4;
        int _3367 = 4;
        int _3368 = 4;
        _3371._m0 = _3375._m0[(uint(_3366) * _3357) + 0u].xyz;
        float _3390 = _3375._m0[(uint(_3366) * _3357) + 0u].w;
        _3371._m1 = _39(_3390);
        _3371._m2 = _3375._m0[(uint(_3366) * _3357) + 1u];
        _3371._m3 = _3375._m0[(uint(_3366) * _3357) + 2u];
        _3371._m4 = _3414._m0[(uint(_3367) * _3357) + 0u];
        _3371._m5 = _3414._m0[(uint(_3367) * _3357) + 1u];
        _3371._m6 = _3414._m0[(uint(_3367) * _3357) + 2u];
        float _3444 = _3375._m0[(uint(_3366) * _3357) + 3u].x;
        _3371._m7.x = _39(_3444);
        float _3454 = _3375._m0[(uint(_3366) * _3357) + 3u].y;
        _3371._m7.y = _39(_3454);
        float _3464 = _3375._m0[(uint(_3366) * _3357) + 3u].z;
        _3371._m7.z = _39(_3464);
        float _3474 = _3375._m0[(uint(_3366) * _3357) + 3u].w;
        _3371._m7.w = _39(_3474);
        _3371._m8 = _3482._m0[(uint(_3368) * _3357) + 0u];
        _3371._m9 = _3482._m0[(uint(_3368) * _3357) + 1u];
        _3371._m10 = _3482._m0[(uint(_3368) * _3357) + 2u];
        _3371._m11 = _3482._m0[(uint(_3368) * _3357) + 3u];
        float _3520 = _3414._m0[(uint(_3367) * _3357) + 3u].x;
        _3371._m12 = _39(_3520);
        float _3530 = _3414._m0[(uint(_3367) * _3357) + 3u].y;
        _3371._m13 = _39(_3530);
        _3371._m14 = _3414._m0[(uint(_3367) * _3357) + 3u].z;
        float _3548 = _3414._m0[(uint(_3367) * _3357) + 3u].w;
        _3371._m15 = _39(_3548);
        uint _3553 = (_3371._m12 >> uint(16)) & 3u;
        if (((_794._m40 >> uint(4)) & 3u) != _3553)
        {
            continue;
        }
        float _3567 = 0.0039215688593685626983642578125;
        vec4 _3568 = vec4(_794._m14, 1.0);
        float _3575 = 1.0 / dot(_3568, _3371._m6);
        vec3 _3581 = vec3(dot(_3568, _3371._m4) * _3575, dot(_3568, _3371._m5) * _3575, dot(_3568, _3371._m3));
        uint _3599 = _3371._m1;
        uint _3602 = _2220;
        _3602 |= 64u;
        float _3606 = _3581.x;
        float _3609 = _3581.y;
        float _3612 = _3581.z;
        bool _3617 = _55(_3606, _3609, _3612) <= _3567;
        bool _3634;
        if (!_3617)
        {
            float _3621 = _3581.x;
            float _3624 = _3581.y;
            float _3627 = _3581.z;
            _3634 = _50(_3621, _3624, _3627) >= (1.0 - _3567);
        }
        else
        {
            _3634 = _3617;
        }
        bool _3642;
        if (!_3634)
        {
            _3642 = (_3599 & _3602) != 0u;
        }
        else
        {
            _3642 = _3634;
        }
        if (_3642)
        {
            continue;
        }
        if ((_3599 & 3u) == 2u)
        {
            vec2 _3661 = fract((_3581.xy * _837._m11.xy) + _837._m11.zw);
            _3581 = vec3(_3661.x, _3661.y, _3581.z);
        }
        vec3 _3664 = _3371._m0;
        float _3667 = 1.0;
        float _3668 = 1.0;
        vec3 _3669 = vec3(0.0, 0.0, 1.0);
        vec3 _3670 = vec3(0.0, 0.0, 1.0);
        uint _3671 = _3371._m1;
        vec3 _3674 = (_3581 * 2.0) - vec3(1.0);
        vec2 _3679 = _3581.xy;
        vec3 _3682 = _3371._m10.xyz;
        if ((_3671 & 3u) == 2u)
        {
            _3689 = _3682;
        }
        else
        {
            _3689 = normalize(_3664 - _794._m14);
        }
        _3669 = _3689;
        _3669 = _3669;
        float _3706 = dot(_794._m6, _3669);
        float _3701 = _10(_3706);
        bool _3710 = _3701 <= _3567;
        bool _3717;
        if (_3710)
        {
            _3717 = (_3671 & 48u) == 0u;
        }
        else
        {
            _3717 = _3710;
        }
        if (_3717)
        {
            continue;
        }
        uvec2 _3722 = _3371._m7.zw;
        vec4 _3721 = _118(_3722);
        float _3727 = TEXTURE_LOD(_3728, vec4((_3679 * _3721.xy) + _3721.zw, 0.0, 0.0).xy, vec4((_3679 * _3721.xy) + _3721.zw, 0.0, 0.0).w).x;
        float _3754 = _3727 * _3727;
        uint _3758 = _3671 & 3u;
        bool _3763 = _3758 == 1u;
        bool _3775;
        if (!_3763)
        {
            bool _3768 = _3758 == 0u;
            bool _3774;
            if (_3768)
            {
                _3774 = _3371._m8.z != 0.0;
            }
            else
            {
                _3774 = _3768;
            }
            _3775 = _3774;
        }
        else
        {
            _3775 = _3763;
        }
        bool _3761 = _3775;
        if (_3761)
        {
            float _3781 = _3371._m8.w;
            _3778 = _10(_3781);
        }
        else
        {
            _3778 = 0.5;
        }
        float _3776 = _3778;
        bool _3789 = _3758 == 0u;
        bool _3795;
        if (_3789)
        {
            _3795 = _3371._m8.z != 0.0;
        }
        else
        {
            _3795 = _3789;
        }
        if (_3795)
        {
            float _3804 = sqrt(dot(_3674, _3674));
            _3796 = min(0.9921875, _10(_3804));
        }
        else
        {
            _3796 = _3581.z;
        }
        float _3787 = _3796;
        uvec2 _3812 = _3371._m7.xy;
        vec4 _3811 = _118(_3812);
        vec2 _3817 = vec2(_3787, _3776);
        float _3821 = TEXTURE_LOD(_3728, vec4((_3817 * _3811.xy) + _3811.zw, 0.0, 0.0).xy, vec4((_3817 * _3811.xy) + _3811.zw, 0.0, 0.0).w).x;
        _3821 *= _3821;
        _3667 = _3821 * _3754;
        if ((_3671 & 48u) != 0u)
        {
            vec4 _3858 = _3371._m10;
            vec4 _3861 = _3371._m8;
            vec4 _3864 = _3371._m9;
            float _3867 = dot(_794._m14, _3858.xyz) + _3858.w;
            if (_3867 < 0.0)
            {
                continue;
            }
            float _3881 = length(_3858.xyz);
            float _3888 = _3867 * 50.0;
            float _3885 = _10(_3888);
            _3667 *= (_3885 * _3885);
            _3867 /= _3881;
            _3858 /= vec4(_3881);
            vec3 _3902 = reflect(-_794._m13, _794._m6);
            if (dot(_3902, _3858.xyz) > 0.0)
            {
                _3902 = reflect(_3902, _3858.xyz);
            }
            float _3920 = dot(_3902, _3858.xyz);
            float _3925 = _3867 / _3920;
            vec3 _3929 = _794._m14 - (_3902 * _3925);
            vec3 _3936 = _3929 - _3664;
            float _3940 = dot(_3936, _3861.xyz) / _3861.w;
            float _3948 = dot(_3936, _3864.xyz) / _3864.w;
            if ((_3671 & 48u) == 32u)
            {
                vec2 _3962 = vec2(_3940, _3948);
                float _3966 = 1.0 / max(1.0, length(vec2(_3940, _3948)));
                _3940 *= (_3966 * _3861.w);
                _3948 *= (_3966 * _3864.w);
            }
            else
            {
                float _3988 = abs(_3940);
                float _3990 = _3940;
                _3940 = (_10(_3988) * _98(_3990)) * _3861.w;
                float _3999 = abs(_3948);
                float _4001 = _3948;
                _3948 = (_10(_3999) * _98(_4001)) * _3864.w;
            }
            vec3 _4008 = (_3861.xyz * _3940) + (_3864.xyz * _3948);
            _3664 += _4008;
            _3669 = normalize(_3664 - _794._m14);
            _3669 = _3669;
        }
        else
        {
            uint _4028 = (_3371._m15 >> uint(16)) & 255u;
            if (_4028 == 0u)
            {
                vec4 _4037 = _3371._m9;
                if (dot(_4037.xyz, _794._m14) < (_4037.w - _3567))
                {
                    continue;
                }
            }
            else
            {
                if (_4028 == 1u)
                {
                    vec3 _4058 = _3371._m9.xyz;
                    float _4063 = _3371._m9.w;
                    uint _4067 = _39(_4063);
                    vec3 _4062 = (((_112(_4067) * 2.0) - vec3(1.0)) * _4058) + _3664;
                    vec3 _4076 = abs((_794._m14 - _4062) / _4058);
                    float _4084 = _4076.x;
                    float _4087 = _4076.y;
                    float _4090 = _4076.z;
                    if (_50(_4084, _4087, _4090) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3667 <= (_3567 / 256.0))
        {
            continue;
        }
        float _4106 = 1.0;
        if ((_3599 & 4u) != 0u)
        {
            float _4113 = float(_3371._m15 & 255u) / 255.0;
            float _4119 = 0.00999999977648258209228515625;
            vec3 _4121 = _794._m14 + (_794._m6 * _4119);
            if ((_3599 & 3u) == 0u)
            {
                vec3 _4134 = _4121 - _3371._m2.xyz;
                float _4141 = _4134.x;
                float _4144 = _4134.y;
                float _4147 = _4134.z;
                _4140 = _61(_4141, _4144, _4147);
            }
            else
            {
                if ((_3599 & 3u) == 2u)
                {
                    float _4157 = 0.0;
                    _4140 = 0u;
                    for (; _4140 < 3u; _4140++)
                    {
                        int _4165 = 5;
                        _4168._m0 = _4172._m0[(uint(_4165) * ((_3599 >> uint(22)) + _4140)) + 0u];
                        _4168._m1 = _4172._m0[(uint(_4165) * ((_3599 >> uint(22)) + _4140)) + 1u];
                        _4168._m2 = _4172._m0[(uint(_4165) * ((_3599 >> uint(22)) + _4140)) + 2u];
                        _4168._m3 = _4172._m0[(uint(_4165) * ((_3599 >> uint(22)) + _4140)) + 3u];
                        _4168._m4 = _4172._m0[(uint(_4165) * ((_3599 >> uint(22)) + _4140)) + 4u];
                        vec2 _4229 = vec2(dot(_4121, _4168._m0.xyz) + _4168._m0.w, dot(_4121, _4168._m1.xyz) + _4168._m1.w);
                        _4229 = abs((_4229 * 2.0) - vec2(1.0));
                        bool _4255 = _4229.x < 0.99500000476837158203125;
                        bool _4261;
                        if (_4255)
                        {
                            _4261 = _4229.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _4261 = _4255;
                        }
                        if (_4261)
                        {
                            _4157 = (1.0 - max(_4229.x, _4229.y)) * _837._m12.w;
                            break;
                        }
                    }
                    _4140 = min(2u, _4140);
                    uint _4278 = uint(_794._m16.x) ^ (uint(_794._m16.y) << uint(1));
                    if (_837._m13.w > 0.0)
                    {
                        _4290 = uint(_837._m14.x);
                    }
                    else
                    {
                        _4290 = 0u;
                    }
                    _4278 ^= _4290;
                    _4140 += uint(int(((float(_4278 & 3u) * 0.25) + 0.125) > _4157));
                }
                else
                {
                    _4140 = 0u;
                }
            }
            int _4313 = 5;
            _4314._m0 = _4172._m0[(uint(_4313) * ((_3599 >> uint(22)) + _4140)) + 0u];
            _4314._m1 = _4172._m0[(uint(_4313) * ((_3599 >> uint(22)) + _4140)) + 1u];
            _4314._m2 = _4172._m0[(uint(_4313) * ((_3599 >> uint(22)) + _4140)) + 2u];
            _4314._m3 = _4172._m0[(uint(_4313) * ((_3599 >> uint(22)) + _4140)) + 3u];
            _4314._m4 = _4172._m0[(uint(_4313) * ((_3599 >> uint(22)) + _4140)) + 4u];
            vec4 _4370 = vec4((_4121.x * _4314._m0.x) + ((_4121.y * _4314._m0.y) + ((_4121.z * _4314._m0.z) + _4314._m0.w)), (_4121.x * _4314._m1.x) + ((_4121.y * _4314._m1.y) + ((_4121.z * _4314._m1.z) + _4314._m1.w)), (_4121.x * _4314._m2.x) + ((_4121.y * _4314._m2.y) + ((_4121.z * _4314._m2.z) + _4314._m2.w)), (_4121.x * _4314._m3.x) + ((_4121.y * _4314._m3.y) + ((_4121.z * _4314._m3.z) + _4314._m3.w)));
            vec3 _4457 = _4370.xyz / vec3(_4370.w);
            _4370 = vec4(_4457.x, _4457.y, _4457.z, _4370.w);
            bool _4465 = min(_4370.x, _4370.y) > 0.0;
            bool _4474;
            if (_4465)
            {
                _4474 = max(_4370.x, _4370.y) < 1.0;
            }
            else
            {
                _4474 = _4465;
            }
            if (_4474)
            {
                vec2 _4486 = (_4370.xy * _4314._m4.xy) + _4314._m4.zw;
                _4370 = vec4(_4486.x, _4486.y, _4370.z, _4370.w);
                if (false)
                {
                    _4106 = textureLod(_4494, vec3(_4370.xyz.xy, _4370.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4501 = (_4370.xy * _837._m15.xy) + vec2(0.5);
                    vec2 _4510 = floor(_4501);
                    vec2 _4513 = _4501 - _4510;
                    _4510 -= vec2(0.5);
                    vec2 _4520 = vec2(4.0) - (_4513 * 3.0);
                    vec2 _4526 = vec2(7.0);
                    vec2 _4529 = vec2(1.0) + (_4513 * 3.0);
                    vec2 _4534 = (_4510 + (((vec2(3.0) - (_4513 * 2.0)) / _4520) - vec2(2.0))) * _837._m15.zw;
                    vec2 _4549 = (_4510 + ((vec2(3.0) + _4513) / _4526)) * _837._m15.zw;
                    vec2 _4561 = (_4510 + ((_4513 / _4529) + vec2(2.0))) * _837._m15.zw;
                    vec3 _4585 = vec3(_4534.x, _4534.y, _4370.z);
                    _4106 = (_4520.x * _4520.y) * textureLod(_4494, vec3(_4585.xy, _4585.z), 0.0);
                    vec3 _4601 = vec3(_4549.x, _4534.y, _4370.z);
                    _4106 += ((_4526.x * _4520.y) * textureLod(_4494, vec3(_4601.xy, _4601.z), 0.0));
                    vec3 _4619 = vec3(_4561.x, _4534.y, _4370.z);
                    _4106 += ((_4529.x * _4520.y) * textureLod(_4494, vec3(_4619.xy, _4619.z), 0.0));
                    vec3 _4637 = vec3(_4534.x, _4549.y, _4370.z);
                    _4106 += ((_4520.x * _4526.y) * textureLod(_4494, vec3(_4637.xy, _4637.z), 0.0));
                    vec3 _4655 = vec3(_4549.x, _4549.y, _4370.z);
                    _4106 += ((_4526.x * _4526.y) * textureLod(_4494, vec3(_4655.xy, _4655.z), 0.0));
                    vec3 _4673 = vec3(_4561.x, _4549.y, _4370.z);
                    _4106 += ((_4529.x * _4526.y) * textureLod(_4494, vec3(_4673.xy, _4673.z), 0.0));
                    vec3 _4691 = vec3(_4534.x, _4561.y, _4370.z);
                    _4106 += ((_4520.x * _4529.y) * textureLod(_4494, vec3(_4691.xy, _4691.z), 0.0));
                    vec3 _4709 = vec3(_4549.x, _4561.y, _4370.z);
                    _4106 += ((_4526.x * _4529.y) * textureLod(_4494, vec3(_4709.xy, _4709.z), 0.0));
                    vec3 _4727 = vec3(_4561.x, _4561.y, _4370.z);
                    _4106 += ((_4529.x * _4529.y) * textureLod(_4494, vec3(_4727.xy, _4727.z), 0.0));
                    _4106 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _4106 = float((_3599 & 3u) == 2u);
            }
            float _4741 = float((_3599 >> uint(16)) & 63u) / 63.0;
            float _4755 = ((_4106 * _4741) + 1.0) - _4741;
            _4106 = _10(_4755);
        }
        uint _4758 = _3371._m13;
        vec3 _4757 = (_121(_4758) * _4106) * _3667;
        _3668 *= _3371._m14;
        vec3 _4770 = _4757;
        vec3 _4772 = _3669;
        float _4779 = dot(_794._m6, _4772);
        float _4774 = _10(_4779);
        vec3 _4785 = _794._m6;
        vec3 _4788 = _794._m13;
        vec3 _4791 = _3669;
        vec3 _4793 = _794._m2;
        float _4796 = abs(_794._m3);
        vec3 _4781 = _134(_4785, _4788, _4791, _4793, _4796);
        _794._m20 += (((_4781 * _3668) * _4770) * _4774);
        vec3 _4810 = mix(_4770, vec3(0.0), bvec3((_3599 & 256u) > 0u));
        _794._m19 += (_4810 * _4774);
    }
    float _4825 = _837._m16.x;
    if (_4825 > 0.00999999977648258209228515625)
    {
        float _4832 = float(int(_837._m14.x) & 1023) / 1023.0;
        _4825 = max(0.0, _4825 + (((_4832 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4848 = _794._m13;
        float _4856 = dot(_794._m6, _4848);
        float _4851 = _10(_4856);
        float _4858 = _4851 * _4825;
        vec3 _4866 = _794._m6;
        vec3 _4869 = _794._m13;
        vec3 _4872 = _794._m2;
        float _4875 = abs(_794._m3);
        vec3 _4862 = _141(_4866, _4869, _4872, _4875) * _4825;
        _794._m19 += vec3(_4858);
        _794._m20 += vec3(_4862);
    }
    _794._m19 = _794._m19;
    _794._m20 += _794._m10;
    float _4903 = 0.064999997615814208984375;
    float _4905 = 1.0 + _4903;
    bool _4908 = false;
    uint _4913;
    if (_837._m17.w > 0.00999999977648258209228515625)
    {
        _4913 = uint(_837._m17.x);
    }
    else
    {
        _4913 = 0u;
    }
    uint _4909 = _4913;
    _4931 _4933;
    for (uint _4921 = 0u; _4921 < _4909; _4921++)
    {
        int _4930 = 4;
        _4933._m0 = _4937._m0[(uint(_4930) * _4921) + 0u];
        _4933._m1 = _4937._m0[(uint(_4930) * _4921) + 1u];
        _4933._m2 = _4937._m0[(uint(_4930) * _4921) + 2u];
        float _4967 = _4937._m0[(uint(_4930) * _4921) + 3u].x;
        _4933._m3 = _39(_4967);
        float _4977 = _4937._m0[(uint(_4930) * _4921) + 3u].y;
        _4933._m4 = _39(_4977);
        float _4987 = _4937._m0[(uint(_4930) * _4921) + 3u].z;
        _4933._m5 = _39(_4987);
        vec4 _4992 = vec4(_794._m14, 1.0);
        vec3 _4999 = vec3(dot(_4992, _4933._m1), dot(_4992, _4933._m2), dot(_4992, _4933._m0));
        float _5013 = _4999.x;
        float _5016 = _4999.y;
        float _5019 = _4999.z;
        bool _5023 = _55(_5013, _5016, _5019) >= 0.0;
        bool _5032;
        if (_5023)
        {
            _5032 = max(_4999.x, _4999.y) < 1.0;
        }
        else
        {
            _5032 = _5023;
        }
        bool _5039;
        if (_5032)
        {
            _5039 = _4999.z < _4905;
        }
        else
        {
            _5039 = _5032;
        }
        if (_5039)
        {
            float _5042 = _4999.z;
            vec4 _5045 = vec4(_794._m14, 1.0);
            vec2 _5052 = vec2(0.0);
            _5052 = (((_5045.xy - _837._m18.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _5065 = 0.000244140625;
            float _5071 = abs(_794._m6.z) * 2.0;
            _5065 *= _10(_5071);
            vec3 _5075 = vec3(TEXTURE_LOD(_5076, vec4(_5052 + vec2(_5065), 0.0, 0.0).xy, vec4(_5052 + vec2(_5065), 0.0, 0.0).w).x, TEXTURE_LOD(_5076, vec4(_5052, 0.0, 0.0).xy, vec4(_5052, 0.0, 0.0).w).x, TEXTURE_LOD(_5076, vec4(_5052 - vec2(_5065), 0.0, 0.0).xy, vec4(_5052 - vec2(_5065), 0.0, 0.0).w).x);
            float _5139 = 2.0 - (2.0 * (length(_5045.xy - _837._m18.zw) / 16.0));
            _5075 *= _10(_5139);
            float _5146 = 1.0 - _5042;
            float _5143 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_5146));
            float _5157 = (_794._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _5149 = (_5075 * _5143) * _10(_5157);
            float _5166 = _4905 - _5042;
            float _5160 = (1.0 - _5143) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_5166));
            float _5180 = ((-_794._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _5170 = (_5075 * _5160) * _10(_5180);
            _5075 = _5149 + _5170;
            float _5191 = 1.02499997615814208984375 - _5042;
            float _5186 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_5191));
            float _5194 = _837._m17.w;
            _794._m19 = mix(_794._m19, (_794._m19 * _5075) + (_794._m19 * mix(1.0, 0.5, _5186)), vec3(_5194));
            break;
        }
    }
    _794._m19 *= _794._m0;
    _794._m21 = _794._m19 + _794._m20;
    vec3 _5234 = _794._m19 + _794._m20;
    _5229 = vec4(_5234.x, _5234.y, _5234.z, _5229.w);
    vec3 _5238 = _794._m6;
    bool _5241 = false;
    vec2 _5242 = _171(_5238, _5241);
    _5237 = vec4(_5242.x, _5242.y, _5237.z, _5237.w);
    float _5246 = _794._m2.x;
    float _5250 = _794._m2.y;
    float _5254 = _794._m2.z;
    float _5258 = _794._m3;
    _5245 = vec4(_101(_5246), _101(_5250), _101(_5254), _174(_5258));
    _5263 = vec4(0.0, 0.0, 0.0, float((uint(_815._m16.z) & 3u) << uint(4)) / 255.0);
    vec3 _5276 = _794._m19 + _794._m20;
    _5229 = vec4(_5276.x, _5276.y, _5276.z, _5229.w);
    vec3 _5279 = _794._m6;
    bool _5282 = false;
    vec2 _5283 = _171(_5279, _5282);
    _5237 = vec4(_5283.x, _5283.y, _5237.z, _5237.w);
    float _5286 = _794._m2.x;
    float _5290 = _794._m2.y;
    float _5294 = _794._m2.z;
    float _5298 = _794._m3;
    _5245 = vec4(_101(_5286), _101(_5290), _101(_5294), _174(_5298));
    vec3 _5308 = _5229.xyz + _815._m18.xyz;
    _5229 = vec4(_5308.x, _5308.y, _5308.z, _5229.w);
}


