// Cloak Glass
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 40, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   


struct _894
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1189
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _1991
{
    int _m0;
    int _m1;
};

struct _1994
{
    int _m0;
    int _m1;
};

struct _2105
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _3102
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3899
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4664
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 1, binding = 0, std140) uniform _915_917
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
} _917;

layout(set = 0, binding = 0, std140) uniform _927_929
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _929;

layout(set = 2, binding = 0, std140) uniform _1029_1031
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _1031;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1996_1998
{
    _1994 _m0[];
} _1998;

layout(set = 0, binding = 14, std430) restrict readonly buffer _2080_2082
{
    uint _m0[];
} _2082;

layout(set = 0, binding = 15, std140) uniform _2110_2112
{
    vec4 _m0[4096];
} _2112;

layout(set = 0, binding = 16, std140) uniform _2130_2132
{
    vec4 _m0[4096];
} _2132;

layout(set = 0, binding = 17, std140) uniform _2182_2184
{
    vec4 _m0[4096];
} _2184;

layout(set = 0, binding = 19, std140) uniform _3106_3108
{
    vec4 _m0[4096];
} _3108;

layout(set = 0, binding = 20, std140) uniform _3145_3147
{
    vec4 _m0[4096];
} _3147;

layout(set = 0, binding = 21, std140) uniform _3213_3215
{
    vec4 _m0[4096];
} _3215;

layout(set = 0, binding = 23, std140) uniform _3903_3905
{
    vec4 _m0[4095];
} _3905;

layout(set = 0, binding = 25, std140) uniform _4668_4670
{
    vec4 _m0[4096];
} _4670;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5803_5805
{
    uint _m0[];
} _5805;

layout(set = 0, binding = 2, std430) restrict readonly buffer _5807_5809
{
    vec4 _m0[];
} _5809;

layout(push_constant, std430) uniform _5799_5801
{
    int _m0;
    int _m1;
} _5801;

layout(set = 3, binding = 0) uniform texture2D _1057[16384];
layout(set = 0, binding = 6) uniform sampler _1065;
layout(set = 3, binding = 2) uniform texture2D _1075[16384];
layout(set = 0, binding = 7) uniform sampler _1080;
layout(set = 3, binding = 1) uniform texture2D _1091[16384];
layout(set = 0, binding = 8) uniform sampler _1096;
layout(set = 3, binding = 3) uniform texture2D _1105[16384];
layout(set = 0, binding = 9) uniform sampler _1110;
layout(set = 3, binding = 7) uniform texture2D _1120[16384];
layout(set = 0, binding = 10) uniform sampler _1125;
layout(set = 3, binding = 4) uniform texture2D _1134[16384];
layout(set = 0, binding = 11) uniform sampler _1139;
layout(set = 3, binding = 6) uniform texture2D _1148[16384];
layout(set = 0, binding = 12) uniform sampler _1153;
layout(set = 1, binding = 1) uniform SAMPLER_2D _1812;
layout(set = 1, binding = 2) uniform SAMPLER_2D _1817;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2405;
layout(set = 0, binding = 22) uniform SAMPLER_2D _3461;
layout(set = 0, binding = 24) uniform sampler2DShadow _4227;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4809;
layout(set = 1, binding = 3) uniform SAMPLER_2D _4969;
layout(set = 0, binding = 27) uniform SAMPLER_2D _5130;
layout(set = 0, binding = 28) uniform SAMPLER_2D _5181;
layout(set = 0, binding = 29) uniform SAMPLER_2D _5278;
layout(set = 0, binding = 30) uniform SAMPLER_2D _5375;
layout(set = 0, binding = 31) uniform SAMPLER_2D _5468;
layout(set = 0, binding = 32) uniform SAMPLER_2D _5561;
layout(set = 3, binding = 5) uniform texture2D _5798[16384];
layout(set = 0, binding = 4) uniform sampler3D _5813;
layout(set = 0, binding = 5) uniform sampler3D _5814;

layout(location = 2) in vec4 _908;
layout(location = 6) in vec4 _934;
layout(location = 3) in vec4 _946;
layout(location = 4) in vec4 _949;
layout(location = 5) in vec4 _952;
layout(location = 10) in vec4 _970;
layout(location = 11) in vec4 _974;
layout(location = 12) in vec4 _978;
layout(location = 14) flat in uvec3 _991;
layout(location = 15) in vec4 _994;
layout(location = 8) in vec4 _1794;
layout(location = 0) out vec4 _5712;
layout(location = 1) out vec4 _5720;
layout(location = 2) out vec4 _5728;
layout(location = 3) out vec4 _5746;

float _283;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _67(float _66)
{
    float _356 = _66;
    return _52(_356);
}

float _58(float _57)
{
    return _57 * ((_57 * ((_57 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _55(vec3 _54)
{
    float _285 = _54.x;
    vec3 _284;
    _284.x = _52(_285);
    float _291 = _54.y;
    _284.y = _52(_291);
    float _297 = _54.z;
    _284.z = _52(_297);
    return _284;
}

vec3 _70(vec3 _69)
{
    vec3 _361 = _69;
    return _55(_361);
}

float _152(float _148, vec4 _149, float _150, bool _151)
{
    float _749 = _149.w / (_148 + _149.z);
    return _749 * _150;
}

vec3 _157(vec3 _155, bool _156)
{
    vec3 _762 = (_155 * 2.0) - vec3(1.0);
    float _779 = (1.0 - (_762.x * _762.x)) - (_762.y * _762.y);
    _762.z = sqrt(_10(_779));
    if (_156 == false)
    {
        _762.z = -_762.z;
    }
    return _762;
}

vec3 _164(vec3 _162, mat3 _163)
{
    return normalize(vec3(dot(_162, _163[0]), dot(_162, _163[1]), dot(_162, _163[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _107(uint _106)
{
    return unpackUnorm4x8(_106).wzyx;
}

vec4 _120(uvec2 _119)
{
    return vec4(float((_119.x >> uint(16)) & 65535u), float(_119.x & 65535u), float((_119.y >> uint(16)) & 65535u), float(_119.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _110(uint _109)
{
    return vec4(float((_109 >> uint(24)) & 255u), float((_109 >> uint(16)) & 255u), float((_109 >> uint(8)) & 255u), float(_109 & 255u));
}

float _99(float _98)
{
    return (step(0.0, _98) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _61(vec3 _60)
{
    float _320 = _60.x;
    vec3 _319;
    _319.x = _58(_320);
    float _325 = _60.y;
    _319.y = _58(_325);
    float _330 = _60.z;
    _319.z = _58(_330);
    return _319;
}

vec4 _64(vec4 _63)
{
    vec3 _339 = _63.xyz;
    vec4 _338 = vec4(_61(_339), 1.0);
    float _347 = _63.w;
    _338.w = _58(_347);
    return _338;
}

float _76(float _75)
{
    return _75 * _75;
}

vec3 _73(vec3 _72)
{
    return _72 * _72;
}

float _81(float _78, float _79, float _80)
{
    float _383 = (_78 - _79) / (_80 - _79);
    return _10(_383);
}

vec3 _114(uint _113)
{
    return vec3(float((_113 >> uint(21)) & 2047u), float((_113 >> uint(10)) & 2047u), float(_113 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _224 = abs(_48) >= abs(_46);
    bool _232;
    if (_224)
    {
        _232 = abs(_48) >= abs(_47);
    }
    else
    {
        _232 = _224;
    }
    if (_232)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _91(float _90)
{
    return exp2(_90);
}

vec3 _123(uint _122)
{
    uint _564 = _122;
    vec4 _563 = _107(_564);
    float _575 = (_563.w * 255.0) - 128.0;
    return _563.xyz * _91(_575);
}

float _96(float _94, float _95)
{
    return pow(_94, _95);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _128(vec3 _126, float _127)
{
    float _587 = 50.0 * dot(_126, vec3(0.33329999446868896484375));
    float _580 = _10(_587);
    float _596 = 1.0 - _127;
    float _599 = _10(_596);
    float _600 = 5.0;
    vec3 _604 = _126 + ((vec3(_580) - _126) * _96(_599, _600));
    return _16(_604);
}

vec3 _136(vec3 _131, vec3 _132, vec3 _133, vec3 _134, float _135)
{
    vec3 _608 = normalize(_132 + _133);
    float _613 = 1.0 - (_135 * 0.800000011920928955078125);
    _613 *= _613;
    _613 *= _613;
    float _624 = _613 * _613;
    float _632 = dot(_131, _608);
    float _628 = _10(_632);
    float _634 = ((_628 * _628) * (_624 - 1.0)) + 1.0;
    _634 = _624 / ((_634 * _634) + 9.9999999392252902907785028219223e-09);
    float _653 = dot(_131, _132);
    float _649 = (_10(_653) * (1.0 - _613)) + _613;
    float _664 = dot(_131, _133);
    float _660 = (_10(_664) * (1.0 - _613)) + _613;
    _634 /= (((4.0 * _649) * _660) + 9.9999999392252902907785028219223e-09);
    vec3 _682 = _134;
    float _684 = dot(_133, _608);
    return _128(_682, _684) * _634;
}

vec3 _143(vec3 _139, vec3 _140, vec3 _141, float _142)
{
    float _690 = 1.0 - (_142 * 0.800000011920928955078125);
    _690 *= _690;
    _690 *= _690;
    float _700 = _690 * _690;
    float _708 = dot(_139, _140);
    float _704 = _10(_708);
    float _710 = ((_704 * _704) * (_700 - 1.0)) + 1.0;
    _710 = _700 / ((_710 * _710) + 9.9999999392252902907785028219223e-09);
    float _728 = dot(_139, _140);
    float _724 = (_10(_728) * (1.0 - _690)) + _690;
    _710 /= (((4.0 * _724) * _724) + 9.9999999392252902907785028219223e-09);
    vec3 _742 = _141;
    return _16(_742) * _710;
}

vec4 _88(vec3 _86, mat4 _87)
{
    return vec4((_86.x * _87[0].x) + ((_86.y * _87[0].y) + ((_86.z * _87[0].z) + _87[0].w)), (_86.x * _87[1].x) + ((_86.y * _87[1].y) + ((_86.z * _87[1].z) + _87[1].w)), (_86.x * _87[2].x) + ((_86.y * _87[2].y) + ((_86.z * _87[2].z) + _87[2].w)), (_86.x * _87[3].x) + ((_86.y * _87[3].y) + ((_86.z * _87[3].z) + _87[3].w)));
}

vec2 _170(vec2 _169)
{
    return (vec2(1.0) - abs(_169.yx)) * vec2((_169.x >= 0.0) ? 1.0 : (-1.0), (_169.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _175(inout vec3 _173, bool _174)
{
    _173 /= vec3((abs(_173.x) + abs(_173.y)) + abs(_173.z));
    vec2 _846;
    if (_173.z >= 0.0)
    {
        _846 = _173.xy;
    }
    else
    {
        vec2 _852 = _173.xy;
        _846 = _170(_852);
    }
    _173 = vec3(_846.x, _846.y, _173.z);
    if (_174)
    {
        vec2 _867 = (_173.xy * 0.5) + vec2(0.5);
        _173 = vec3(_867.x, _867.y, _173.z);
    }
    return _173.xy;
}

float _102(float _101)
{
    return sqrt(_101);
}

float _178(float _177)
{
    float _877 = abs(_177);
    float _874 = _102(_877);
    float _881;
    if (_177 > 0.0)
    {
        _881 = _874;
    }
    else
    {
        _881 = -_874;
    }
    return (_881 * 0.5) + 0.5;
}

void main()
{
    _894 _896 = _894(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _896._m15 = _908;
    _896._m16 = gl_FragCoord;
    _896._m40 = (uint(_917._m28.z) & 3u) << uint(4);
    _896._m14 = _929._m2.xyz + _934.xyz;
    _896._m13 = normalize(-_934.xyz);
    _896._m17 = mat3(vec3(_946.xyz), vec3(_949.xyz), vec3(_952.xyz));
    _896._m34 = _970;
    _896._m35 = _974;
    _896._m36 = _978;
    uint _981 = 0u;
    vec4 _982 = vec4(0.0);
    vec4 _983 = vec4(0.0);
    vec4 _984 = vec4(0.0);
    vec4 _985 = vec4(0.0);
    vec4 _986 = vec4(0.0);
    uvec3 _989 = _991;
    vec3 _993 = _994.xyz;
    bool _1000 = _989.y == 65535u;
    bool _1006;
    if (_1000)
    {
        _1006 = _989.z == 65535u;
    }
    else
    {
        _1006 = _1000;
    }
    bool _997 = _1006;
    bool _1007 = !_997;
    bool _1010 = _989.z != 65535u;
    uint _1014 = _989.x & 7u;
    uint _1024;
    if (_929._m4.x == 0.0)
    {
        _1024 = _1014;
    }
    else
    {
        vec4 _1032 = _1031._m8;
        uvec4 _1028 = _32(_1032);
        uint _1036 = _1028[_1014 / 2u];
        uint _1041 = 16u * (_1014 & 1u);
        _1024 = (_1036 >> _1041) & 65535u;
    }
    uint _1050 = _1024;
    uint _1059 = _1050;
    vec3 _1052 = texture(sampler2D(_1057[nonuniformEXT(_1059)], _1065), _896._m15.zw).xyz;
    uint _1077 = _1050;
    vec2 _1074 = texture(sampler2D(_1075[nonuniformEXT(_1077)], _1080), _896._m15.zw).yx;
    vec3 _1088 = vec3(0.039999999105930328369140625);
    uint _1093 = _1050;
    _1088 = texture(sampler2D(_1091[nonuniformEXT(_1093)], _1096), _896._m15.zw).xyz;
    uint _1107 = _1050;
    float _1104 = texture(sampler2D(_1105[nonuniformEXT(_1107)], _1110), _896._m15.zw).x;
    float _1118 = 1.0;
    uint _1122 = _1050;
    float _1119 = texture(sampler2D(_1120[nonuniformEXT(_1122)], _1125), _896._m15.zw).x;
    uint _1136 = _1050;
    float _1133 = texture(sampler2D(_1134[nonuniformEXT(_1136)], _1139), _896._m15.zw).x;
    uint _1150 = _1050;
    vec3 _1147 = texture(sampler2D(_1148[nonuniformEXT(_1150)], _1153), _896._m15.zw).xyz;
    _984 = vec4(_1052.x, _1052.y, _1052.z, _984.w);
    _984.w = _1074.y;
    _985 = vec4(_1088.x, _1088.y, _1088.z, _985.w);
    _985.w = _1133;
    _986 = vec4(_986.x, _1074.x, _986.z, _1074.y);
    _982.x = _1119;
    _982.y = _1118;
    _982.z = _1133;
    _982.w = _1104;
    _983 = vec4(_1147.x, _1147.y, _1147.z, _983.w);
    vec2 _1186 = _908.zw;
    _1189 _1191;
    _1191._m0 = _984;
    _1191._m1 = _985;
    float _1196 = _982.x;
    _1191._m2.x = _67(_1196);
    _1191._m2 = vec4(_1191._m2.x, _982.yzw.x, _982.yzw.y, _982.yzw.z);
    _1191._m3 = _986;
    _1191._m4 = _983;
    _1189 _1210 = _1191;
    vec3 _1212 = vec3(0.0);
    bool _1220;
    if (_1007)
    {
        _1220 = _993.x < 65534.0;
    }
    else
    {
        _1220 = _1007;
    }
    bool _1226;
    if (_1220)
    {
        _1226 = _993.x > 0.0;
    }
    else
    {
        _1226 = _1220;
    }
    if (_1226)
    {
        uint _1229 = 0u;
        _1189 _1230 = _1189(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1232 = _989.y & 7u;
        uint _1241;
        if (_929._m4.x == 0.0)
        {
            _1241 = _1232;
        }
        else
        {
            vec4 _1245 = _1031._m8;
            uvec4 _1244 = _32(_1245);
            uint _1249 = _1244[_1232 / 2u];
            uint _1254 = 16u * (_1232 & 1u);
            _1241 = (_1249 >> _1254) & 65535u;
        }
        uint _1262 = _1241;
        uint _1266 = _1262;
        vec3 _1264 = texture(sampler2D(_1057[nonuniformEXT(_1266)], _1065), _1186).xyz;
        uint _1276 = _1262;
        vec2 _1274 = texture(sampler2D(_1075[nonuniformEXT(_1276)], _1080), _1186).yx;
        vec3 _1284 = vec3(0.039999999105930328369140625);
        uint _1286 = _1262;
        _1284 = texture(sampler2D(_1091[nonuniformEXT(_1286)], _1096), _1186).xyz;
        uint _1296 = _1262;
        float _1294 = texture(sampler2D(_1105[nonuniformEXT(_1296)], _1110), _1186).x;
        float _1304 = 1.0;
        uint _1307 = _1262;
        float _1305 = texture(sampler2D(_1120[nonuniformEXT(_1307)], _1125), _1186).x;
        uint _1317 = _1262;
        float _1315 = texture(sampler2D(_1134[nonuniformEXT(_1317)], _1139), _1186).x;
        uint _1327 = _1262;
        vec3 _1325 = texture(sampler2D(_1148[nonuniformEXT(_1327)], _1153), _1186).xyz;
        _1230._m0 = vec4(_1264.x, _1264.y, _1264.z, _1230._m0.w);
        _1230._m0.w = _1274.y;
        _1230._m1 = vec4(_1284.x, _1284.y, _1284.z, _1230._m1.w);
        _1230._m1.w = _1315;
        _1230._m3 = vec4(_1230._m3.x, _1274.x, _1230._m3.z, _1274.y);
        _1230._m2.x = _1305;
        _1230._m2.y = _1304;
        _1230._m2.z = _1315;
        _1230._m2.w = _1294;
        _1230._m4 = vec4(_1325.x, _1325.y, _1325.z, _1230._m4.w);
        float _1364 = _1230._m2.x;
        _1230._m2.x = _58(_1364);
        float _1369 = _1230._m1.w;
        float _1372 = _993.x * _1369;
        float _1377 = _1191._m2.x;
        float _1380 = 0.0;
        float _1381 = 0.0;
        float _1382 = (_1372 * 1.5) - 0.5;
        float _1390 = 1.0 - _1377;
        float _1387 = _10(_1390);
        float _1399 = ((_1387 + _1382) - 0.5) * 10.0;
        float _1392 = _10(_1399);
        _1380 = _1392;
        float _1402 = (_993.x * 1.5) - 0.5;
        float _1410 = 1.0 - _1377;
        float _1407 = _10(_1410);
        float _1418 = ((_1407 + _1402) - 0.5) * 10.0;
        float _1412 = _10(_1418);
        _1381 = _1412;
        _1210._m0 = mix(_1210._m0, _1230._m0, vec4(_1380));
        _1210._m1 = mix(_1210._m1, _1230._m1, vec4(_1380));
        _1210._m2 = mix(_1210._m2, _1230._m2, vec4(_1380));
        _1210._m3 = mix(_1210._m3, _1230._m3, vec4(_1380));
        _1210._m4 = mix(_1210._m4, _1230._m4, vec4(_1380));
        _981 = (_1380 > 0.5) ? _1229 : _981;
        _1212.x = _1380;
    }
    bool _1474;
    if (_1010)
    {
        _1474 = _993.y < 65534.0;
    }
    else
    {
        _1474 = _1010;
    }
    bool _1480;
    if (_1474)
    {
        _1480 = _993.y > 0.0;
    }
    else
    {
        _1480 = _1474;
    }
    if (_1480)
    {
        uint _1483 = 0u;
        _1189 _1484 = _1189(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1485 = _989.z & 7u;
        uint _1494;
        if (_929._m4.x == 0.0)
        {
            _1494 = _1485;
        }
        else
        {
            vec4 _1498 = _1031._m8;
            uvec4 _1497 = _32(_1498);
            uint _1502 = _1497[_1485 / 2u];
            uint _1507 = 16u * (_1485 & 1u);
            _1494 = (_1502 >> _1507) & 65535u;
        }
        uint _1515 = _1494;
        uint _1519 = _1515;
        vec3 _1517 = texture(sampler2D(_1057[nonuniformEXT(_1519)], _1065), _1186).xyz;
        uint _1529 = _1515;
        vec2 _1527 = texture(sampler2D(_1075[nonuniformEXT(_1529)], _1080), _1186).yx;
        vec3 _1537 = vec3(0.039999999105930328369140625);
        uint _1539 = _1515;
        _1537 = texture(sampler2D(_1091[nonuniformEXT(_1539)], _1096), _1186).xyz;
        uint _1549 = _1515;
        float _1547 = texture(sampler2D(_1105[nonuniformEXT(_1549)], _1110), _1186).x;
        float _1557 = 1.0;
        uint _1560 = _1515;
        float _1558 = texture(sampler2D(_1120[nonuniformEXT(_1560)], _1125), _1186).x;
        uint _1570 = _1515;
        float _1568 = texture(sampler2D(_1134[nonuniformEXT(_1570)], _1139), _1186).x;
        uint _1580 = _1515;
        vec3 _1578 = texture(sampler2D(_1148[nonuniformEXT(_1580)], _1153), _1186).xyz;
        _1484._m0 = vec4(_1517.x, _1517.y, _1517.z, _1484._m0.w);
        _1484._m0.w = _1527.y;
        _1484._m1 = vec4(_1537.x, _1537.y, _1537.z, _1484._m1.w);
        _1484._m1.w = _1568;
        _1484._m3 = vec4(_1484._m3.x, _1527.x, _1484._m3.z, _1527.y);
        _1484._m2.x = _1558;
        _1484._m2.y = _1557;
        _1484._m2.z = _1568;
        _1484._m2.w = _1547;
        _1484._m4 = vec4(_1578.x, _1578.y, _1578.z, _1484._m4.w);
        float _1617 = _1484._m2.x;
        _1484._m2.x = _58(_1617);
        float _1622 = _1484._m1.w;
        float _1625 = _993.y * _1622;
        float _1630 = _1210._m2.x;
        float _1633 = 0.0;
        float _1634 = 0.0;
        float _1635 = (_1625 * 1.5) - 0.5;
        float _1642 = 1.0 - _1630;
        float _1639 = _10(_1642);
        float _1650 = ((_1639 + _1635) - 0.5) * 10.0;
        float _1644 = _10(_1650);
        _1633 = _1644;
        float _1653 = (_993.y * 1.5) - 0.5;
        float _1661 = 1.0 - _1630;
        float _1658 = _10(_1661);
        float _1669 = ((_1658 + _1653) - 0.5) * 10.0;
        float _1663 = _10(_1669);
        _1634 = _1663;
        _1210._m0 = mix(_1210._m0, _1484._m0, vec4(_1633));
        _1210._m1 = mix(_1210._m1, _1484._m1, vec4(_1633));
        _1210._m2 = mix(_1210._m2, _1484._m2, vec4(_1633));
        _1210._m3 = mix(_1210._m3, _1484._m3, vec4(_1633));
        _1210._m4 = mix(_1210._m4, _1484._m4, vec4(_1633));
        _981 = (_1633 > 0.5) ? _1483 : _981;
        _1212.y = _1633;
    }
    bool _1725;
    if (_1007)
    {
        _1725 = _993.z > 0.0;
    }
    else
    {
        _1725 = _1007;
    }
    if (_1725)
    {
        _896._m37 = _993.z;
        float _1736 = 1.0 - _1210._m2.x;
        _896._m38 = _10(_1736);
    }
    _984 = _1210._m0;
    _985 = _1210._m1;
    vec3 _1744;
    if (_1007)
    {
        _1744 = vec3(0.0);
    }
    else
    {
        _1744 = _982.xyz;
    }
    _982 = vec4(_1744.x, _1744.y, _1744.z, _982.w);
    _982.w = _1210._m2.w;
    _986 = _1210._m3;
    _983 = _1210._m4;
    _896._m10 = vec3(_982.x) * _993;
    _896._m10 *= vec3(_929._m5.x);
    _896._m0 = _984.xyz;
    _896._m2 = _985.xyz;
    _896._m1 = _983.xyz;
    _896._m9 = _982.xyz;
    _896._m3 = _982.w;
    _896._m6 = _986.wyz;
    float _1799 = _1794.y * 0.5;
    float _1793 = 1.0 - _10(_1799);
    vec2 _1802 = _908.xy * _917._m29.xy;
    vec4 _1810 = SAMPLE_TEXTURE(_1812, _1802);
    vec4 _1816 = SAMPLE_TEXTURE(_1817, _1802);
    float _1821 = mix(0.449999988079071044921875, 0.64999997615814208984375, _896._m3);
    float _1830 = _1793 * 2.0;
    float _1837 = (_10(_1830) - (1.0 - _1810.w)) * 1.0;
    float _1827 = _10(_1837);
    float _1846 = (_1793 - (1.0 - _1816.w)) * 1.0;
    float _1839 = _10(_1846);
    vec3 _1850 = _1810.xyz;
    _896._m0 = mix(_896._m0, _70(_1850), vec3(_1827));
    _896._m2 = mix(_896._m2, vec3(0.039999999105930328369140625), vec3(_1827));
    _896._m3 = mix(_896._m3, _1821, _1827);
    _896._m6 = mix(_896._m6, _1816.xyz, vec3(_1839));
    uint _1878 = uint((_917._m28.x > 0.0) ? 8 : 0);
    float _1884 = 16.0;
    float _1886 = 8.0;
    float _1888 = 24.0;
    vec2 _1897 = _896._m16.xy * _929._m6.xy;
    vec3 _1890;
    _1890 = vec3(_1897.x, _1897.y, _1890.z);
    _1890.y = 1.0 - _1890.y;
    vec2 _1910 = floor(_1890.xy * vec2(_1884, _1886));
    _1890 = vec3(_1910.x, _1910.y, _1890.z);
    float _1915 = _896._m16.z;
    vec4 _1918 = _929._m7;
    float _1921 = 1.0;
    bool _1922 = false;
    float _1913 = _152(_1915, _1918, _1921, _1922);
    float _1924 = log2(max(1.0, _1913 / _929._m8.z)) * _929._m8.w;
    _1890.z = min(_1888 - 1.0, floor(_1924));
    uint _1940 = uint((_1890.x + (_1890.y * _1884)) + ((_1890.z * _1884) * _1886));
    _1940 = min(_1940, uint(((_1884 * _1886) * _1888) - 1.0));
    bool _1965 = true;
    vec3 _1967 = _896._m6;
    bool _1970 = _1965;
    _896._m7 = _157(_1967, _1970);
    vec3 _1974 = _896._m7;
    mat3 _1977 = _896._m17;
    _896._m6 = _164(_1974, _1977);
    uint _1982 = 0u;
    uint _1983 = 0u;
    uint _1984 = 0u;
    uint _1985 = 0u;
    uint _1986 = 0u;
    uint _1987 = 0u;
    int _1989 = 256;
    _1991 _1993;
    _1993._m0 = _1998._m0[_1940]._m0;
    _1993._m1 = _1998._m0[_1940]._m1;
    int _2007 = _1993._m0 & (~(_1993._m0 >> 31));
    int _2016 = _1993._m1 & (~(_1993._m1 >> 31));
    _1982 = uint((_2007 >> 16) * _1989);
    _1983 = _1982 + uint(_2016 & 255);
    _1984 = _1982;
    _1985 = _1984 + uint((_2016 >> 8) & 255);
    _1986 = _1982;
    _1987 = _1986 + uint((_2016 >> 16) & 255);
    vec3 _2049 = dFdx(_896._m14);
    vec3 _2053 = dFdy(_896._m14);
    bool _2058 = _1878 == 0u;
    bool _2064;
    if (_2058)
    {
        _2064 = _917._m28.y == 0.0;
    }
    else
    {
        _2064 = _2058;
    }
    _1984 = _2064 ? _1985 : _1984;
    uint _2068 = _1984;
    _2105 _2107;
    vec3 _2459;
    float _2564;
    while (_2068 < _1985)
    {
        uint _2078 = _2082._m0[_2068];
        uint _2087 = (_2078 >> uint(12)) & 4095u;
        uint _2093 = _2087;
        if (_2093 >= _2087)
        {
            _2068++;
        }
        int _2102 = 2;
        int _2103 = 2;
        int _2104 = 2;
        _2107._m0 = _2112._m0[(uint(_2102) * _2093) + 0u];
        _2107._m1 = _2112._m0[(uint(_2102) * _2093) + 1u];
        _2107._m2 = _2132._m0[(uint(_2103) * _2093) + 0u];
        float _2146 = _2132._m0[(uint(_2103) * _2093) + 1u].x;
        _2107._m3.x = _27(_2146);
        float _2156 = _2132._m0[(uint(_2103) * _2093) + 1u].y;
        _2107._m3.y = _27(_2156);
        float _2166 = _2132._m0[(uint(_2103) * _2093) + 1u].z;
        _2107._m4.x = _27(_2166);
        float _2176 = _2132._m0[(uint(_2103) * _2093) + 1u].w;
        _2107._m4.y = _27(_2176);
        float _2190 = _2184._m0[(uint(_2104) * _2093) + 0u].x;
        _2107._m5.x = _27(_2190);
        float _2200 = _2184._m0[(uint(_2104) * _2093) + 0u].y;
        _2107._m5.y = _27(_2200);
        float _2210 = _2184._m0[(uint(_2104) * _2093) + 0u].z;
        _2107._m6 = _27(_2210);
        float _2220 = _2184._m0[(uint(_2104) * _2093) + 0u].w;
        _2107._m7 = _27(_2220);
        float _2230 = _2184._m0[(uint(_2104) * _2093) + 1u].x;
        _2107._m8 = _27(_2230);
        float _2240 = _2184._m0[(uint(_2104) * _2093) + 1u].y;
        _2107._m9 = _27(_2240);
        float _2250 = _2184._m0[(uint(_2104) * _2093) + 1u].z;
        _2107._m10 = _27(_2250);
        float _2261 = _2184._m0[(uint(_2104) * _2093) + 1u].w;
        _2107._m11 = _27(_2261);
        vec4 _2266 = vec4(_896._m14, 1.0);
        vec3 _2273 = vec3(dot(_2266, _2107._m0), dot(_2266, _2107._m1), dot(_2266, _2107._m2));
        float _2287 = 0.0039215688593685626983642578125;
        float _2289 = _2273.x;
        float _2292 = _2273.y;
        float _2295 = _2273.z;
        bool _2300 = _43(_2289, _2292, _2295) <= _2287;
        bool _2317;
        if (!_2300)
        {
            float _2304 = _2273.x;
            float _2307 = _2273.y;
            float _2310 = _2273.z;
            _2317 = _38(_2304, _2307, _2310) >= (1.0 - _2287);
        }
        else
        {
            _2317 = _2300;
        }
        if (_2317)
        {
            continue;
        }
        uint _2321 = _2107._m11;
        bool _2325 = _1878 != 0u;
        bool _2332;
        if (_2325)
        {
            _2332 = (_2321 & 1024u) != 0u;
        }
        else
        {
            _2332 = _2325;
        }
        bool _2345;
        if (!_2332)
        {
            bool _2337 = _1878 == 0u;
            bool _2344;
            if (_2337)
            {
                _2344 = (_2321 & 2048u) != 0u;
            }
            else
            {
                _2344 = _2337;
            }
            _2345 = _2344;
        }
        else
        {
            _2345 = _2332;
        }
        if (_2345)
        {
            continue;
        }
        vec3 _2349 = _2107._m0.xyz;
        vec3 _2353 = _2107._m1.xyz;
        vec3 _2357 = _2107._m2.xyz;
        vec2 _2361 = vec2(dot(_2049, _2349), dot(_2049, _2353));
        vec2 _2369 = vec2(dot(_2053, _2349), dot(_2053, _2353));
        float _2377 = 1.0;
        float _2378 = 1.0;
        vec3 _2379 = vec3(0.5, 0.5, 1.0);
        uint _2381 = _2107._m7;
        uint _2385 = _2107._m9;
        vec4 _2384 = _107(_2385);
        uvec2 _2390 = _2107._m5;
        vec4 _2389 = _120(_2390);
        vec2 _2394 = _2361 * _2389.xy;
        vec2 _2399 = _2369 * _2389.xy;
        vec4 _2404 = TEXTURE_GRAD(_2405, (_2273.xy * _2389.xy) + _2389.zw, _2394, _2399);
        _2377 = _2404.z;
        float _2420 = _2404.w;
        _2378 = _58(_2420);
        bool _2427 = _2378 <= (4.0 * _2287);
        bool _2434;
        if (_2427)
        {
            _2434 = _2384.w <= _2287;
        }
        else
        {
            _2434 = _2427;
        }
        if (_2434)
        {
            continue;
        }
        vec2 _2438 = (_2404.xy * 2.0) - vec2(1.0);
        float _2449 = 1.0 - dot(_2438, _2438);
        _2379 = vec3(_2438, sqrt(_10(_2449)));
        if ((_2321 & 256u) != 0u)
        {
            _2459 = vec3(-_2379.x, -_2379.y, _2379.z);
        }
        else
        {
            _2459 = _2379;
        }
        _2379 = _2459;
        uint _2474 = _2107._m8;
        uint _2478 = _2474;
        float _2477 = 1.0 + (_110(_2478).w * 0.062745101749897003173828125);
        uint _2486 = _2381;
        float _2485 = _107(_2486).z;
        float _2499 = _2477 - (_2477 * abs((_2273.z * 2.0) - 1.0));
        _2378 *= _10(_2499);
        if ((_2381 & 64u) != 0u)
        {
            uint _2510 = _2381;
            float _2509 = _107(_2510).x;
            uint _2515 = _2381;
            float _2514 = _110(_2515).y;
            float _2521 = _2509;
            float _2519 = mix(_2514, 0.0, _10(_2521));
            float _2530 = _2377 - (_2519 / 255.0);
            float _2525 = float(_10(_2530) > 0.0);
            _2378 *= _2525;
        }
        vec3 _2537 = normalize(vec3(_896._m17[0].z, _896._m17[1].z, _896._m17[2].z));
        float _2546 = dot(_2537, normalize(_2357));
        float _2551 = _2546;
        vec2 _2556 = _2379.xy * _99(_2551);
        _2379 = vec3(_2556.x, _2556.y, _2379.z);
        if ((_2321 & 32768u) != 0u)
        {
            float _2569 = abs(_2546);
            _2564 = _10(_2569);
        }
        else
        {
            float _2572 = _2546;
            _2564 = _10(_2572);
        }
        float _2559 = _2564;
        float _2576 = _2378 * _2559;
        uint _2580 = _2107._m6;
        uint _2584 = _2580;
        vec4 _2589 = _107(_2584) * _2576;
        vec4 _2583 = _22(_2589);
        _896._m11 = max(_896._m11, _2583.x);
        _2349 += (_2537 * dot(_2349, _2537));
        _2353 += (_2537 * dot(_2353, _2537));
        _2379 = ((normalize(_2349) * _2379.x) + (normalize(_2353) * _2379.y)) + (_2537 * _2379.z);
        if ((_2321 & 512u) != 0u)
        {
            vec3 _2633 = mix(_2537, _2379, _2583.www);
            float _2639 = dot(_2633, _2537);
            _2379 = (_896._m6 * _2639) + ((_2633 - (_2537 * _2639)) * dot(_896._m6, _2537));
        }
        else
        {
            if ((_2321 & 128u) != 0u)
            {
                _2379 = mix(mix(_896._m6, _2537, vec3(_2576)), _2379, _2583.www);
            }
            else
            {
                _2379 = mix(_896._m6, _2379, _2583.www);
            }
        }
        _896._m6 = normalize(_2379);
        uint _2686 = _2474;
        vec3 _2685 = _107(_2686).xyz;
        float _2690 = _2378;
        if ((_2381 & 1u) != 0u)
        {
            uvec2 _2698 = _2107._m3;
            vec4 _2697 = _120(_2698);
            vec2 _2702 = _2361 * _2697.xy;
            vec2 _2707 = _2369 * _2697.xy;
            vec4 _2712 = TEXTURE_GRAD(_2405, (_2273.xy * _2697.xy) + _2697.zw, _2702, _2707);
            vec4 _2725 = _2712;
            _2712 = _64(_2725);
            float _2735 = (_2712.w - _2287) / (1.0 - _2287);
            _2690 = _10(_2735);
            _2685 *= _2712.xyz;
        }
        _896._m0 = mix(_896._m0, _2685, _2583.xxx);
        float _2748 = ((_2559 * _2690) * _2384.w) * _2485;
        _896._m10 += (_2384.xyz * (_2748 * 64.0));
        uint _2767 = _2107._m10;
        uint _2771 = _2767;
        vec4 _2770 = _107(_2771);
        float _2774 = 0.0;
        if ((_2381 & 10u) != 0u)
        {
            uvec2 _2782 = _2107._m4;
            vec4 _2781 = _120(_2782);
            vec2 _2786 = _2361 * _2781.xy;
            vec2 _2791 = _2369 * _2781.xy;
            vec4 _2796 = TEXTURE_GRAD(_2405, (_2273.xy * _2781.xy) + _2781.zw, _2786, _2791);
            if ((_2381 & 2u) != 0u)
            {
                _2770 = _2796 * _2796;
            }
            else
            {
                _2774 = _2796.w;
            }
        }
        _896._m2 = mix(_896._m2, _2770.xyz, _2583.yyy);
        _896._m3 = mix(_896._m3, _2770.w, _2583.z);
        _896._m37 = max(_896._m37, _2774);
        float _2846 = (_2377 - 0.5) * 2.0;
        _896._m38 = max(_896._m38, _10(_2846));
    }
    float _2851 = _896._m37;
    float _2850 = _76(_2851);
    float _2858 = _2850 - 0.5;
    float _2855 = _10(_2858) * 2.0;
    float _2869 = _2850 * 2.0;
    float _2861 = (_896._m38 * _896._m38) * _10(_2869);
    float _2876 = _2861 + _2855;
    float _2872 = _10(_2876);
    if (_2872 > 0.0039215688593685626983642578125)
    {
        vec3 _2884 = _896._m0;
        float _2891 = _2872 * 1.0;
        float _2892 = 0.0;
        float _2893 = 0.3499999940395355224609375;
        _896._m0 = mix(_896._m0, _73(_2884), vec3(_81(_2891, _2892, _2893) * (1.0 - _896._m3)));
        float _2907 = _2872 * 1.0;
        float _2908 = 0.25;
        float _2909 = 0.5;
        _896._m2 = mix(_896._m2, vec3(0.039999999105930328369140625), vec3(_81(_2907, _2908, _2909)));
        vec3 _2914 = vec3(_896._m17[0].z, _896._m17[1].z, _896._m17[2].z);
        float _2928 = _2914.z + 0.0625;
        float _2922 = _2872 * _10(_2928);
        float _2937 = _2922 * 1.0;
        float _2938 = 0.20000000298023223876953125;
        float _2939 = 1.0;
        _896._m3 = mix(_896._m3, 0.89999997615814208984375, _81(_2937, _2938, _2939));
        float _2947 = _2922 * 1.0;
        float _2948 = 0.449999988079071044921875;
        float _2949 = 0.980000019073486328125;
        float _2943 = _81(_2947, _2948, _2949);
        _896._m6 = normalize(mix(_896._m6, vec3(0.0, 0.0, 1.0), vec3(_2943)));
        _896._m7 = mix(_896._m6, vec3(0.5, 0.5, 1.0), vec3(_2943));
        if (_2922 > 0.980000019073486328125)
        {
            float _2972 = _2922 * _2943;
            float _2973 = 0.980000019073486328125;
            float _2974 = 1.0;
            _2914 = normalize(mix(_2914, vec3(0.0, 0.0, 1.0), vec3(_81(_2972, _2973, _2974))));
            _896._m17[0].z = _2914.x;
            _896._m17[1].z = _2914.y;
            _896._m17[2].z = _2914.z;
        }
    }
    vec3 _2988 = vec3(0.0);
    vec3 _2989 = vec3(_896._m34.x, _896._m34.y, _896._m34.z);
    vec3 _2997 = vec3(_896._m34.w, _896._m35.x, _896._m35.y);
    vec3 _3005 = vec3(_896._m35.z, _896._m35.w, _896._m36.x);
    vec3 _3013 = vec3(_896._m36.y, _896._m36.z, _896._m36.w);
    vec3 _3021 = ((_2989 - (_2997 * _896._m6.y)) + (_3005 * _896._m6.z)) - (_3013 * _896._m6.x);
    float _3045 = _917._m30.x * _929._m9.x;
    _2988 += max(_3021 * _10(_3045), vec3(0.0));
    float _3056;
    if (dot(_896._m10, vec3(1.0)) > 0.0)
    {
        _3056 = -_896._m3;
    }
    else
    {
        _3056 = _896._m3;
    }
    _896._m3 = _3056;
    _896._m18 = _2988;
    _896._m19 = _2988;
    uint _3073 = _1982;
    _3102 _3104;
    vec3 _3422;
    float _3511;
    float _3529;
    uint _3873;
    _3899 _3901;
    uint _4023;
    _3899 _4047;
    while (_3073 < _1983)
    {
        uint _3083 = _2082._m0[_3073];
        uint _3087 = _3083 & 4095u;
        uint _3090 = _3087;
        if (_3090 >= _3087)
        {
            _3073++;
        }
        int _3099 = 4;
        int _3100 = 4;
        int _3101 = 4;
        _3104._m0 = _3108._m0[(uint(_3099) * _3090) + 0u].xyz;
        float _3123 = _3108._m0[(uint(_3099) * _3090) + 0u].w;
        _3104._m1 = _27(_3123);
        _3104._m2 = _3108._m0[(uint(_3099) * _3090) + 1u];
        _3104._m3 = _3108._m0[(uint(_3099) * _3090) + 2u];
        _3104._m4 = _3147._m0[(uint(_3100) * _3090) + 0u];
        _3104._m5 = _3147._m0[(uint(_3100) * _3090) + 1u];
        _3104._m6 = _3147._m0[(uint(_3100) * _3090) + 2u];
        float _3177 = _3108._m0[(uint(_3099) * _3090) + 3u].x;
        _3104._m7.x = _27(_3177);
        float _3187 = _3108._m0[(uint(_3099) * _3090) + 3u].y;
        _3104._m7.y = _27(_3187);
        float _3197 = _3108._m0[(uint(_3099) * _3090) + 3u].z;
        _3104._m7.z = _27(_3197);
        float _3207 = _3108._m0[(uint(_3099) * _3090) + 3u].w;
        _3104._m7.w = _27(_3207);
        _3104._m8 = _3215._m0[(uint(_3101) * _3090) + 0u];
        _3104._m9 = _3215._m0[(uint(_3101) * _3090) + 1u];
        _3104._m10 = _3215._m0[(uint(_3101) * _3090) + 2u];
        _3104._m11 = _3215._m0[(uint(_3101) * _3090) + 3u];
        float _3253 = _3147._m0[(uint(_3100) * _3090) + 3u].x;
        _3104._m12 = _27(_3253);
        float _3263 = _3147._m0[(uint(_3100) * _3090) + 3u].y;
        _3104._m13 = _27(_3263);
        _3104._m14 = _3147._m0[(uint(_3100) * _3090) + 3u].z;
        float _3281 = _3147._m0[(uint(_3100) * _3090) + 3u].w;
        _3104._m15 = _27(_3281);
        uint _3286 = (_3104._m12 >> uint(16)) & 3u;
        if (((_896._m40 >> uint(4)) & 3u) != _3286)
        {
            continue;
        }
        float _3300 = 0.0039215688593685626983642578125;
        vec4 _3301 = vec4(_896._m14, 1.0);
        float _3308 = 1.0 / dot(_3301, _3104._m6);
        vec3 _3314 = vec3(dot(_3301, _3104._m4) * _3308, dot(_3301, _3104._m5) * _3308, dot(_3301, _3104._m3));
        uint _3332 = _3104._m1;
        uint _3335 = _1878;
        _3335 |= 64u;
        float _3339 = _3314.x;
        float _3342 = _3314.y;
        float _3345 = _3314.z;
        bool _3350 = _43(_3339, _3342, _3345) <= _3300;
        bool _3367;
        if (!_3350)
        {
            float _3354 = _3314.x;
            float _3357 = _3314.y;
            float _3360 = _3314.z;
            _3367 = _38(_3354, _3357, _3360) >= (1.0 - _3300);
        }
        else
        {
            _3367 = _3350;
        }
        bool _3375;
        if (!_3367)
        {
            _3375 = (_3332 & _3335) != 0u;
        }
        else
        {
            _3375 = _3367;
        }
        if (_3375)
        {
            continue;
        }
        if ((_3332 & 3u) == 2u)
        {
            vec2 _3394 = fract((_3314.xy * _929._m10.xy) + _929._m10.zw);
            _3314 = vec3(_3394.x, _3394.y, _3314.z);
        }
        vec3 _3397 = _3104._m0;
        float _3400 = 1.0;
        float _3401 = 1.0;
        vec3 _3402 = vec3(0.0, 0.0, 1.0);
        vec3 _3403 = vec3(0.0, 0.0, 1.0);
        uint _3404 = _3104._m1;
        vec3 _3407 = (_3314 * 2.0) - vec3(1.0);
        vec2 _3412 = _3314.xy;
        vec3 _3415 = _3104._m10.xyz;
        if ((_3404 & 3u) == 2u)
        {
            _3422 = _3415;
        }
        else
        {
            _3422 = normalize(_3397 - _896._m14);
        }
        _3402 = _3422;
        _3402 = _3402;
        float _3439 = dot(_896._m6, _3402);
        float _3434 = _10(_3439);
        bool _3443 = _3434 <= _3300;
        bool _3450;
        if (_3443)
        {
            _3450 = (_3404 & 48u) == 0u;
        }
        else
        {
            _3450 = _3443;
        }
        if (_3450)
        {
            continue;
        }
        uvec2 _3455 = _3104._m7.zw;
        vec4 _3454 = _120(_3455);
        float _3460 = TEXTURE_LOD(_3461, vec4((_3412 * _3454.xy) + _3454.zw, 0.0, 0.0).xy, vec4((_3412 * _3454.xy) + _3454.zw, 0.0, 0.0).w).x;
        float _3487 = _3460 * _3460;
        uint _3491 = _3404 & 3u;
        bool _3496 = _3491 == 1u;
        bool _3508;
        if (!_3496)
        {
            bool _3501 = _3491 == 0u;
            bool _3507;
            if (_3501)
            {
                _3507 = _3104._m8.z != 0.0;
            }
            else
            {
                _3507 = _3501;
            }
            _3508 = _3507;
        }
        else
        {
            _3508 = _3496;
        }
        bool _3494 = _3508;
        if (_3494)
        {
            float _3514 = _3104._m8.w;
            _3511 = _10(_3514);
        }
        else
        {
            _3511 = 0.5;
        }
        float _3509 = _3511;
        bool _3522 = _3491 == 0u;
        bool _3528;
        if (_3522)
        {
            _3528 = _3104._m8.z != 0.0;
        }
        else
        {
            _3528 = _3522;
        }
        if (_3528)
        {
            float _3537 = sqrt(dot(_3407, _3407));
            _3529 = min(0.9921875, _10(_3537));
        }
        else
        {
            _3529 = _3314.z;
        }
        float _3520 = _3529;
        uvec2 _3545 = _3104._m7.xy;
        vec4 _3544 = _120(_3545);
        vec2 _3550 = vec2(_3520, _3509);
        float _3554 = TEXTURE_LOD(_3461, vec4((_3550 * _3544.xy) + _3544.zw, 0.0, 0.0).xy, vec4((_3550 * _3544.xy) + _3544.zw, 0.0, 0.0).w).x;
        _3554 *= _3554;
        _3400 = _3554 * _3487;
        if ((_3404 & 48u) != 0u)
        {
            vec4 _3591 = _3104._m10;
            vec4 _3594 = _3104._m8;
            vec4 _3597 = _3104._m9;
            float _3600 = dot(_896._m14, _3591.xyz) + _3591.w;
            if (_3600 < 0.0)
            {
                continue;
            }
            float _3614 = length(_3591.xyz);
            float _3621 = _3600 * 50.0;
            float _3618 = _10(_3621);
            _3400 *= (_3618 * _3618);
            _3600 /= _3614;
            _3591 /= vec4(_3614);
            vec3 _3635 = reflect(-_896._m13, _896._m6);
            if (dot(_3635, _3591.xyz) > 0.0)
            {
                _3635 = reflect(_3635, _3591.xyz);
            }
            float _3653 = dot(_3635, _3591.xyz);
            float _3658 = _3600 / _3653;
            vec3 _3662 = _896._m14 - (_3635 * _3658);
            vec3 _3669 = _3662 - _3397;
            float _3673 = dot(_3669, _3594.xyz) / _3594.w;
            float _3681 = dot(_3669, _3597.xyz) / _3597.w;
            if ((_3404 & 48u) == 32u)
            {
                vec2 _3695 = vec2(_3673, _3681);
                float _3699 = 1.0 / max(1.0, length(vec2(_3673, _3681)));
                _3673 *= (_3699 * _3594.w);
                _3681 *= (_3699 * _3597.w);
            }
            else
            {
                float _3721 = abs(_3673);
                float _3723 = _3673;
                _3673 = (_10(_3721) * _99(_3723)) * _3594.w;
                float _3732 = abs(_3681);
                float _3734 = _3681;
                _3681 = (_10(_3732) * _99(_3734)) * _3597.w;
            }
            vec3 _3741 = (_3594.xyz * _3673) + (_3597.xyz * _3681);
            _3397 += _3741;
            _3402 = normalize(_3397 - _896._m14);
            _3402 = _3402;
        }
        else
        {
            uint _3761 = (_3104._m15 >> uint(16)) & 255u;
            if (_3761 == 0u)
            {
                vec4 _3770 = _3104._m9;
                if (dot(_3770.xyz, _896._m14) < (_3770.w - _3300))
                {
                    continue;
                }
            }
            else
            {
                if (_3761 == 1u)
                {
                    vec3 _3791 = _3104._m9.xyz;
                    float _3796 = _3104._m9.w;
                    uint _3800 = _27(_3796);
                    vec3 _3795 = (((_114(_3800) * 2.0) - vec3(1.0)) * _3791) + _3397;
                    vec3 _3809 = abs((_896._m14 - _3795) / _3791);
                    float _3817 = _3809.x;
                    float _3820 = _3809.y;
                    float _3823 = _3809.z;
                    if (_38(_3817, _3820, _3823) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3400 <= (_3300 / 256.0))
        {
            continue;
        }
        float _3839 = 1.0;
        if ((_3332 & 4u) != 0u)
        {
            float _3846 = float(_3104._m15 & 255u) / 255.0;
            float _3852 = 0.00999999977648258209228515625;
            vec3 _3854 = _896._m14 + (_896._m6 * _3852);
            if ((_3332 & 3u) == 0u)
            {
                vec3 _3867 = _3854 - _3104._m2.xyz;
                float _3874 = _3867.x;
                float _3877 = _3867.y;
                float _3880 = _3867.z;
                _3873 = _49(_3874, _3877, _3880);
            }
            else
            {
                if ((_3332 & 3u) == 2u)
                {
                    float _3890 = 0.0;
                    _3873 = 0u;
                    for (; _3873 < 3u; _3873++)
                    {
                        int _3898 = 5;
                        _3901._m0 = _3905._m0[(uint(_3898) * ((_3332 >> uint(22)) + _3873)) + 0u];
                        _3901._m1 = _3905._m0[(uint(_3898) * ((_3332 >> uint(22)) + _3873)) + 1u];
                        _3901._m2 = _3905._m0[(uint(_3898) * ((_3332 >> uint(22)) + _3873)) + 2u];
                        _3901._m3 = _3905._m0[(uint(_3898) * ((_3332 >> uint(22)) + _3873)) + 3u];
                        _3901._m4 = _3905._m0[(uint(_3898) * ((_3332 >> uint(22)) + _3873)) + 4u];
                        vec2 _3962 = vec2(dot(_3854, _3901._m0.xyz) + _3901._m0.w, dot(_3854, _3901._m1.xyz) + _3901._m1.w);
                        _3962 = abs((_3962 * 2.0) - vec2(1.0));
                        bool _3988 = _3962.x < 0.99500000476837158203125;
                        bool _3994;
                        if (_3988)
                        {
                            _3994 = _3962.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3994 = _3988;
                        }
                        if (_3994)
                        {
                            _3890 = (1.0 - max(_3962.x, _3962.y)) * _929._m11.w;
                            break;
                        }
                    }
                    _3873 = min(2u, _3873);
                    uint _4011 = uint(_896._m16.x) ^ (uint(_896._m16.y) << uint(1));
                    if (_929._m12.w > 0.0)
                    {
                        _4023 = uint(_929._m13.x);
                    }
                    else
                    {
                        _4023 = 0u;
                    }
                    _4011 ^= _4023;
                    _3873 += uint(int(((float(_4011 & 3u) * 0.25) + 0.125) > _3890));
                }
                else
                {
                    _3873 = 0u;
                }
            }
            int _4046 = 5;
            _4047._m0 = _3905._m0[(uint(_4046) * ((_3332 >> uint(22)) + _3873)) + 0u];
            _4047._m1 = _3905._m0[(uint(_4046) * ((_3332 >> uint(22)) + _3873)) + 1u];
            _4047._m2 = _3905._m0[(uint(_4046) * ((_3332 >> uint(22)) + _3873)) + 2u];
            _4047._m3 = _3905._m0[(uint(_4046) * ((_3332 >> uint(22)) + _3873)) + 3u];
            _4047._m4 = _3905._m0[(uint(_4046) * ((_3332 >> uint(22)) + _3873)) + 4u];
            vec4 _4103 = vec4((_3854.x * _4047._m0.x) + ((_3854.y * _4047._m0.y) + ((_3854.z * _4047._m0.z) + _4047._m0.w)), (_3854.x * _4047._m1.x) + ((_3854.y * _4047._m1.y) + ((_3854.z * _4047._m1.z) + _4047._m1.w)), (_3854.x * _4047._m2.x) + ((_3854.y * _4047._m2.y) + ((_3854.z * _4047._m2.z) + _4047._m2.w)), (_3854.x * _4047._m3.x) + ((_3854.y * _4047._m3.y) + ((_3854.z * _4047._m3.z) + _4047._m3.w)));
            vec3 _4190 = _4103.xyz / vec3(_4103.w);
            _4103 = vec4(_4190.x, _4190.y, _4190.z, _4103.w);
            bool _4198 = min(_4103.x, _4103.y) > 0.0;
            bool _4207;
            if (_4198)
            {
                _4207 = max(_4103.x, _4103.y) < 1.0;
            }
            else
            {
                _4207 = _4198;
            }
            if (_4207)
            {
                vec2 _4219 = (_4103.xy * _4047._m4.xy) + _4047._m4.zw;
                _4103 = vec4(_4219.x, _4219.y, _4103.z, _4103.w);
                if (false)
                {
                    _3839 = textureLod(_4227, vec3(_4103.xyz.xy, _4103.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4234 = (_4103.xy * _929._m14.xy) + vec2(0.5);
                    vec2 _4243 = floor(_4234);
                    vec2 _4246 = _4234 - _4243;
                    _4243 -= vec2(0.5);
                    vec2 _4253 = vec2(4.0) - (_4246 * 3.0);
                    vec2 _4259 = vec2(7.0);
                    vec2 _4262 = vec2(1.0) + (_4246 * 3.0);
                    vec2 _4267 = (_4243 + (((vec2(3.0) - (_4246 * 2.0)) / _4253) - vec2(2.0))) * _929._m14.zw;
                    vec2 _4282 = (_4243 + ((vec2(3.0) + _4246) / _4259)) * _929._m14.zw;
                    vec2 _4294 = (_4243 + ((_4246 / _4262) + vec2(2.0))) * _929._m14.zw;
                    vec3 _4318 = vec3(_4267.x, _4267.y, _4103.z);
                    _3839 = (_4253.x * _4253.y) * textureLod(_4227, vec3(_4318.xy, _4318.z), 0.0);
                    vec3 _4334 = vec3(_4282.x, _4267.y, _4103.z);
                    _3839 += ((_4259.x * _4253.y) * textureLod(_4227, vec3(_4334.xy, _4334.z), 0.0));
                    vec3 _4352 = vec3(_4294.x, _4267.y, _4103.z);
                    _3839 += ((_4262.x * _4253.y) * textureLod(_4227, vec3(_4352.xy, _4352.z), 0.0));
                    vec3 _4370 = vec3(_4267.x, _4282.y, _4103.z);
                    _3839 += ((_4253.x * _4259.y) * textureLod(_4227, vec3(_4370.xy, _4370.z), 0.0));
                    vec3 _4388 = vec3(_4282.x, _4282.y, _4103.z);
                    _3839 += ((_4259.x * _4259.y) * textureLod(_4227, vec3(_4388.xy, _4388.z), 0.0));
                    vec3 _4406 = vec3(_4294.x, _4282.y, _4103.z);
                    _3839 += ((_4262.x * _4259.y) * textureLod(_4227, vec3(_4406.xy, _4406.z), 0.0));
                    vec3 _4424 = vec3(_4267.x, _4294.y, _4103.z);
                    _3839 += ((_4253.x * _4262.y) * textureLod(_4227, vec3(_4424.xy, _4424.z), 0.0));
                    vec3 _4442 = vec3(_4282.x, _4294.y, _4103.z);
                    _3839 += ((_4259.x * _4262.y) * textureLod(_4227, vec3(_4442.xy, _4442.z), 0.0));
                    vec3 _4460 = vec3(_4294.x, _4294.y, _4103.z);
                    _3839 += ((_4262.x * _4262.y) * textureLod(_4227, vec3(_4460.xy, _4460.z), 0.0));
                    _3839 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3839 = float((_3332 & 3u) == 2u);
            }
            float _4474 = float((_3332 >> uint(16)) & 63u) / 63.0;
            float _4488 = ((_3839 * _4474) + 1.0) - _4474;
            _3839 = _10(_4488);
        }
        uint _4491 = _3104._m13;
        vec3 _4490 = (_123(_4491) * _3839) * _3400;
        _3401 *= _3104._m14;
        vec3 _4503 = _4490;
        vec3 _4505 = _3402;
        float _4512 = dot(_896._m6, _4505);
        float _4507 = _10(_4512);
        vec3 _4518 = _896._m6;
        vec3 _4521 = _896._m13;
        vec3 _4524 = _3402;
        vec3 _4526 = _896._m2;
        float _4529 = abs(_896._m3);
        vec3 _4514 = _136(_4518, _4521, _4524, _4526, _4529);
        _896._m20 += (((_4514 * _3401) * _4503) * _4507);
        vec3 _4543 = mix(_4503, vec3(0.0), bvec3((_3332 & 256u) > 0u));
        _896._m19 += (_4543 * _4507);
    }
    float _4558 = _929._m15.x;
    if (_4558 > 0.00999999977648258209228515625)
    {
        float _4565 = float(int(_929._m13.x) & 1023) / 1023.0;
        _4558 = max(0.0, _4558 + (((_4565 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4581 = _896._m13;
        float _4589 = dot(_896._m6, _4581);
        float _4584 = _10(_4589);
        float _4591 = _4584 * _4558;
        vec3 _4599 = _896._m6;
        vec3 _4602 = _896._m13;
        vec3 _4605 = _896._m2;
        float _4608 = abs(_896._m3);
        vec3 _4595 = _143(_4599, _4602, _4605, _4608) * _4558;
        _896._m19 += vec3(_4591);
        _896._m20 += vec3(_4595);
    }
    _896._m19 = _896._m19;
    _896._m20 += _896._m10;
    float _4636 = 0.064999997615814208984375;
    float _4638 = 1.0 + _4636;
    bool _4641 = false;
    uint _4646;
    if (_929._m16.w > 0.00999999977648258209228515625)
    {
        _4646 = uint(_929._m16.x);
    }
    else
    {
        _4646 = 0u;
    }
    uint _4642 = _4646;
    _4664 _4666;
    for (uint _4654 = 0u; _4654 < _4642; _4654++)
    {
        int _4663 = 4;
        _4666._m0 = _4670._m0[(uint(_4663) * _4654) + 0u];
        _4666._m1 = _4670._m0[(uint(_4663) * _4654) + 1u];
        _4666._m2 = _4670._m0[(uint(_4663) * _4654) + 2u];
        float _4700 = _4670._m0[(uint(_4663) * _4654) + 3u].x;
        _4666._m3 = _27(_4700);
        float _4710 = _4670._m0[(uint(_4663) * _4654) + 3u].y;
        _4666._m4 = _27(_4710);
        float _4720 = _4670._m0[(uint(_4663) * _4654) + 3u].z;
        _4666._m5 = _27(_4720);
        vec4 _4725 = vec4(_896._m14, 1.0);
        vec3 _4732 = vec3(dot(_4725, _4666._m1), dot(_4725, _4666._m2), dot(_4725, _4666._m0));
        float _4746 = _4732.x;
        float _4749 = _4732.y;
        float _4752 = _4732.z;
        bool _4756 = _43(_4746, _4749, _4752) >= 0.0;
        bool _4765;
        if (_4756)
        {
            _4765 = max(_4732.x, _4732.y) < 1.0;
        }
        else
        {
            _4765 = _4756;
        }
        bool _4772;
        if (_4765)
        {
            _4772 = _4732.z < _4638;
        }
        else
        {
            _4772 = _4765;
        }
        if (_4772)
        {
            float _4775 = _4732.z;
            vec4 _4778 = vec4(_896._m14, 1.0);
            vec2 _4785 = vec2(0.0);
            _4785 = (((_4778.xy - _929._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4798 = 0.000244140625;
            float _4804 = abs(_896._m6.z) * 2.0;
            _4798 *= _10(_4804);
            vec3 _4808 = vec3(TEXTURE_LOD(_4809, vec4(_4785 + vec2(_4798), 0.0, 0.0).xy, vec4(_4785 + vec2(_4798), 0.0, 0.0).w).x, TEXTURE_LOD(_4809, vec4(_4785, 0.0, 0.0).xy, vec4(_4785, 0.0, 0.0).w).x, TEXTURE_LOD(_4809, vec4(_4785 - vec2(_4798), 0.0, 0.0).xy, vec4(_4785 - vec2(_4798), 0.0, 0.0).w).x);
            float _4872 = 2.0 - (2.0 * (length(_4778.xy - _929._m17.zw) / 16.0));
            _4808 *= _10(_4872);
            float _4879 = 1.0 - _4775;
            float _4876 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4879));
            float _4890 = (_896._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4882 = (_4808 * _4876) * _10(_4890);
            float _4899 = _4638 - _4775;
            float _4893 = (1.0 - _4876) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4899));
            float _4913 = ((-_896._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4903 = (_4808 * _4893) * _10(_4913);
            _4808 = _4882 + _4903;
            float _4924 = 1.02499997615814208984375 - _4775;
            float _4919 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4924));
            float _4927 = _929._m16.w;
            _896._m19 = mix(_896._m19, (_896._m19 * _4808) + (_896._m19 * mix(1.0, 0.5, _4919)), vec3(_4927));
            break;
        }
    }
    _896._m19 *= _896._m0;
    _896._m21 = _896._m19 + _896._m20;
    vec2 _4961 = gl_FragCoord.xy * _929._m6.zw;
    vec4 _4968 = (SAMPLE_TEXTURE(_4969, _4961 + vec2(_929._m1.x * 0.5)) * 2.0) - vec4(1.0);
    _4968 *= 0.100000001490116119384765625;
    vec2 _4983 = (_896._m6.xy * 2.0) - vec2(1.0);
    vec2 _4990 = mix(_4968.xy, _4983 * 0.064999997615814208984375, vec2(0.3499999940395355224609375)) * 0.333000004291534423828125;
    float _4999 = 2.0;
    float _5000 = 0.89999997615814208984375;
    float _5001 = 0.949999988079071044921875;
    float _5003 = 0.89999997615814208984375;
    float _5004 = 0.0076199998147785663604736328125 * _4999;
    vec3 _5008 = normalize(refract(_896._m6, -_896._m13, _5003));
    vec3 _5054 = _896._m14 + ((_5008 * _5004) * 1.0);
    mat4 _5055 = mat4(vec4(_929._m18), vec4(_929._m19), vec4(_929._m20), vec4(_929._m21));
    vec4 _5017 = _88(_5054, _5055);

    // FIX FOR GLASS    
     if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (_5017.w > vk3d_params[VIEW].custom_params.z)
            _5017.x += vk3d_params[VIEW].stereo.x * (_5017.w - vk3d_params[VIEW].stereo.y)* 0.5; 
        else
            _5017.x += vk3d_params[VIEW].stereo.x * (_5017.w - vk3d_params[VIEW].custom_params.w)* 0.75 * 0.5;
    }
    else
    {
           _5017.x += vk3d_params[VIEW].stereo.x * (_5017.w - vk3d_params[VIEW].stereo.y)* 0.5;
    }
    vec2 _5062 = _5017.xy / vec2(_5017.w);
    
    _5017 = vec4(_5062.x, _5062.y, _5017.z, _5017.w);
    vec3 _5065 = normalize(_929._m2.xyz - _896._m14);
    float _5078 = dot(_896._m6, _5065);
    float _5073 = 1.0 - _10(_5078);
    float _5084 = pow(_5073, 5.0);
    float _5081 = _10(_5084);
    float _5089 = pow(_5073, 2.0);
    float _5086 = _10(_5089);
    float _5091 = _5081;
    float _5093 = _4990.x;
    vec2 _5096 = vec2(_5017.x + _5093, _5017.y);
    vec2 _5104 = vec2(_5017.x - _5093, _5017.y);
    float _5112 = mix(min(_896._m3, 0.99989998340606689453125), _5001, _5000);
    vec3 _5120 = vec3(0.0);
    float _5121 = fract(_5112 * 4.0);
    if (_5112 > 0.97500002384185791015625)
    {
        _5120.x = TEXTURE_LOD(_5130, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x;
        _5120.y = TEXTURE_LOD(_5130, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y;
        _5120.z = TEXTURE_LOD(_5130, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z;
    }
    else
    {
        if (_5112 > 0.75)
        {
            _5120.x = mix(TEXTURE_LOD(_5181, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, TEXTURE_LOD(_5130, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, _5121);
            _5120.y = mix(TEXTURE_LOD(_5181, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, TEXTURE_LOD(_5130, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, _5121);
            _5120.z = mix(TEXTURE_LOD(_5181, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, TEXTURE_LOD(_5130, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, _5121);
        }
        else
        {
            if (_5112 > 0.5)
            {
                _5120.x = mix(TEXTURE_LOD(_5278, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, TEXTURE_LOD(_5181, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, _5121);
                _5120.y = mix(TEXTURE_LOD(_5278, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, TEXTURE_LOD(_5181, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, _5121);
                _5120.z = mix(TEXTURE_LOD(_5278, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, TEXTURE_LOD(_5181, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, _5121);
            }
            else
            {
                if (_5112 > 0.25)
                {
                    _5120.x = mix(TEXTURE_LOD(_5375, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, TEXTURE_LOD(_5278, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, _5121);
                    _5120.y = mix(TEXTURE_LOD(_5375, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, TEXTURE_LOD(_5278, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, _5121);
                    _5120.z = mix(TEXTURE_LOD(_5375, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, TEXTURE_LOD(_5278, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, _5121);
                }
                else
                {
                    _5120.x = mix(TEXTURE_LOD(_5468, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, TEXTURE_LOD(_5375, vec4(_5096, 0.0, 0.0).xy, vec4(_5096, 0.0, 0.0).w).x, _5121);
                    _5120.y = mix(TEXTURE_LOD(_5468, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, TEXTURE_LOD(_5375, vec4(_5017.xy, 0.0, 0.0).xy, vec4(_5017.xy, 0.0, 0.0).w).y, _5121);
                    _5120.z = mix(TEXTURE_LOD(_5468, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, TEXTURE_LOD(_5375, vec4(_5104, 0.0, 0.0).xy, vec4(_5104, 0.0, 0.0).w).z, _5121);
                }
            }
        }
    }
    vec4 _5560 = TEXTURE_LOD(_5561, vec4(_4961 + _4990, 0.0, 2.0).xy, vec4(_4961 + _4990, 0.0, 2.0).w);
    vec3 _5578 = _896._m19;
    vec3 _5581 = _896._m20;
    float _5584 = 0.375;
    _896._m19 = mix(_5120, _5560.xyz, vec3(_5584));
    _896._m19 = mix(_5120, _5560.xyz, vec3(_5086));
    float _5600 = SAMPLE_TEXTURE(_4969, (_908.xy + vec2(0.0)) * vec2(1.730000019073486328125)).y;
    float _5610 = SAMPLE_TEXTURE(_4969, (_908.xy + vec2(0.5)) * vec2(5.389999866485595703125)).y;
    float _5621 = ((_5600 - 0.23529399931430816650390625) * 2.8333346843719482421875) * 1.0;
    float _5628 = ((_5610 - 0.23529399931430816650390625) * 2.8333346843719482421875) * 1.0;
    float _5635 = _1794.y;
    float _5638 = 0.0;
    float _5639 = 0.449999988079071044921875;
    float _5643 = _1794.y;
    float _5646 = 0.3499999940395355224609375;
    float _5647 = 0.75;
    float _5633 = mix(1.0, _5621, _81(_5635, _5638, _5639)) * mix(1.0, _5628, _81(_5643, _5646, _5647));
    float _5655 = _1794.y * 0.5;
    float _5651 = 1.0 - _10(_5655);
    vec2 _5658 = _908.xy * _917._m29.xy;
    float _5665 = SAMPLE_TEXTURE(_1812, _5658).w;
    float _5676 = pow(_5633, 13.0);
    float _5679 = (_5651 * 2.0) * _10(_5676);
    float _5685 = (_10(_5679) - (1.0 - _5665)) * 1.0;
    float _5670 = _10(_5685);
    float _5694 = pow(max(9.9999997473787516355514526367188e-06, (_5670 - 0.25) * 1.34000003337860107421875), 0.25);
    _5670 = _10(_5694);
    _5091 = mix(_5091, 1.0, _5670);
    _896._m19 = mix(_896._m19, _5578, vec3(_5670));
    _896._m20 *= _5091;
    vec3 _5717 = _896._m19 + _896._m20;
    _5712 = vec4(_5717.x, _5717.y, _5717.z, _5712.w);
    vec3 _5721 = _896._m6;
    bool _5724 = false;
    vec2 _5725 = _175(_5721, _5724);
    _5720 = vec4(_5725.x, _5725.y, _5720.z, _5720.w);
    float _5729 = _896._m2.x;
    float _5733 = _896._m2.y;
    float _5737 = _896._m2.z;
    float _5741 = _896._m3;
    _5728 = vec4(_102(_5729), _102(_5733), _102(_5737), _178(_5741));
    _5746 = vec4(0.0, 0.0, 0.0, float((uint(_917._m28.z) & 3u) << uint(4)) / 255.0);
    vec3 _5759 = _896._m19 + _896._m20;
    _5712 = vec4(_5759.x, _5759.y, _5759.z, _5712.w);
    vec3 _5762 = _896._m6;
    bool _5765 = false;
    vec2 _5766 = _175(_5762, _5765);
    _5720 = vec4(_5766.x, _5766.y, _5720.z, _5720.w);
    float _5769 = _896._m2.x;
    float _5773 = _896._m2.y;
    float _5777 = _896._m2.z;
    float _5781 = _896._m3;
    _5728 = vec4(_102(_5769), _102(_5773), _102(_5777), _178(_5781));
    vec3 _5791 = _5712.xyz + _917._m31.xyz;
    _5712 = vec4(_5791.x, _5791.y, _5791.z, _5712.w);
    _5720 = vec4(_5712.xyz.x, _5712.xyz.y, _5712.xyz.z, _5720.w);
}



