#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _279_281
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _281;

layout(set = 2, binding = 0, std140) uniform _298_300
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _300;

layout(set = 1, binding = 0, std140) uniform _411_413
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _413;

layout(push_constant, std430) uniform _763_765
{
    int _m0;
    int _m1;
} _765;

layout(set = 3, binding = 0) uniform texture2D _310[65536];
layout(set = 0, binding = 1) uniform sampler _318;
layout(set = 2, binding = 1) uniform SAMPLER_2D _349;
layout(set = 0, binding = 2) uniform SAMPLER_2D _376;
layout(set = 0, binding = 3) uniform sampler3D _563;
layout(set = 0, binding = 4) uniform sampler3D _584;
layout(set = 0, binding = 5) uniform sampler3D _707;

layout(location = 2) in vec4 _321;
layout(location = 3) in vec4 _327;
layout(location = 4) in vec4 _419;
layout(location = 0) in vec4 _433;
layout(location = 0) out vec4 _743;

float _62(vec4 _61)
{
    return _61.z;
}

uint _19(float _18)
{
    return floatBitsToUint(_18);
}

float _22(float _21)
{
    return _21 * ((_21 * ((_21 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _28(vec3 _27)
{
    float _102 = _27.x;
    vec3 _101;
    _101.x = _22(_102);
    float _108 = _27.y;
    _101.y = _22(_108);
    float _114 = _27.z;
    _101.z = _22(_114);
    return _101;
}

vec4 _34(vec4 _33)
{
    vec3 _124 = _33.xyz;
    vec4 _123 = vec4(_28(_124), 1.0);
    float _132 = _33.w;
    _123.w = _22(_132);
    return _123;
}

vec4 _58(SAMPLER_2D _56, vec2 _57)
{
    vec4 _243 = SAMPLE_TEXTURE(_56, _57);
    vec4 _247 = _243;
    _243 = _34(_247);
    return _243;
}

void _14(float _13)
{
    if (_13 < 0.0)
    {
        discard;
    }
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _71(float _67, vec4 _68, float _69, bool _70)
{
    float _257 = _68.w / (_67 + _68.z);
    return _257 * _69;
}

float _37(float _36)
{
    float _141 = (((-0.15658299624919891357421875) * abs(_36)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_36));
    float _155;
    if (_36 >= 0.0)
    {
        _155 = _141;
    }
    else
    {
        _155 = 3.1415927410125732421875 - _141;
    }
    return _155;
}

float _40(float _39)
{
    float _169;
    if (_39 < 1.0)
    {
        _169 = _39;
    }
    else
    {
        _169 = 1.0 / _39;
    }
    float _166 = _169;
    float _177 = _166 * _166;
    float _181 = 0.087292902171611785888671875;
    _181 = (-0.3018949925899505615234375) + (_181 * _177);
    _181 = 1.0 + (_181 * _177);
    _181 *= _166;
    float _197;
    if (_39 < 1.0)
    {
        _197 = _181;
    }
    else
    {
        _197 = 1.57079637050628662109375 - _181;
    }
    return _197;
}

float _43(float _42)
{
    float _210 = abs(_42);
    float _207 = _40(_210);
    float _214;
    if (_42 < 0.0)
    {
        _214 = -_207;
    }
    else
    {
        _214 = _207;
    }
    return _214;
}

float _48(float _46, float _47)
{
    float _228 = _46 / _47;
    float _224 = _43(_228);
    if (_47 < 0.0)
    {
        _224 += ((_46 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _224;
}

void main()
{
    vec4 _273 = gl_FragCoord;
    float _270 = _62(_273);
    vec2 _276 = gl_FragCoord.xy * _281._m4.zw;
    vec4 _306;
    vec4 _333;
    if (_281._m5.x == 1.0)
    {
        float _302 = _300._m0.x;
        uint _297 = _19(_302);
        uint _312 = _297;
        vec4 _325 = texture(sampler2D(_310[nonuniformEXT(_312)], _318), _321.xy);
        _306 = _34(_325) * (1.0 - _327.z);
        uint _335 = _297;
        vec4 _343 = texture(sampler2D(_310[nonuniformEXT(_335)], _318), _327.xy);
        _333 = _34(_343) * _327.z;
    }
    else
    {
        vec2 _350 = _321.xy;
        _306 = _58(_349, _350) * (1.0 - _327.z);
        vec2 _358 = _327.xy;
        _333 = _58(_349, _358) * _327.z;
    }
    vec4 _365 = _306 + _333;
    float _373 = _365.w - 9.9999999747524270787835121154785e-07;
    _14(_373);
    float _375 = TEXTURE_LOD(_376, vec4(_276, 0.0, 0.0).xy, vec4(_276, 0.0, 0.0).w).x;
    float _390 = 1.0 / (1.0 - _375);
    float _394 = 1.0 / (1.0 - _270);
    float _405 = (_390 - _394) * _321.w;
    float _398 = _10(_405);
    float _417 = mix(_398, _398 * 500.0, _413._m5.x);
    _398 = _10(_417);
    vec3 _425 = _365.xyz * vec3(_419.x);
    _365 = vec4(_425.x, _425.y, _425.z, _365.w);
    _365.w *= _398;
    vec3 _438 = _365.xyz * _433.xyz;
    _365 = vec4(_438.x, _438.y, _438.z, _365.w);
    _365.w = mix(_365.w - (1.0 - pow(_433.w, 0.5)), _365.w * _433.w, _419.w);
    _365.w *= _419.y;
    vec3 _481 = mix(_365.xyz * _300._m1.x, _365.xyz * _281._m6.x, vec3(1.0 - _300._m2.x));
    _365 = vec4(_481.x, _481.y, _481.z, _365.w);
    vec2 _484 = gl_FragCoord.xy * _281._m4.zw;
    float _491 = gl_FragCoord.z;
    vec4 _494 = vec4(0.0);
    float _496 = 1.0;
    float _499 = _281._m7.w;
    uint _497 = _19(_499);
    if ((_497 & 6u) != 0u)
    {
        vec2 _509 = _484 + vec2(0.0);
        vec3 _513 = _281._m8.xyz;
        float _518 = 0.100000001490116119384765625;
        float _520 = _281._m9.y;
        float _524 = _281._m8.z;
        float _527 = 0.0;
        float _531 = _491;
        vec4 _533 = _281._m10;
        float _536 = 1.0;
        bool _537 = false;
        float _528 = _71(_531, _533, _536, _537);
        _527 = pow(max(0.0, (_528 - _518) / (_520 - _518)), 0.5);
        _527 = (_527 * (_524 - 1.0)) / _524;
        vec4 _554 = vec4(_509, _527, 0.0);
        vec3 _580 = textureLod(_563, vec4(_554.xyz, 0.0).xyz, vec4(_554.xyz, 0.0).w).xyz;
        _494 = vec4(_580.x, _580.y, _580.z, _494.w);
        vec2 _583 = textureLod(_584, vec4(_554.xyz, 0.0).xyz, vec4(_554.xyz, 0.0).w).xy;
        _494.w = _583.x;
        _496 = _583.y;
    }
    if ((_497 & 2u) != 0u)
    {
        vec4 _612 = vec4(0.0);
        vec3 _613 = _281._m11.xyz;
        float _619 = _491;
        vec4 _621 = _281._m10;
        float _624 = 1.0;
        bool _625 = false;
        float _618 = _71(_619, _621, _624, _625);
        vec3 _627 = mix(_281._m12.xyz, _281._m13.xyz, vec3(_484.x * _281._m14.z));
        vec3 _644 = mix(_281._m15.xyz, _281._m16.xyz, vec3(_484.x * _281._m14.z));
        vec3 _660 = mix(_644, _627, vec3(1.0 - (_484.y * _281._m14.w)));
        vec4 _671 = vec4(0.0);
        vec3 _672 = normalize(_660);
        float _675 = _672.z;
        _671.x = clamp(_37(_675) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _684 = _672.y;
        float _687 = _672.x;
        _671.y = _48(_684, _687) / 6.283185482025146484375;
        _671.z = sqrt(_618 * _281._m17.w);
        _671.z = clamp(_671.z, 0.015625, 0.984375);
        vec3 _714 = textureLod(_707, _671.xyz, _671.w).xyz;
        _612 = vec4(_714.x, _714.y, _714.z, _612.w);
        vec3 _723 = _365.xyz + (_612.xyz * _496);
        _365 = vec4(_723.x, _723.y, _723.z, _365.w);
    }
    if ((_497 & 4u) != 0u)
    {
        vec3 _739 = (_365.xyz * _494.w) + _494.xyz;
        _365 = vec4(_739.x, _739.y, _739.z, _365.w);
    }
    _743 = _365;
    float _745 = _743.w;
    _743.w = _10(_745);
    float _751 = _743.w;
    _743.w = _10(_751);
    vec3 _760 = _743.xyz * _743.w;
    _743 = vec4(_760.x, _760.y, _760.z, _743.w);
}

