// Decals
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _995
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1273
{
    int _m0;
    int _m1;
};

struct _1276
{
    int _m0;
    int _m1;
};

struct _1387
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2398
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3841
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 1, binding = 0, std140) uniform _1016_1018
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _1018;

layout(set = 0, binding = 0, std140) uniform _1028_1030
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
} _1030;

layout(set = 2, binding = 0, std140) uniform _1110_1112
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _1112;

layout(set = 0, binding = 4, std430) restrict readonly buffer _1278_1280
{
    _1276 _m0[];
} _1280;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1362_1364
{
    uint _m0[];
} _1364;

layout(set = 0, binding = 6, std140) uniform _1392_1394
{
    vec4 _m0[4096];
} _1394;

layout(set = 0, binding = 7, std140) uniform _1412_1414
{
    vec4 _m0[4096];
} _1414;

layout(set = 0, binding = 8, std140) uniform _1464_1466
{
    vec4 _m0[4096];
} _1466;

layout(set = 0, binding = 10, std140) uniform _2402_2404
{
    vec4 _m0[4096];
} _2404;

layout(set = 0, binding = 11, std140) uniform _2441_2443
{
    vec4 _m0[4096];
} _2443;

layout(set = 0, binding = 12, std140) uniform _2509_2511
{
    vec4 _m0[4096];
} _2511;

layout(set = 0, binding = 15, std140) uniform _3845_3847
{
    vec4 _m0[4095];
} _3847;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5013_5015
{
    vec4 _m0[];
} _5015;

layout(push_constant, std430) uniform _5009_5011
{
    int _m0;
    int _m1;
} _5011;

layout(set = 2, binding = 1) uniform SAMPLER_2D _1118;
layout(set = 2, binding = 2) uniform SAMPLER_2D _1126;
layout(set = 2, binding = 3) uniform SAMPLER_2D _1131;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1686;
layout(set = 0, binding = 13) uniform samplerCubeArray _2994;
layout(set = 0, binding = 14) uniform SAMPLER_2D _3402;
layout(set = 0, binding = 16) uniform sampler2DShadow _4169;
layout(set = 0, binding = 17) uniform SAMPLER_2D _4680;
layout(set = 0, binding = 18) uniform SAMPLER_2D _4693;
layout(set = 0, binding = 19) uniform sampler3D _4816;
layout(set = 0, binding = 20) uniform sampler3D _4837;
layout(set = 0, binding = 21) uniform sampler3D _4955;
layout(set = 0, binding = 2) uniform sampler3D _5016;
layout(set = 0, binding = 3) uniform sampler3D _5017;

layout(location = 2) in vec4 _1009;
layout(location = 6) in vec4 _1035;
layout(location = 3) in vec4 _1047;
layout(location = 4) in vec4 _1050;
layout(location = 5) in vec4 _1053;
layout(location = 10) in vec4 _1071;
layout(location = 11) in vec4 _1075;
layout(location = 12) in vec4 _1079;
layout(location = 3) out vec4 _4665;
layout(location = 0) out vec4 _4733;

float _300;
float _357;

float _51(float _50)
{
    if (_50 <= 0.040449999272823333740234375)
    {
        return _50 / 12.9200000762939453125;
    }
    else
    {
        return pow((_50 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _54(vec3 _53)
{
    float _302 = _53.x;
    vec3 _301;
    _301.x = _51(_302);
    float _308 = _53.y;
    _301.y = _51(_308);
    float _314 = _53.z;
    _301.z = _51(_314);
    return _301;
}

vec4 _57(vec4 _56)
{
    vec3 _324 = _56.xyz;
    vec4 _323 = vec4(_54(_324), 1.0);
    float _332 = _56.w;
    _323.w = _51(_332);
    return _323;
}

vec4 _72(vec4 _71)
{
    vec4 _407 = _71;
    return _57(_407);
}

vec4 _135(SAMPLER_2D _133, vec2 _134)
{
    vec4 _624 = SAMPLE_TEXTURE(_133, _134);
    vec4 _628 = _624;
    _624 = _72(_628);
    return _624;
}

float _60(float _59)
{
    if (_59 > 0.003130800090730190277099609375)
    {
        return (pow(_59, 0.4166666567325592041015625) * 1.05499994754791259765625) - 0.054999999701976776123046875;
    }
    else
    {
        return _59 * 12.9200000762939453125;
    }
}

float _173(float _169, vec4 _170, float _171, bool _172)
{
    float _868 = _170.w / (_169 + _170.z);
    return _868 * _171;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _178(vec3 _176, bool _177)
{
    vec3 _881 = (_176 * 2.0) - vec3(1.0);
    float _898 = (1.0 - (_881.x * _881.x)) - (_881.y * _881.y);
    _881.z = sqrt(_10(_898));
    if (_177 == false)
    {
        _881.z = -_881.z;
    }
    return _881;
}

vec3 _185(vec3 _183, mat3 _184)
{
    return normalize(vec3(dot(_183, _184[0]), dot(_183, _184[1]), dot(_183, _184[2])));
}

uint _31(float _30)
{
    return floatBitsToUint(_30);
}

float _42(float _39, float _40, float _41)
{
    return min(_39, min(_40, _41));
}

float _37(float _34, float _35, float _36)
{
    return max(_34, max(_35, _36));
}

vec4 _112(uint _111)
{
    return unpackUnorm4x8(_111).wzyx;
}

vec4 _125(uvec2 _124)
{
    return vec4(float((_124.x >> uint(16)) & 65535u), float(_124.x & 65535u), float((_124.y >> uint(16)) & 65535u), float(_124.y & 65535u)) * 3.0518509447574615478515625e-05;
}

void _26(float _25)
{
    if (_25 < 0.0)
    {
        discard;
    }
}

float _63(float _62)
{
    return _62 * ((_62 * ((_62 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _115(uint _114)
{
    return vec4(float((_114 >> uint(24)) & 255u), float((_114 >> uint(16)) & 255u), float((_114 >> uint(8)) & 255u), float(_114 & 255u));
}

float _94(float _93)
{
    return (step(0.0, _93) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _66(vec3 _65)
{
    float _372 = _65.x;
    vec3 _371;
    _371.x = _63(_372);
    float _377 = _65.y;
    _371.y = _63(_377);
    float _382 = _65.z;
    _371.z = _63(_382);
    return _371;
}

vec4 _69(vec4 _68)
{
    vec3 _391 = _68.xyz;
    vec4 _390 = vec4(_66(_391), 1.0);
    float _399 = _68.w;
    _390.w = _63(_399);
    return _390;
}

float _78(float _77)
{
    return _77 * _77;
}

vec3 _75(vec3 _74)
{
    return _74 * _74;
}

float _83(float _80, float _81, float _82)
{
    float _429 = (_80 - _81) / (_82 - _81);
    return _10(_429);
}

float _86(float _85)
{
    return exp2(_85);
}

vec3 _138(uint _137)
{
    uint _635 = _137;
    vec4 _634 = _112(_635);
    float _646 = (_634.w * 255.0) - 128.0;
    return _634.xyz * _86(_646);
}

vec3 _119(uint _118)
{
    return vec3(float((_118 >> uint(21)) & 2047u), float((_118 >> uint(10)) & 2047u), float(_118 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

vec3 _164(float _161, float _162, vec3 _163)
{
    float _820 = 0.0949999988079071044921875 + (_162 * (0.60000002384185791015625 + (4.190000057220458984375 * _162)));
    float _830 = _161 + 0.02500000037252902984619140625;
    float _834 = (9.5 * _162) * _161;
    float _848 = 1.0 - (14.0 * _161);
    float _840 = (_820 * _830) * _86(_848);
    float _855 = -_834;
    float _851 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _86(_855)));
    return mix(vec3(_840), vec3(_851), _163);
}

uint _48(float _45, float _46, float _47)
{
    bool _241 = abs(_47) >= abs(_45);
    bool _249;
    if (_241)
    {
        _249 = abs(_47) >= abs(_46);
    }
    else
    {
        _249 = _241;
    }
    if (_249)
    {
        return uint((_47 < 0.0) ? 5 : 4);
    }
    if (abs(_46) >= abs(_45))
    {
        return uint((_46 < 0.0) ? 3 : 2);
    }
    return uint(int(_45 < 0.0));
}

float _91(float _89, float _90)
{
    return pow(_89, _90);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _143(vec3 _141, float _142)
{
    float _658 = 50.0 * dot(_141, vec3(0.33329999446868896484375));
    float _651 = _10(_658);
    float _667 = 1.0 - _142;
    float _670 = _10(_667);
    float _671 = 5.0;
    vec3 _675 = _141 + ((vec3(_651) - _141) * _91(_670, _671));
    return _16(_675);
}

vec3 _151(vec3 _146, vec3 _147, vec3 _148, vec3 _149, float _150)
{
    vec3 _679 = normalize(_147 + _148);
    float _684 = 1.0 - (_150 * 0.800000011920928955078125);
    _684 *= _684;
    _684 *= _684;
    float _695 = _684 * _684;
    float _703 = dot(_146, _679);
    float _699 = _10(_703);
    float _705 = ((_699 * _699) * (_695 - 1.0)) + 1.0;
    _705 = _695 / ((_705 * _705) + 9.9999999392252902907785028219223e-09);
    float _724 = dot(_146, _147);
    float _720 = (_10(_724) * (1.0 - _684)) + _684;
    float _735 = dot(_146, _148);
    float _731 = (_10(_735) * (1.0 - _684)) + _684;
    _705 /= (((4.0 * _720) * _731) + 9.9999999392252902907785028219223e-09);
    vec3 _753 = _149;
    float _755 = dot(_148, _679);
    return _143(_753, _755) * _705;
}

vec3 _158(vec3 _154, vec3 _155, vec3 _156, float _157)
{
    float _761 = 1.0 - (_157 * 0.800000011920928955078125);
    _761 *= _761;
    _761 *= _761;
    float _771 = _761 * _761;
    float _779 = dot(_154, _155);
    float _775 = _10(_779);
    float _781 = ((_775 * _775) * (_771 - 1.0)) + 1.0;
    _781 = _771 / ((_781 * _781) + 9.9999999392252902907785028219223e-09);
    float _799 = dot(_154, _155);
    float _795 = (_10(_799) * (1.0 - _761)) + _761;
    _781 /= (((4.0 * _795) * _795) + 9.9999999392252902907785028219223e-09);
    vec3 _813 = _156;
    return _16(_813) * _781;
}

vec2 _189(vec2 _188)
{
    return (vec2(1.0) - abs(_188.yx)) * vec2((_188.x >= 0.0) ? 1.0 : (-1.0), (_188.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _194(inout vec3 _192, bool _193)
{
    _192 /= vec3((abs(_192.x) + abs(_192.y)) + abs(_192.z));
    vec2 _965;
    if (_192.z >= 0.0)
    {
        _965 = _192.xy;
    }
    else
    {
        vec2 _971 = _192.xy;
        _965 = _189(_971);
    }
    _192 = vec3(_965.x, _965.y, _192.z);
    if (_193)
    {
        vec2 _986 = (_192.xy * 0.5) + vec2(0.5);
        _192 = vec3(_986.x, _986.y, _192.z);
    }
    return _192.xy;
}

float _97(float _96)
{
    float _449 = (((-0.15658299624919891357421875) * abs(_96)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_96));
    float _463;
    if (_96 >= 0.0)
    {
        _463 = _449;
    }
    else
    {
        _463 = 3.1415927410125732421875 - _449;
    }
    return _463;
}

float _100(float _99)
{
    float _477;
    if (_99 < 1.0)
    {
        _477 = _99;
    }
    else
    {
        _477 = 1.0 / _99;
    }
    float _474 = _477;
    float _485 = _474 * _474;
    float _489 = 0.087292902171611785888671875;
    _489 = (-0.3018949925899505615234375) + (_489 * _485);
    _489 = 1.0 + (_489 * _485);
    _489 *= _474;
    float _505;
    if (_99 < 1.0)
    {
        _505 = _489;
    }
    else
    {
        _505 = 1.57079637050628662109375 - _489;
    }
    return _505;
}

float _103(float _102)
{
    float _518 = abs(_102);
    float _515 = _100(_518);
    float _522;
    if (_102 < 0.0)
    {
        _522 = -_515;
    }
    else
    {
        _522 = _515;
    }
    return _522;
}

float _107(float _105, float _106)
{
    float _536 = _105 / _106;
    float _532 = _103(_536);
    if (_106 < 0.0)
    {
        _532 += ((_105 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _532;
}

void main()
{
    _995 _997 = _995(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _997._m15 = _1009;
    _997._m16 = gl_FragCoord;
    _997._m40 = (uint(_1018._m6.z) & 3u) << uint(4);
    _997._m14 = _1030._m4.xyz + _1035.xyz;
    _997._m13 = normalize(-_1035.xyz);
    _997._m17 = mat3(vec3(_1047.xyz), vec3(_1050.xyz), vec3(_1053.xyz));
    _997._m34 = _1071;
    _997._m35 = _1075;
    _997._m36 = _1079;
    uint _1082 = 0u;
    vec4 _1083 = vec4(0.0);
    vec4 _1084 = vec4(0.0);
    vec4 _1085 = vec4(0.0);
    vec4 _1086 = vec4(0.0);
    vec4 _1087 = vec4(0.0);
    _997._m0 = _1085.xyz;
    _997._m2 = _1086.xyz;
    _997._m1 = _1084.xyz;
    _997._m9 = _1083.xyz;
    _997._m3 = _1083.w;
    _997._m6 = _1087.wyz;
    vec2 _1107 = _1009.xy * _1112._m4.xy;
    vec2 _1119 = _1107;
    vec4 _1117 = _135(_1118, _1119);
    vec4 _1122 = vec4(0.07999999821186065673828125);
    vec4 _1125 = SAMPLE_TEXTURE(_1126, _1107);
    float _1130 = SAMPLE_TEXTURE(_1131, _1107).x;
    _997._m0 = _1112._m5.xyz * _1117.xyz;
    float _1146 = _1117.w;
    _997._m11 = _1112._m5.w * _60(_1146);
    _997._m2 = _1122.xyz;
    _997._m3 = _1130;
    _997._m6 = _1125.xyz;
    uint _1160 = uint((_1018._m6.x > 0.0) ? 8 : 0);
    float _1166 = 16.0;
    float _1168 = 8.0;
    float _1170 = 24.0;
    vec2 _1179 = _997._m16.xy * _1030._m6.xy;
    vec3 _1172;
    _1172 = vec3(_1179.x, _1179.y, _1172.z);
    _1172.y = 1.0 - _1172.y;
    
    // FIX
    _1172.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1192 = floor(_1172.xy * vec2(_1166, _1168));
    _1172 = vec3(_1192.x, _1192.y, _1172.z);
    float _1197 = _997._m16.z;
    vec4 _1200 = _1030._m7;
    float _1203 = 1.0;
    bool _1204 = false;
    float _1195 = _173(_1197, _1200, _1203, _1204);
    float _1206 = log2(max(1.0, _1195 / _1030._m8.z)) * _1030._m8.w;
    _1172.z = min(_1170 - 1.0, floor(_1206));
    uint _1222 = uint((_1172.x + (_1172.y * _1166)) + ((_1172.z * _1166) * _1168));
    _1222 = min(_1222, uint(((_1166 * _1168) * _1170) - 1.0));
    bool _1247 = true;
    vec3 _1249 = _997._m6;
    bool _1252 = _1247;
    _997._m7 = _178(_1249, _1252);
    vec3 _1256 = _997._m7;
    mat3 _1259 = _997._m17;
    _997._m6 = _185(_1256, _1259);
    uint _1264 = 0u;
    uint _1265 = 0u;
    uint _1266 = 0u;
    uint _1267 = 0u;
    uint _1268 = 0u;
    uint _1269 = 0u;
    int _1271 = 256;
    _1273 _1275;
    _1275._m0 = _1280._m0[_1222]._m0;
    _1275._m1 = _1280._m0[_1222]._m1;
    int _1289 = _1275._m0 & (~(_1275._m0 >> 31));
    int _1298 = _1275._m1 & (~(_1275._m1 >> 31));
    _1264 = uint((_1289 >> 16) * _1271);
    _1265 = _1264 + uint(_1298 & 255);
    _1266 = _1264;
    _1267 = _1266 + uint((_1298 >> 8) & 255);
    _1268 = _1264;
    _1269 = _1268 + uint((_1298 >> 16) & 255);
    vec3 _1331 = dFdx(_997._m14);
    vec3 _1335 = dFdy(_997._m14);
    bool _1340 = _1160 == 0u;
    bool _1346;
    if (_1340)
    {
        _1346 = _1018._m6.y == 0.0;
    }
    else
    {
        _1346 = _1340;
    }
    _1266 = _1346 ? _1267 : _1266;
    uint _1350 = _1266;
    _1387 _1389;
    vec3 _1750;
    float _1854;
    while (_1350 < _1267)
    {
        uint _1360 = _1364._m0[_1350];
        uint _1369 = (_1360 >> uint(12)) & 4095u;
        uint _1375 = _1369;
        if (_1375 >= _1369)
        {
            _1350++;
        }
        int _1384 = 2;
        int _1385 = 2;
        int _1386 = 2;
        _1389._m0 = _1394._m0[(uint(_1384) * _1375) + 0u];
        _1389._m1 = _1394._m0[(uint(_1384) * _1375) + 1u];
        _1389._m2 = _1414._m0[(uint(_1385) * _1375) + 0u];
        float _1428 = _1414._m0[(uint(_1385) * _1375) + 1u].x;
        _1389._m3.x = _31(_1428);
        float _1438 = _1414._m0[(uint(_1385) * _1375) + 1u].y;
        _1389._m3.y = _31(_1438);
        float _1448 = _1414._m0[(uint(_1385) * _1375) + 1u].z;
        _1389._m4.x = _31(_1448);
        float _1458 = _1414._m0[(uint(_1385) * _1375) + 1u].w;
        _1389._m4.y = _31(_1458);
        float _1472 = _1466._m0[(uint(_1386) * _1375) + 0u].x;
        _1389._m5.x = _31(_1472);
        float _1482 = _1466._m0[(uint(_1386) * _1375) + 0u].y;
        _1389._m5.y = _31(_1482);
        float _1492 = _1466._m0[(uint(_1386) * _1375) + 0u].z;
        _1389._m6 = _31(_1492);
        float _1502 = _1466._m0[(uint(_1386) * _1375) + 0u].w;
        _1389._m7 = _31(_1502);
        float _1512 = _1466._m0[(uint(_1386) * _1375) + 1u].x;
        _1389._m8 = _31(_1512);
        float _1522 = _1466._m0[(uint(_1386) * _1375) + 1u].y;
        _1389._m9 = _31(_1522);
        float _1532 = _1466._m0[(uint(_1386) * _1375) + 1u].z;
        _1389._m10 = _31(_1532);
        float _1542 = _1466._m0[(uint(_1386) * _1375) + 1u].w;
        _1389._m11 = _31(_1542);
        vec4 _1547 = vec4(_997._m14, 1.0);
        vec3 _1554 = vec3(dot(_1547, _1389._m0), dot(_1547, _1389._m1), dot(_1547, _1389._m2));
        float _1568 = 0.0039215688593685626983642578125;
        float _1570 = _1554.x;
        float _1573 = _1554.y;
        float _1576 = _1554.z;
        bool _1581 = _42(_1570, _1573, _1576) <= _1568;
        bool _1598;
        if (!_1581)
        {
            float _1585 = _1554.x;
            float _1588 = _1554.y;
            float _1591 = _1554.z;
            _1598 = _37(_1585, _1588, _1591) >= (1.0 - _1568);
        }
        else
        {
            _1598 = _1581;
        }
        if (_1598)
        {
            continue;
        }
        uint _1602 = _1389._m11;
        bool _1606 = _1160 != 0u;
        bool _1613;
        if (_1606)
        {
            _1613 = (_1602 & 1024u) != 0u;
        }
        else
        {
            _1613 = _1606;
        }
        bool _1626;
        if (!_1613)
        {
            bool _1618 = _1160 == 0u;
            bool _1625;
            if (_1618)
            {
                _1625 = (_1602 & 2048u) != 0u;
            }
            else
            {
                _1625 = _1618;
            }
            _1626 = _1625;
        }
        else
        {
            _1626 = _1613;
        }
        if (_1626)
        {
            continue;
        }
        vec3 _1630 = _1389._m0.xyz;
        vec3 _1634 = _1389._m1.xyz;
        vec3 _1638 = _1389._m2.xyz;
        vec2 _1642 = vec2(dot(_1331, _1630), dot(_1331, _1634));
        vec2 _1650 = vec2(dot(_1335, _1630), dot(_1335, _1634));
        float _1658 = 1.0;
        float _1659 = 1.0;
        vec3 _1660 = vec3(0.5, 0.5, 1.0);
        uint _1662 = _1389._m7;
        uint _1666 = _1389._m9;
        vec4 _1665 = _112(_1666);
        uvec2 _1671 = _1389._m5;
        vec4 _1670 = _125(_1671);
        vec2 _1675 = _1642 * _1670.xy;
        vec2 _1680 = _1650 * _1670.xy;
        vec4 _1685 = TEXTURE_GRAD(_1686, (_1554.xy * _1670.xy) + _1670.zw, _1675, _1680);
        _1658 = _1685.z;
        if ((_1662 & 64u) == 0u)
        {
            float _1709 = _1658 - 0.5;
            _26(_1709);
        }
        float _1711 = _1685.w;
        _1659 = _63(_1711);
        bool _1718 = _1659 <= (4.0 * _1568);
        bool _1725;
        if (_1718)
        {
            _1725 = _1665.w <= _1568;
        }
        else
        {
            _1725 = _1718;
        }
        if (_1725)
        {
            continue;
        }
        vec2 _1729 = (_1685.xy * 2.0) - vec2(1.0);
        float _1740 = 1.0 - dot(_1729, _1729);
        _1660 = vec3(_1729, sqrt(_10(_1740)));
        if ((_1602 & 256u) != 0u)
        {
            _1750 = vec3(-_1660.x, -_1660.y, _1660.z);
        }
        else
        {
            _1750 = _1660;
        }
        _1660 = _1750;
        uint _1765 = _1389._m8;
        uint _1769 = _1765;
        float _1768 = 1.0 + (_115(_1769).w * 0.062745101749897003173828125);
        uint _1777 = _1662;
        float _1776 = _112(_1777).z;
        float _1790 = _1768 - (_1768 * abs((_1554.z * 2.0) - 1.0));
        _1659 *= _10(_1790);
        if ((_1662 & 64u) != 0u)
        {
            uint _1800 = _1662;
            float _1799 = _112(_1800).x;
            uint _1805 = _1662;
            float _1804 = _115(_1805).y;
            float _1811 = _1799;
            float _1809 = mix(_1804, 0.0, _10(_1811));
            float _1820 = _1658 - (_1809 / 255.0);
            float _1815 = float(_10(_1820) > 0.0);
            _1659 *= _1815;
        }
        vec3 _1827 = normalize(vec3(_997._m17[0].z, _997._m17[1].z, _997._m17[2].z));
        float _1836 = dot(_1827, normalize(_1638));
        float _1841 = _1836;
        vec2 _1846 = _1660.xy * _94(_1841);
        _1660 = vec3(_1846.x, _1846.y, _1660.z);
        if ((_1602 & 32768u) != 0u)
        {
            float _1859 = abs(_1836);
            _1854 = _10(_1859);
        }
        else
        {
            float _1862 = _1836;
            _1854 = _10(_1862);
        }
        float _1849 = _1854;
        float _1866 = _1659 * _1849;
        uint _1870 = _1389._m6;
        uint _1874 = _1870;
        vec4 _1879 = _112(_1874) * _1866;
        vec4 _1873 = _22(_1879);
        _997._m11 = max(_997._m11, _1873.x);
        _1630 += (_1827 * dot(_1630, _1827));
        _1634 += (_1827 * dot(_1634, _1827));
        _1660 = ((normalize(_1630) * _1660.x) + (normalize(_1634) * _1660.y)) + (_1827 * _1660.z);
        if ((_1602 & 512u) != 0u)
        {
            vec3 _1923 = mix(_1827, _1660, _1873.www);
            float _1929 = dot(_1923, _1827);
            _1660 = (_997._m6 * _1929) + ((_1923 - (_1827 * _1929)) * dot(_997._m6, _1827));
        }
        else
        {
            if ((_1602 & 128u) != 0u)
            {
                _1660 = mix(mix(_997._m6, _1827, vec3(_1866)), _1660, _1873.www);
            }
            else
            {
                _1660 = mix(_997._m6, _1660, _1873.www);
            }
        }
        _997._m6 = normalize(_1660);
        uint _1976 = _1765;
        vec3 _1975 = _112(_1976).xyz;
        float _1980 = _1659;
        if ((_1662 & 1u) != 0u)
        {
            uvec2 _1988 = _1389._m3;
            vec4 _1987 = _125(_1988);
            vec2 _1992 = _1642 * _1987.xy;
            vec2 _1997 = _1650 * _1987.xy;
            vec4 _2002 = TEXTURE_GRAD(_1686, (_1554.xy * _1987.xy) + _1987.zw, _1992, _1997);
            vec4 _2015 = _2002;
            _2002 = _69(_2015);
            float _2025 = (_2002.w - _1568) / (1.0 - _1568);
            _1980 = _10(_2025);
            _1975 *= _2002.xyz;
        }
        _997._m0 = mix(_997._m0, _1975, _1873.xxx);
        float _2038 = ((_1849 * _1980) * _1665.w) * _1776;
        _997._m10 += (_1665.xyz * (_2038 * 64.0));
        uint _2057 = _1389._m10;
        uint _2061 = _2057;
        vec4 _2060 = _112(_2061);
        float _2064 = 0.0;
        if ((_1662 & 10u) != 0u)
        {
            uvec2 _2072 = _1389._m4;
            vec4 _2071 = _125(_2072);
            vec2 _2076 = _1642 * _2071.xy;
            vec2 _2081 = _1650 * _2071.xy;
            vec4 _2086 = TEXTURE_GRAD(_1686, (_1554.xy * _2071.xy) + _2071.zw, _2076, _2081);
            if ((_1662 & 2u) != 0u)
            {
                _2060 = _2086 * _2086;
            }
            else
            {
                _2064 = _2086.w;
            }
        }
        _997._m2 = mix(_997._m2, _2060.xyz, _1873.yyy);
        _997._m3 = mix(_997._m3, _2060.w, _1873.z);
        _997._m37 = max(_997._m37, _2064);
        float _2138 = (_1658 - 0.5) * 2.0;
        _997._m38 = max(_997._m38, _10(_2138));
    }
    float _2143 = _997._m37;
    float _2142 = _78(_2143);
    float _2150 = _2142 - 0.5;
    float _2147 = _10(_2150) * 2.0;
    float _2161 = _2142 * 2.0;
    float _2153 = (_997._m38 * _997._m38) * _10(_2161);
    float _2168 = _2153 + _2147;
    float _2164 = _10(_2168);
    if (_2164 > 0.0039215688593685626983642578125)
    {
        vec3 _2176 = _997._m0;
        float _2183 = _2164 * 1.0;
        float _2184 = 0.0;
        float _2185 = 0.3499999940395355224609375;
        _997._m0 = mix(_997._m0, _75(_2176), vec3(_83(_2183, _2184, _2185) * (1.0 - _997._m3)));
        float _2201 = _2164 * 1.0;
        float _2202 = 0.25;
        float _2203 = 0.5;
        _997._m2 = mix(_997._m2, vec3(0.039999999105930328369140625), vec3(_83(_2201, _2202, _2203)));
        vec3 _2208 = vec3(_997._m17[0].z, _997._m17[1].z, _997._m17[2].z);
        float _2222 = _2208.z + 0.0625;
        float _2216 = _2164 * _10(_2222);
        float _2231 = _2216 * 1.0;
        float _2232 = 0.20000000298023223876953125;
        float _2233 = 1.0;
        _997._m3 = mix(_997._m3, 0.89999997615814208984375, _83(_2231, _2232, _2233));
        float _2242 = _2216 * 1.0;
        float _2243 = 0.449999988079071044921875;
        float _2244 = 0.980000019073486328125;
        float _2237 = _83(_2242, _2243, _2244);
        _997._m6 = normalize(mix(_997._m6, vec3(0.0, 0.0, 1.0), vec3(_2237)));
        _997._m7 = mix(_997._m6, vec3(0.5, 0.5, 1.0), vec3(_2237));
        if (_2216 > 0.980000019073486328125)
        {
            float _2267 = _2216 * _2237;
            float _2268 = 0.980000019073486328125;
            float _2269 = 1.0;
            _2208 = normalize(mix(_2208, vec3(0.0, 0.0, 1.0), vec3(_83(_2267, _2268, _2269))));
            _997._m17[0].z = _2208.x;
            _997._m17[1].z = _2208.y;
            _997._m17[2].z = _2208.z;
        }
    }
    vec3 _2283 = vec3(0.0);
    vec3 _2284 = vec3(_997._m34.x, _997._m34.y, _997._m34.z);
    vec3 _2292 = vec3(_997._m34.w, _997._m35.x, _997._m35.y);
    vec3 _2300 = vec3(_997._m35.z, _997._m35.w, _997._m36.x);
    vec3 _2308 = vec3(_997._m36.y, _997._m36.z, _997._m36.w);
    vec3 _2316 = ((_2284 - (_2292 * _997._m6.y)) + (_2300 * _997._m6.z)) - (_2308 * _997._m6.x);
    float _2339 = _1018._m7.x * _1030._m9.x;
    _2283 += max(_2316 * _10(_2339), vec3(0.0));
    float _2350;
    if (dot(_997._m10, vec3(1.0)) > 0.0)
    {
        _2350 = -_997._m3;
    }
    else
    {
        _2350 = _997._m3;
    }
    _997._m3 = _2350;
    _997._m18 = _2283;
    _997._m19 = _2283;
    float _2367 = 1.0;
    uint _2368 = _1268;
    _2398 _2400;
    while (_2368 < _1269)
    {
        uint _2378 = _1364._m0[_2368];
        uint _2382 = (_2378 >> uint(24)) & 4095u;
        uint _2386 = _2382;
        if (_2386 >= _2382)
        {
            _2368++;
        }
        int _2395 = 4;
        int _2396 = 4;
        int _2397 = 4;
        _2400._m0 = _2404._m0[(uint(_2395) * _2386) + 0u].xyz;
        float _2419 = _2404._m0[(uint(_2395) * _2386) + 0u].w;
        _2400._m1 = _31(_2419);
        _2400._m2 = _2404._m0[(uint(_2395) * _2386) + 1u];
        _2400._m3 = _2404._m0[(uint(_2395) * _2386) + 2u];
        _2400._m4 = _2443._m0[(uint(_2396) * _2386) + 0u];
        _2400._m5 = _2443._m0[(uint(_2396) * _2386) + 1u];
        _2400._m6 = _2443._m0[(uint(_2396) * _2386) + 2u];
        float _2473 = _2404._m0[(uint(_2395) * _2386) + 3u].x;
        _2400._m7.x = _31(_2473);
        float _2483 = _2404._m0[(uint(_2395) * _2386) + 3u].y;
        _2400._m7.y = _31(_2483);
        float _2493 = _2404._m0[(uint(_2395) * _2386) + 3u].z;
        _2400._m7.z = _31(_2493);
        float _2503 = _2404._m0[(uint(_2395) * _2386) + 3u].w;
        _2400._m7.w = _31(_2503);
        _2400._m8 = _2511._m0[(uint(_2397) * _2386) + 0u];
        _2400._m9 = _2511._m0[(uint(_2397) * _2386) + 1u];
        _2400._m10 = _2511._m0[(uint(_2397) * _2386) + 2u];
        _2400._m11 = _2511._m0[(uint(_2397) * _2386) + 3u];
        float _2549 = _2443._m0[(uint(_2396) * _2386) + 3u].x;
        _2400._m12 = _31(_2549);
        float _2559 = _2443._m0[(uint(_2396) * _2386) + 3u].y;
        _2400._m13 = _31(_2559);
        _2400._m14 = _2443._m0[(uint(_2396) * _2386) + 3u].z;
        float _2577 = _2443._m0[(uint(_2396) * _2386) + 3u].w;
        _2400._m15 = _31(_2577);
        uint _2582 = (_2400._m12 >> uint(16)) & 3u;
        if (((_997._m40 >> uint(4)) & 3u) != _2582)
        {
            continue;
        }
        vec3 _2596 = vec3((_997._m14.x * _2400._m4.x) + ((_997._m14.y * _2400._m4.y) + ((_997._m14.z * _2400._m4.z) + _2400._m4.w)), (_997._m14.x * _2400._m5.x) + ((_997._m14.y * _2400._m5.y) + ((_997._m14.z * _2400._m5.z) + _2400._m5.w)), (_997._m14.x * _2400._m6.x) + ((_997._m14.y * _2400._m6.y) + ((_997._m14.z * _2400._m6.z) + _2400._m6.w)));
        vec2 _2663 = _2596.xy / vec2(_2596.z);
        _2596 = vec3(_2663.x, _2663.y, _2596.z);
        _2596.z = (_997._m14.x * _2400._m3.x) + ((_997._m14.y * _2400._m3.y) + ((_997._m14.z * _2400._m3.z) + _2400._m3.w));
        float _2687 = 0.0039215688593685626983642578125;
        float _2688 = _2596.x;
        float _2691 = _2596.y;
        float _2694 = _2596.z;
        bool _2699 = _42(_2688, _2691, _2694) < _2687;
        bool _2716;
        if (!_2699)
        {
            float _2703 = _2596.x;
            float _2706 = _2596.y;
            float _2709 = _2596.z;
            _2716 = _37(_2703, _2706, _2709) >= (1.0 - _2687);
        }
        else
        {
            _2716 = _2699;
        }
        if (_2716)
        {
            continue;
        }
        uint _2720 = _2400._m1;
        uint _2724 = _2400._m13;
        vec3 _2723 = _138(_2724);
        float _2728 = _2400._m14;
        vec3 _2731 = _2400._m0;
        if (_2400._m9.w == 0.0)
        {
            if (dot(_2400._m11.xyz, _997._m14) < (_2400._m11.w - _2687))
            {
                continue;
            }
        }
        else
        {
            if (_2400._m9.w == 1.0)
            {
                float _2760 = _2400._m11.w;
                uint _2764 = _31(_2760);
                vec3 _2759 = (((_119(_2764) * 2.0) - vec3(1.0)) * _2400._m11.xyz) + _2731;
                vec3 _2775 = abs(_997._m14 - _2759) / _2400._m11.xyz;
                float _2785 = _2775.x;
                float _2788 = _2775.y;
                float _2791 = _2775.z;
                if (_37(_2785, _2788, _2791) > 1.0)
                {
                    continue;
                }
            }
        }
        uint _2800 = _2720;
        float _2799 = _112(_2800).y;
        vec3 _2804 = (_2596 * 2.0) - vec3(1.0);
        vec3 _2808 = _2804 * sqrt(((vec3(1.0) - ((_2804.yzx * _2804.yzx) * 0.5)) - ((_2804.zxy * _2804.zxy) * 0.5)) + ((((_2804.yzx * _2804.yzx) * _2804.zxy) * _2804.zxy) / vec3(3.0)));
        float _2852 = 1.0 - ((length(_2808) - _2799) / ((1.0 - _2799) + 9.9999999747524270787835121154785e-07));
        float _2841 = _10(_2852);
        _2841 *= _2841;
        _2841 *= (_2400._m8.w * _2367);
        _2367 *= (1.0 - _2841);
        if (_2841 <= (_2687 * 4.0))
        {
            continue;
        }
        vec3 _2874 = _2723;
        uint _2877 = _2720;
        float _2876 = _115(_2877).z;
        vec3 _2881 = vec3(0.0);
        vec3 _2882 = vec3(0.0);
        vec3 _2883 = _997._m6;
        _2883.x = dot(_2400._m2.xy, _997._m6.xy);
        _2883.y = dot(_2400._m2.zw, _997._m6.xy);
        vec3 _2902 = reflect(-_997._m13, _997._m6);
        vec3 _2909 = (_2400._m9.xyz - _997._m14) / _2902;
        vec3 _2918 = (_2400._m8.xyz - _997._m14) / _2902;
        vec3 _2927 = max(_2909, _2918);
        float _2932 = _2927.x;
        float _2935 = _2927.y;
        float _2938 = _2927.z;
        float _2931 = _42(_2932, _2935, _2938);
        vec3 _2942 = _997._m14 + (_2902 * _2931);
        vec3 _2949 = normalize(_2942 - _2731);
        vec3 _2954 = _2949;
        _2954.x = dot(_2400._m2.xy, _2949.xy);
        _2954.y = dot(_2400._m2.zw, _2949.xy);
        float _2976 = dot(_997._m13, _997._m6);
        float _2970 = _10(_2976);
        float _2978 = 0.0;
        float _2979 = 6.0;
        float _2981 = max(_2978, _2979 - (_2979 * abs(_997._m3)));
        _2882 = textureLod(_2994, vec4(_2954, _2876), _2981).xyz * _2728;
        float _3011 = _2970;
        float _3013 = abs(_997._m3);
        vec3 _3014 = _997._m2;
        vec3 _3007 = _164(_3011, _3013, _3014);
        _2882 *= _3007;
        float _3025 = _2841;
        _997._m27 += ((_2882 * _2874) * _10(_3025));
        if (_2367 <= (_2687 * 4.0))
        {
            break;
        }
    }
    uint _3040 = _1264;
    _2398 _3069;
    vec3 _3375;
    float _3452;
    float _3470;
    uint _3815;
    _3841 _3843;
    uint _3965;
    _3841 _3989;
    vec3 _4463;
    vec3 _4476;
    while (_3040 < _1265)
    {
        uint _3050 = _1364._m0[_3040];
        uint _3054 = _3050 & 4095u;
        uint _3057 = _3054;
        if (_3057 >= _3054)
        {
            _3040++;
        }
        int _3066 = 4;
        int _3067 = 4;
        int _3068 = 4;
        _3069._m0 = _2404._m0[(uint(_3066) * _3057) + 0u].xyz;
        float _3084 = _2404._m0[(uint(_3066) * _3057) + 0u].w;
        _3069._m1 = _31(_3084);
        _3069._m2 = _2404._m0[(uint(_3066) * _3057) + 1u];
        _3069._m3 = _2404._m0[(uint(_3066) * _3057) + 2u];
        _3069._m4 = _2443._m0[(uint(_3067) * _3057) + 0u];
        _3069._m5 = _2443._m0[(uint(_3067) * _3057) + 1u];
        _3069._m6 = _2443._m0[(uint(_3067) * _3057) + 2u];
        float _3134 = _2404._m0[(uint(_3066) * _3057) + 3u].x;
        _3069._m7.x = _31(_3134);
        float _3144 = _2404._m0[(uint(_3066) * _3057) + 3u].y;
        _3069._m7.y = _31(_3144);
        float _3154 = _2404._m0[(uint(_3066) * _3057) + 3u].z;
        _3069._m7.z = _31(_3154);
        float _3164 = _2404._m0[(uint(_3066) * _3057) + 3u].w;
        _3069._m7.w = _31(_3164);
        _3069._m8 = _2511._m0[(uint(_3068) * _3057) + 0u];
        _3069._m9 = _2511._m0[(uint(_3068) * _3057) + 1u];
        _3069._m10 = _2511._m0[(uint(_3068) * _3057) + 2u];
        _3069._m11 = _2511._m0[(uint(_3068) * _3057) + 3u];
        float _3206 = _2443._m0[(uint(_3067) * _3057) + 3u].x;
        _3069._m12 = _31(_3206);
        float _3216 = _2443._m0[(uint(_3067) * _3057) + 3u].y;
        _3069._m13 = _31(_3216);
        _3069._m14 = _2443._m0[(uint(_3067) * _3057) + 3u].z;
        float _3234 = _2443._m0[(uint(_3067) * _3057) + 3u].w;
        _3069._m15 = _31(_3234);
        uint _3239 = (_3069._m12 >> uint(16)) & 3u;
        if (((_997._m40 >> uint(4)) & 3u) != _3239)
        {
            continue;
        }
        float _3253 = 0.0039215688593685626983642578125;
        vec4 _3254 = vec4(_997._m14, 1.0);
        float _3261 = 1.0 / dot(_3254, _3069._m6);
        vec3 _3267 = vec3(dot(_3254, _3069._m4) * _3261, dot(_3254, _3069._m5) * _3261, dot(_3254, _3069._m3));
        uint _3285 = _3069._m1;
        uint _3288 = _1160;
        _3288 |= 64u;
        float _3292 = _3267.x;
        float _3295 = _3267.y;
        float _3298 = _3267.z;
        bool _3303 = _42(_3292, _3295, _3298) <= _3253;
        bool _3320;
        if (!_3303)
        {
            float _3307 = _3267.x;
            float _3310 = _3267.y;
            float _3313 = _3267.z;
            _3320 = _37(_3307, _3310, _3313) >= (1.0 - _3253);
        }
        else
        {
            _3320 = _3303;
        }
        bool _3328;
        if (!_3320)
        {
            _3328 = (_3285 & _3288) != 0u;
        }
        else
        {
            _3328 = _3320;
        }
        if (_3328)
        {
            continue;
        }
        if ((_3285 & 3u) == 2u)
        {
            vec2 _3347 = fract((_3267.xy * _1030._m10.xy) + _1030._m10.zw);
            _3267 = vec3(_3347.x, _3347.y, _3267.z);
        }
        vec3 _3350 = _3069._m0;
        float _3353 = 1.0;
        float _3354 = 1.0;
        vec3 _3355 = vec3(0.0, 0.0, 1.0);
        vec3 _3356 = vec3(0.0, 0.0, 1.0);
        uint _3357 = _3069._m1;
        vec3 _3360 = (_3267 * 2.0) - vec3(1.0);
        vec2 _3365 = _3267.xy;
        vec3 _3368 = _3069._m10.xyz;
        if ((_3357 & 3u) == 2u)
        {
            _3375 = _3368;
        }
        else
        {
            _3375 = normalize(_3350 - _997._m14);
        }
        _3355 = _3375;
        _3355 = _3355;
        float _3392 = dot(_997._m6, _3355);
        float _3387 = _10(_3392);
        uvec2 _3395 = _3069._m7.zw;
        vec4 _3394 = _125(_3395);
        float _3401 = TEXTURE_LOD(_3402, vec4((_3365 * _3394.xy) + _3394.zw, 0.0, 0.0).xy, vec4((_3365 * _3394.xy) + _3394.zw, 0.0, 0.0).w).x;
        float _3428 = _3401 * _3401;
        uint _3432 = _3357 & 3u;
        bool _3437 = _3432 == 1u;
        bool _3449;
        if (!_3437)
        {
            bool _3442 = _3432 == 0u;
            bool _3448;
            if (_3442)
            {
                _3448 = _3069._m8.z != 0.0;
            }
            else
            {
                _3448 = _3442;
            }
            _3449 = _3448;
        }
        else
        {
            _3449 = _3437;
        }
        bool _3435 = _3449;
        if (_3435)
        {
            float _3455 = _3069._m8.w;
            _3452 = _10(_3455);
        }
        else
        {
            _3452 = 0.5;
        }
        float _3450 = _3452;
        bool _3463 = _3432 == 0u;
        bool _3469;
        if (_3463)
        {
            _3469 = _3069._m8.z != 0.0;
        }
        else
        {
            _3469 = _3463;
        }
        if (_3469)
        {
            float _3478 = sqrt(dot(_3360, _3360));
            _3470 = min(0.9921875, _10(_3478));
        }
        else
        {
            _3470 = _3267.z;
        }
        float _3461 = _3470;
        uvec2 _3486 = _3069._m7.xy;
        vec4 _3485 = _125(_3486);
        vec2 _3491 = vec2(_3461, _3450);
        float _3495 = TEXTURE_LOD(_3402, vec4((_3491 * _3485.xy) + _3485.zw, 0.0, 0.0).xy, vec4((_3491 * _3485.xy) + _3485.zw, 0.0, 0.0).w).x;
        _3495 *= _3495;
        _3353 = _3495 * _3428;
        if ((_3357 & 48u) != 0u)
        {
            vec4 _3533 = _3069._m10;
            vec4 _3536 = _3069._m8;
            vec4 _3539 = _3069._m9;
            float _3542 = dot(_997._m14, _3533.xyz) + _3533.w;
            if (_3542 < 0.0)
            {
                continue;
            }
            float _3556 = length(_3533.xyz);
            float _3563 = _3542 * 50.0;
            float _3560 = _10(_3563);
            _3353 *= (_3560 * _3560);
            _3542 /= _3556;
            _3533 /= vec4(_3556);
            vec3 _3577 = reflect(-_997._m13, _997._m6);
            if (dot(_3577, _3533.xyz) > 0.0)
            {
                _3577 = reflect(_3577, _3533.xyz);
            }
            float _3595 = dot(_3577, _3533.xyz);
            float _3600 = _3542 / _3595;
            vec3 _3604 = _997._m14 - (_3577 * _3600);
            vec3 _3611 = _3604 - _3350;
            float _3615 = dot(_3611, _3536.xyz) / _3536.w;
            float _3623 = dot(_3611, _3539.xyz) / _3539.w;
            if ((_3357 & 48u) == 32u)
            {
                vec2 _3637 = vec2(_3615, _3623);
                float _3641 = 1.0 / max(1.0, length(vec2(_3615, _3623)));
                _3615 *= (_3641 * _3536.w);
                _3623 *= (_3641 * _3539.w);
            }
            else
            {
                float _3663 = abs(_3615);
                float _3665 = _3615;
                _3615 = (_10(_3663) * _94(_3665)) * _3536.w;
                float _3674 = abs(_3623);
                float _3676 = _3623;
                _3623 = (_10(_3674) * _94(_3676)) * _3539.w;
            }
            vec3 _3683 = (_3536.xyz * _3615) + (_3539.xyz * _3623);
            _3350 += _3683;
            _3355 = normalize(_3350 - _997._m14);
            _3355 = _3355;
        }
        else
        {
            uint _3703 = (_3069._m15 >> uint(16)) & 255u;
            if (_3703 == 0u)
            {
                vec4 _3712 = _3069._m9;
                if (dot(_3712.xyz, _997._m14) < (_3712.w - _3253))
                {
                    continue;
                }
            }
            else
            {
                if (_3703 == 1u)
                {
                    vec3 _3733 = _3069._m9.xyz;
                    float _3738 = _3069._m9.w;
                    uint _3742 = _31(_3738);
                    vec3 _3737 = (((_119(_3742) * 2.0) - vec3(1.0)) * _3733) + _3350;
                    vec3 _3751 = abs((_997._m14 - _3737) / _3733);
                    float _3759 = _3751.x;
                    float _3762 = _3751.y;
                    float _3765 = _3751.z;
                    if (_37(_3759, _3762, _3765) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3353 <= (_3253 / 256.0))
        {
            continue;
        }
        float _3781 = 1.0;
        if ((_3285 & 4u) != 0u)
        {
            float _3788 = float(_3069._m15 & 255u) / 255.0;
            float _3794 = 0.00999999977648258209228515625;
            vec3 _3796 = _997._m14 + (_997._m6 * _3794);
            if ((_3285 & 3u) == 0u)
            {
                vec3 _3809 = _3796 - _3069._m2.xyz;
                float _3816 = _3809.x;
                float _3819 = _3809.y;
                float _3822 = _3809.z;
                _3815 = _48(_3816, _3819, _3822);
            }
            else
            {
                if ((_3285 & 3u) == 2u)
                {
                    float _3832 = 0.0;
                    _3815 = 0u;
                    for (; _3815 < 3u; _3815++)
                    {
                        int _3840 = 5;
                        _3843._m0 = _3847._m0[(uint(_3840) * ((_3285 >> uint(22)) + _3815)) + 0u];
                        _3843._m1 = _3847._m0[(uint(_3840) * ((_3285 >> uint(22)) + _3815)) + 1u];
                        _3843._m2 = _3847._m0[(uint(_3840) * ((_3285 >> uint(22)) + _3815)) + 2u];
                        _3843._m3 = _3847._m0[(uint(_3840) * ((_3285 >> uint(22)) + _3815)) + 3u];
                        _3843._m4 = _3847._m0[(uint(_3840) * ((_3285 >> uint(22)) + _3815)) + 4u];
                        vec2 _3904 = vec2(dot(_3796, _3843._m0.xyz) + _3843._m0.w, dot(_3796, _3843._m1.xyz) + _3843._m1.w);
                        _3904 = abs((_3904 * 2.0) - vec2(1.0));
                        bool _3930 = _3904.x < 0.99500000476837158203125;
                        bool _3936;
                        if (_3930)
                        {
                            _3936 = _3904.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3936 = _3930;
                        }
                        if (_3936)
                        {
                            _3832 = (1.0 - max(_3904.x, _3904.y)) * _1030._m11.w;
                            break;
                        }
                    }
                    _3815 = min(2u, _3815);
                    uint _3953 = uint(_997._m16.x) ^ (uint(_997._m16.y) << uint(1));
                    if (_1030._m12.w > 0.0)
                    {
                        _3965 = uint(_1030._m13.x);
                    }
                    else
                    {
                        _3965 = 0u;
                    }
                    _3953 ^= _3965;
                    _3815 += uint(int(((float(_3953 & 3u) * 0.25) + 0.125) > _3832));
                }
                else
                {
                    _3815 = 0u;
                }
            }
            int _3988 = 5;
            _3989._m0 = _3847._m0[(uint(_3988) * ((_3285 >> uint(22)) + _3815)) + 0u];
            _3989._m1 = _3847._m0[(uint(_3988) * ((_3285 >> uint(22)) + _3815)) + 1u];
            _3989._m2 = _3847._m0[(uint(_3988) * ((_3285 >> uint(22)) + _3815)) + 2u];
            _3989._m3 = _3847._m0[(uint(_3988) * ((_3285 >> uint(22)) + _3815)) + 3u];
            _3989._m4 = _3847._m0[(uint(_3988) * ((_3285 >> uint(22)) + _3815)) + 4u];
            vec4 _4045 = vec4((_3796.x * _3989._m0.x) + ((_3796.y * _3989._m0.y) + ((_3796.z * _3989._m0.z) + _3989._m0.w)), (_3796.x * _3989._m1.x) + ((_3796.y * _3989._m1.y) + ((_3796.z * _3989._m1.z) + _3989._m1.w)), (_3796.x * _3989._m2.x) + ((_3796.y * _3989._m2.y) + ((_3796.z * _3989._m2.z) + _3989._m2.w)), (_3796.x * _3989._m3.x) + ((_3796.y * _3989._m3.y) + ((_3796.z * _3989._m3.z) + _3989._m3.w)));
            vec3 _4132 = _4045.xyz / vec3(_4045.w);
            _4045 = vec4(_4132.x, _4132.y, _4132.z, _4045.w);
            bool _4140 = min(_4045.x, _4045.y) > 0.0;
            bool _4149;
            if (_4140)
            {
                _4149 = max(_4045.x, _4045.y) < 1.0;
            }
            else
            {
                _4149 = _4140;
            }
            if (_4149)
            {
                vec2 _4161 = (_4045.xy * _3989._m4.xy) + _3989._m4.zw;
                _4045 = vec4(_4161.x, _4161.y, _4045.z, _4045.w);
                if (false)
                {
                    _3781 = textureLod(_4169, vec3(_4045.xyz.xy, _4045.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4176 = (_4045.xy * _1030._m14.xy) + vec2(0.5);
                    vec2 _4185 = floor(_4176);
                    vec2 _4188 = _4176 - _4185;
                    _4185 -= vec2(0.5);
                    vec2 _4195 = vec2(4.0) - (_4188 * 3.0);
                    vec2 _4200 = vec2(7.0);
                    vec2 _4203 = vec2(1.0) + (_4188 * 3.0);
                    vec2 _4208 = (_4185 + (((vec2(3.0) - (_4188 * 2.0)) / _4195) - vec2(2.0))) * _1030._m14.zw;
                    vec2 _4223 = (_4185 + ((vec2(3.0) + _4188) / _4200)) * _1030._m14.zw;
                    vec2 _4235 = (_4185 + ((_4188 / _4203) + vec2(2.0))) * _1030._m14.zw;
                    vec3 _4259 = vec3(_4208.x, _4208.y, _4045.z);
                    _3781 = (_4195.x * _4195.y) * textureLod(_4169, vec3(_4259.xy, _4259.z), 0.0);
                    vec3 _4275 = vec3(_4223.x, _4208.y, _4045.z);
                    _3781 += ((_4200.x * _4195.y) * textureLod(_4169, vec3(_4275.xy, _4275.z), 0.0));
                    vec3 _4293 = vec3(_4235.x, _4208.y, _4045.z);
                    _3781 += ((_4203.x * _4195.y) * textureLod(_4169, vec3(_4293.xy, _4293.z), 0.0));
                    vec3 _4311 = vec3(_4208.x, _4223.y, _4045.z);
                    _3781 += ((_4195.x * _4200.y) * textureLod(_4169, vec3(_4311.xy, _4311.z), 0.0));
                    vec3 _4329 = vec3(_4223.x, _4223.y, _4045.z);
                    _3781 += ((_4200.x * _4200.y) * textureLod(_4169, vec3(_4329.xy, _4329.z), 0.0));
                    vec3 _4347 = vec3(_4235.x, _4223.y, _4045.z);
                    _3781 += ((_4203.x * _4200.y) * textureLod(_4169, vec3(_4347.xy, _4347.z), 0.0));
                    vec3 _4365 = vec3(_4208.x, _4235.y, _4045.z);
                    _3781 += ((_4195.x * _4203.y) * textureLod(_4169, vec3(_4365.xy, _4365.z), 0.0));
                    vec3 _4383 = vec3(_4223.x, _4235.y, _4045.z);
                    _3781 += ((_4200.x * _4203.y) * textureLod(_4169, vec3(_4383.xy, _4383.z), 0.0));
                    vec3 _4401 = vec3(_4235.x, _4235.y, _4045.z);
                    _3781 += ((_4203.x * _4203.y) * textureLod(_4169, vec3(_4401.xy, _4401.z), 0.0));
                    _3781 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3781 = float((_3285 & 3u) == 2u);
            }
            float _4415 = float((_3285 >> uint(16)) & 63u) / 63.0;
            float _4429 = ((_3781 * _4415) + 1.0) - _4415;
            _3781 = _10(_4429);
        }
        uint _4432 = _3069._m13;
        vec3 _4431 = (_138(_4432) * _3781) * _3353;
        _3354 *= _3069._m14;
        vec3 _4444 = _4431;
        vec3 _4446 = normalize(_3350 - _997._m14);
        float _4452 = dot(_997._m6, _4446);
        float _4458 = _4452;
        float _4457 = _94(_4458);
        if (_4457 >= 0.0)
        {
            _4463 = _4446;
        }
        else
        {
            _4463 = reflect(_4446, _997._m6);
        }
        _4446 = _4463;
        if (_4457 >= 0.0)
        {
            _4476 = vec3(1.0);
        }
        else
        {
            _4476 = _997._m0;
        }
        vec3 _4473 = _4476;
        float _4487 = dot(_997._m6, _4446);
        float _4489 = _4452;
        _4452 = mix(_10(_4487), _10(_4489), _997._m11);
        _997._m19 += (_4444 * _4452);
        vec3 _4503 = _997._m6;
        vec3 _4506 = _997._m13;
        vec3 _4509 = _4446;
        vec3 _4511 = _997._m2;
        float _4514 = _997._m3;
        vec3 _4502 = _151(_4503, _4506, _4509, _4511, _4514);
        vec3 _4518 = ((((_4444 * _4452) * _4502) * _3354) * _4473) + _997._m20;
        vec3 _4532 = vec3(40.0);
        _997._m20 = min(_4518, _4532);
    }
    float _4539 = _1030._m15.x;
    if (_4539 > 0.00999999977648258209228515625)
    {
        float _4546 = float(int(_1030._m13.x) & 1023) / 1023.0;
        _4539 = max(0.0, _4539 + (((_4546 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4562 = _997._m13;
        float _4570 = dot(_997._m6, _4562);
        float _4565 = _10(_4570);
        float _4572 = _4565 * _4539;
        vec3 _4580 = _997._m6;
        vec3 _4583 = _997._m13;
        vec3 _4586 = _997._m2;
        float _4589 = abs(_997._m3);
        vec3 _4576 = _158(_4580, _4583, _4586, _4589) * _4539;
        _997._m19 += vec3(_4572);
        _997._m20 += vec3(_4576);
    }
    _997._m19 = _997._m19;
    _997._m20 += _997._m10;
    _997._m19 *= _997._m0;
    _997._m21 = _997._m19 + _997._m20;
    if (_1030._m16.x > 0.0)
    {
        bool _4634 = gl_FrontFacing;
        vec3 _4640;
        if (_4634)
        {
            _4640 = _997._m6;
        }
        else
        {
            _4640 = -_997._m6;
        }
        vec3 _4649 = _4640;
        bool _4651 = false;
        vec2 _4652 = _194(_4649, _4651);
        vec2 _4638 = _4652;
        float _4654 = gl_FragCoord.z;
        vec4 _4658 = _1030._m7;
        float _4661 = 1.0;
        bool _4662 = false;
        float _4653 = _173(_4654, _4658, _4661, _4662);
        _4665 = vec4(_4638, _4653 * 0.00999999977648258209228515625, 1.0);
        vec2 _4672 = gl_FragCoord.xy * _1030._m6.zw;
        vec4 _4679 = TEXTURE_LOD(_4680, vec4(_4672, 0.0, 0.0).xy, vec4(_4672, 0.0, 0.0).w) + TEXTURE_LOD(_4693, vec4(_4672, 0.0, 0.0).xy, vec4(_4672, 0.0, 0.0).w);
        vec3 _4715 = mix(_997._m27, _4679.xyz, vec3(min(_4679.w, 1.0)));
        _4679 = vec4(_4715.x, _4715.y, _4715.z, _4679.w);
        _997._m20 += _4679.xyz;
    }
    _997._m21 = (_997._m19 * _997._m11) + _997._m20;
    _4733 = vec4(_997._m21, _997._m11);
    vec2 _4742 = _997._m16.xy * _1030._m6.zw;
    float _4750 = _997._m16.z;
    vec4 _4753 = vec4(0.0);
    float _4754 = 1.0;
    float _4756 = _1030._m17.w;
    uint _4755 = _31(_4756);
    if ((_4755 & 6u) != 0u)
    {
        vec2 _4766 = _4742 + vec2(0.0);
        vec3 _4770 = _1030._m18.xyz;
        float _4774 = 0.100000001490116119384765625;
        float _4776 = _1030._m19.y;
        float _4779 = _1030._m18.z;
        float _4782 = 0.0;
        float _4784 = _4750;
        vec4 _4786 = _1030._m7;
        float _4789 = 1.0;
        bool _4790 = false;
        float _4783 = _173(_4784, _4786, _4789, _4790);
        _4782 = pow(max(0.0, (_4783 - _4774) / (_4776 - _4774)), 0.5);
        _4782 = (_4782 * (_4779 - 1.0)) / _4779;
        vec4 _4807 = vec4(_4766, _4782, 0.0);
        vec3 _4833 = textureLod(_4816, vec4(_4807.xyz, 0.0).xyz, vec4(_4807.xyz, 0.0).w).xyz;
        _4753 = vec4(_4833.x, _4833.y, _4833.z, _4753.w);
        vec2 _4836 = textureLod(_4837, vec4(_4807.xyz, 0.0).xyz, vec4(_4807.xyz, 0.0).w).xy;
        _4753.w = _4836.x;
        _4754 = _4836.y;
    }
    if ((_4755 & 2u) != 0u)
    {
        vec4 _4865 = vec4(0.0);
        vec3 _4866 = _1030._m4.xyz;
        float _4871 = _4750;
        vec4 _4873 = _1030._m7;
        float _4876 = 1.0;
        bool _4877 = false;
        float _4870 = _173(_4871, _4873, _4876, _4877);
        vec3 _4879 = mix(_1030._m20.xyz, _1030._m21.xyz, vec3(_4742.x * _1030._m22.z));
        vec3 _4893 = mix(_1030._m23.xyz, _1030._m24.xyz, vec3(_4742.x * _1030._m22.z));
        vec3 _4908 = mix(_4893, _4879, vec3(1.0 - (_4742.y * _1030._m22.w)));
        vec4 _4919 = vec4(0.0);
        vec3 _4920 = normalize(_4908);
        float _4923 = _4920.z;
        _4919.x = clamp(_97(_4923) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _4932 = _4920.y;
        float _4935 = _4920.x;
        _4919.y = _107(_4932, _4935) / 6.283185482025146484375;
        _4919.z = sqrt(_4870 * _1030._m25.w);
        _4919.z = clamp(_4919.z, 0.015625, 0.984375);
        vec3 _4962 = textureLod(_4955, _4919.xyz, _4919.w).xyz;
        _4865 = vec4(_4962.x, _4962.y, _4962.z, _4865.w);
        _4865 *= _4733.w;
        vec3 _4976 = _4733.xyz + (_4865.xyz * _4754);
        _4733 = vec4(_4976.x, _4976.y, _4976.z, _4733.w);
    }
    if ((_4755 & 4u) != 0u)
    {
        vec3 _4988 = _4753.xyz * _4733.w;
        _4753 = vec4(_4988.x, _4988.y, _4988.z, _4753.w);
        vec3 _4998 = (_4733.xyz * _4753.w) + _4753.xyz;
        _4733 = vec4(_4998.x, _4998.y, _4998.z, _4733.w);
    }
    vec3 _5006 = _4733.xyz + _1018._m8.xyz;
    _4733 = vec4(_5006.x, _5006.y, _5006.z, _4733.w);
}


